define LOCALISED_FUNCTION
ifeq "$(COMPONENT_MAKEFILE)/functions.mk" "$$(wildcard $(COMPONENT_MAKEFILE)/functions.mk)"
include $(COMPONENT_MAKEFILE)/functions.mk
else
$$(error FATAL: The inclusive Makefile $(COMPONENT_MAKEFILE)/functions.mk does not exist.)
endif
endef


## IS_ABS (DIR) returns if DIR is absolute or relative
define IS_ABS
$(shell if test "$(shell echo $1|cut -c 1)" = "/"; then echo true; else echo false; fi)
endef

## IS_DIR (DIR) returns if DIR exists
define IS_DIR
$(shell if test -d $1 ; then echo TRUE; else echo FALSE; fi)
endef

## check_unset
define check_unset
  ifneq "$(word 1,$($(1)))" ""
    $$(error MAKE ERROR (COMPDIR=$(COMPDIR)):  $1=$($1) is not empty)
  endif
endef

## check_set
define check_set
  ifeq "$(word 1,$($(1)))" ""
    $$(error MAKE ERROR (COMPDIR=$(COMPDIR)): $1=$$($1) is empty)
  endif
endef

## localised
define localised
LOCALVAR$(COMPDIR)$(1)
endef

## localised_in
define localised_in
LOCALVAR$(shell if test "$(shell if test "$(shell echo $1|cut -c 1)" = "/"; then echo true; else echo false; fi)" = "false"; then echo $(COMPDIR)$(1)$(2); else echo $(1)$(2); fi)
endef

## copy_local
define copy_local
  ifneq ("$(word 1,$($(1)))","")
    $(call localised,$1):=$(strip $($(1)))
    ifneq "$(COMPDIR)" ""
      $(COMPDIR)$1=$$(error using "$$$$($(COMPDIR)$1)" is depricated use "$$$$($$$$(call localised_in,$(COMPDIR),$1))" instead.)$$($(call localised,$1))
    endif
  endif
endef

## append_copy_local
define append_copy_local
  ifneq ("$(word 1,$($(1)))","")
    $(call localised,$1)+=$(strip $($(1)))
    ifneq "$(COMPDIR)" ""
      $(COMPDIR)$1=$$(error using "$$$$($(COMPDIR)$1)" is depricated use "$$$$($$$$(call localised_in,$(COMPDIR),$1))" instead.)$$($(call localised,$1))
    endif
  endif
endef


## move_local
define move_local
  $(eval $(call copy_local,$1))
  $1:=#undefined
endef

## append_move_local
define append_move_local
  $(eval $(call append_copy_local,$1))
  $1:=#undefined
endef

## link_substruct (directory,variablename)
define link_substruct
  $(call localised,$(1)$(2))?=$($(call localised,$(2)))
endef


define IS_SAME_FILE
ifneq "" "$2"
RETURN=$$(shell if test $1 -ef $2; then echo "true"; else echo "false"; fi)
else
RETURN=false
endif
endef

define DEFINE_VAR
$1:=$2 $3 $4 $5 $6 $7 $8 $9 $(10)
endef

define ID
$(shell echo $1 $2 $3 $4 $5 $6 $7 $8 |$(MD5)|cut -f 1 -d ' ') $(eval $(shell echo $1 $2 $3 $4 $5 $6 $7 $8 |$(MD5)|cut -f 1 -d ' ')=$1 $2 $3 $4 $5 $6 $7 $8)
endef

define ASSERTAVAILABLE
ifeq "$$(findstring $1,$$(AVAILABLE))" ""
$$(error Library $(strip $($1)) not available)
endif
endef	

define COMPONENTDIR
$(strip $1)/DIR
endef 

define IMPORTIFAVAILABLE
ifdef $(call COMPONENTDIR,$1)
IMPORT:=$(IMPORT) $($(call COMPONENTDIR,$1))
endif
endef

define AUTOIMPORT
$$(foreach C,$$($(call localised,DEPENDS)),$$(eval $$(call IMPORTIFAVAILABLE,$$C)))
endef

define IMPORTVAR
$(2)+=$($(call localised_in,$($(call COMPONENTDIR,$1))/$2))
endef 

############################
####TEST####################
############################
ifneq "$(findstring bla, hdj dsjka)" ""
$(error IS_IN does not work on this system : returning "$(findstring bla, hdj dsjka)")
endif
ifeq "$(findstring bla, hdj dsjka bla))" ""
$(error IS_IN does not work on this system : returning "$(findstring bla, hdj dsjka bla)")
endif


