#!/bin/bash 
SOLINKAGE=$1
EXELINKAGE=$2
COMPONENT_MAKEFILE=$(dirname $0)
ABSOLUTIFY=$COMPONENT_MAKEFILE/bin/absolutify

rand()
{
   echo "$(dd if=/dev/urandom count=1 2> /dev/null | cksum | cut -f1 -d" " )"
}

locationAlreadyIn()
{
	TEMPFILE1=/tmp/TMP_$(rand)
	TEMPFILE2=/tmp/TMP_$(rand)
	cat $ENVFILE > $TEMPFILE1
	for arg in $*;
	do 
		cat $TEMPFILE1 | grep -e $arg > $TEMPFILE2  
		mv $TEMPFILE2 $TEMPFILE1
	done
	ret=$(cat $TEMPFILE1 | wc -l)
	rm -f $TEMPFILE1 $TEMPFILE2
	if test $ret -eq 0; then false; else true; fi
};

alreadyIncluded()
{
	TEMPFILE1=/tmp/TMP_$(rand)
	TEMPFILE2=/tmp/TMP_$(rand)
	cat $GLOBALENV > $TEMPFILE1
	for arg in $*;
	do 
		cat $TEMPFILE1 | grep -e $arg > $TEMPFILE2  
		mv $TEMPFILE2 $TEMPFILE1
	done
	ret=$(cat $TEMPFILE1 | wc -l)
	rm -f $TEMPFILE1 $TEMPFILE2
	if test $ret -eq 0; then false; else true; fi
};

alreadyLinked()
{
        TEMPFILE1=/tmp/TMP_$(rand)
        cat $ENVFILE > $TEMPFILE1
        cat $ENVFILE | grep -e "$arg ->" > $TEMPFILE1
	TEST=$(cat $TEMPFILE1 | while read a; do
	      if [ "$(echo $a | cut -f 1 -d ' ')" = "$1" ]; 
                then echo TRUE; true ;
              fi;
	    done);
	rm $TEMPFILE1 
	if test "$TEST" = "TRUE";then true; else false; fi;
};

identifyCOMPONENT()
{
  ARG=$(echo $1|sed 's,\.so,\.exe,g'|$ABSOLUTIFY $PWD/)
  if   $ARG -I 2>&1 > /dev/null; 
    then $ARG -I; 
  fi
}

isCTLSO()
{
	if test -n "$(echo $1 | grep \.ctl\.so)"; then 
		true; else false;
	fi
}

isCTLEXE()
{
        if test -n "$(echo $1 | grep \.ctl\.exe)"; then
                true; else false;
        fi
}


generateENVFILE()
{
	for COMP in $*; 
	do
		iface=$(identifyCOMPONENT $COMP);
		for IFACE in $iface;
		do
			if isCTLEXE $COMP; then
				LOCATION="$IFACE -> $(echo $COMP|$ABSOLUTIFY $PWD/) $EXELINKAGE";
			fi
			if isCTLSO $COMP; then
		        	LOCATION="$IFACE -> $(echo $COMP|$ABSOLUTIFY $PWD/) $SOLINKAGE";
			fi
			if ! alreadyLinked "$IFACE"; then 
				echo "$LOCATION" >> $ENVFILE;
			fi
		done;
	done;
}

#MAIN
ENVFILE=.ctl.env
GLOBALENV=ctl.env
ENVFILE=$COMPDIR$ENVFILE
GLOBALENV=$COMPDIR$GLOBALENV

if test $# -ne 2; then echo $0 needs @arg1=SOLINKAGE @arg2=EXELINKAGE;fi
touch $ENVFILE;
touch $GLOBALENV;
generateENVFILE $COMPONENT
if ! alreadyIncluded $ENVFILE; then echo include $ENVFILE >> $GLOBALENV; fi 
