#THE ORIGINAL FILE WAS WRITTEN BY 
#DOMINIK JUERGENS (d.juergens@tu-bs.de)
#Institut of Scientific Computing
#TU Braunschweig 	
#
#COPYRIGHT: IT IS TOTALLY FREE FOR ANY USE AND CHANGE, BUT 
#THIS HEADER MUST NOT BE CHANGED!
#ADDITIONAL TEXT MAY BE ADDED BELOW.

#SUCCESS REPORT
ifeq "$(DEBUG)" "TRUE"
REPORTSUCCESS=echo SUCCESSFULLY BUILT $@: \"$${COMMAND}\"
else
REPORTSUCCESS=true
endif

#ALL RULES DEPEND ON ALLDEP
ALLDEP+=$(COMPDIR)config.mk 

ifeq "$(FORCE)" "TRUE"
  ALLDEP+=force_rebuild
endif

#CTL IDL Converter
%.ci: %.idl
	@echo "Generating CI-File -- $(IDL2CTL): $< -> $@"
	@$(IDL2CTL) $< > /dev/null

#CTL-EXE-RULE
$($(call localised,BIN))%.ctl.exe: LIBFLAGS=$(strip $(LDLIBS) $($(call localised,LDCOMPONENTLIBS)) $($(call localised,LDLIBS)))
$($(call localised,BIN))%.ctl.exe: COMPILEFLAGS=$(strip $($(call localised,INCFLAGS)) $($(call localised,CPPFLAGS)) $($(call localised,CXXFLAGS)) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS)) 

$($(call localised,BIN))%.ctl.exe: COMPDIR:=$(COMPDIR)
$($(call localised,BIN))%.ctl.exe: $($(call localised,OBJDIR))$($(call localised,CONNECTSOURCEPREFIX))%.o $($(call localised,DEP))$($(call localised,CONNECTSOURCEPREFIX))%.d $($(call localised,LOCALLIBS)) $($(call localised,COMPONENTLIBS)) $($(call localised,CTLLIB)) $(ALLDEP)
ifeq "$(DEBUG)" "TRUE"
	@echo TARGET $@ depends on $?
endif
	@echo "Linking Executable CTL-Component $@ "
ifeq "$(DEBUG)" "TRUE"
	@echo $($(call localised,CXX)) $(COMPILEFLAGS) $< $(LIBFLAGS) -o $@;
endif
	@COMMAND="$($(call localised,CXX)) $(COMPILEFLAGS) $< $(LIBFLAGS) -o $@";\
	$${COMMAND}&&$(REPORTSUCCESS)||(echo "->$${COMMAND}<- FAILED";exit -1)

#CTL-SO-RULE
$($(call localised,BIN))%.ctl.so: LIBFLAGS=$(strip $(LDLIBS) $($(call localised,LDCOMPONENTLIBS)) $($(call localised,LDLIBS)))
$($(call localised,BIN))%.ctl.so: COMPILEFLAGS=$(strip $($(call localised,INCFLAGS)) $($(call localised,CPPFLAGS)) $($(call localised,CXXFLAGS)) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS)) 

$($(call localised,BIN))%.ctl.so: COMPDIR:=$(COMPDIR)
$($(call localised,BIN))%.ctl.so: $($(call localised,OBJDIR))$($(call localised,CONNECTSOURCEPREFIX))%.o $($(call localised,DEP))$($(call localised,CONNECTSOURCEPREFIX))%.d $($(call localised,LOCALLIBS)) $($(call localised,COMPONENTLIBS)) $($(call localised,CTLLIB))
ifeq "$(DEBUG)" "TRUE"
	@echo TARGET $@ depends on $?
endif
	@echo "Linking Shared Object CTL-Component $@ "
ifeq "$(DEBUG)" "TRUE"
	@echo $($(call localised,CXX)) $(SHARED) $(COMPILEFLAGS) $< $(LIBFLAGS) -o $@;
endif
	@COMMAND="$($(call localised,CXX)) $(SHARED) $(COMPILEFLAGS) $< $(LIBFLAGS) -o $@";\
	$${COMMAND}&&$(REPORTSUCCESS)||(echo "->$${COMMAND}<- FAILED";exit -1)

#LIBRARY-RULE
$($(call localised,OBJDIR))lib%.a : COMPDIR:=$(COMPDIR)
$($(call localised,OBJDIR))lib%.a : 
	@if test "" = "$?"; then \
		echo "@echo Warning: Properly fatal : dependencies of $@";\
		echo "are not defined properly therefore the library is not created";\
	fi
	@echo "Building Library $@ "	
ifeq "$(DEBUG)" "TRUE"
	@echo $(AR) sr $@ $?
endif
	@R=$${RANDOM};\
	LOGFILE=LOG$${R};\
	COMMAND="$(AR) sr $@ $?";\
	$${COMMAND} 1>&2 2> $${LOGFILE} && ($(REPORTSUCCESS); $(RM) $${LOGFILE})\
	|| ( echo "->$${COMMAND}<- FAILED:"&&$(CAT) $${LOGFILE};$(RM) $${LOGFILE}; exit -1 ); 

$($(call localised,BIN))lib%.a : 
	@if test "" = "$?"; then \
		echo "@echo Warning: Properly fatal : dependencies of $@";\
		echo "are not defined properly therefore the library is not created";\
	fi
	@echo "Building Library $@ "	
ifeq "$(DEBUG)" "TRUE"
	@echo $(AR) sr $@ $?
endif
	@R=$${RANDOM};\
	LOGFILE=LOG$${R};\
	COMMAND="$(AR) sr $@ $?";\
	$${COMMAND} 1>&2 2> $${LOGFILE} && ($(REPORTSUCCESS); $(RM) $${LOGFILE})\
	|| ( echo "->$${COMMAND}<- FAILED:"&&$(CAT) $${LOGFILE};$(RM) $${LOGFILE}; exit -1 ); 


#OBJECT-RULE
.PRECIOUS: $($(call localised,OBJDIR))%.o 
##############################################################################
## OBJECT RULE                                                               #
##############################################################################
$($(call localised,OBJDIR))%.o: COMPDIR:=$(COMPDIR)

define OBJECTRULE
$($(call localised,OBJDIR))%.o:$(1)%.$($(call localised,FSUFFIX)) $(ALLDEP) $($(call localised,DEP))%.d 
	@echo "Building Object $$@ "	
ifeq "$(DEBUG)" "TRUE"
	@echo $$(FC) -c $($(call localised,AUTOINCLUDE)) $$(INCFLAGS) $$($$(call localised,INCFLAGS)) $$(FFLAGS) $$($$(call localised,FFLAGS)) $$< -o $$@
endif
	@R=$$$${RANDOM};\
       	if [ -n $$(FC) ]; then FC=$$($$(call localised,FC)); fi;\
	LOGFILE=LOG$$$${R};\
	COMMAND="$$$${FC} -c $($(call localised,AUTOINCLUDE)) $$(INCFLAGS) $$($$(call localised,INCFLAGS)) $$(FFLAGS) $$($$(call localised,FFLAGS)) $$< -o $$@";\
	$$$${COMMAND} > $$$${LOGFILE} && ($$(REPORTSUCCESS); $(RM) $$$${LOGFILE})\
	|| (echo "->$$$${COMMAND}<- FAILED:" &&$(CAT) $$$${LOGFILE};$(RM) $$$${LOGFILE};exit -1);


$($(call localised,OBJDIR))%.o:$(1)%.$($(call localised,CCSUFFIX)) $(ALLDEP) $($(call localised,DEP))%.d
	@echo "Building Object $$@ "
ifeq "$(DEBUG)" "TRUE"
	@echo $$(CXX) -c -DCOMPDIR=\"$($(call localised,ABS_COMPDIR))\" $($(call localised,AUTOINCLUDE)) $$(INCFLAGS) $$($$(call localised,INCFLAGS)) $$(CPPFLAGS) $$(CXXFLAGS) $$($$(call localised,CPPFLAGS)) $$($$(call localised,CXXFLAGS)) $$< -o $$@
endif
	@R=$$$${RANDOM};\
	if [ -n $$(CXX) ]; then CXX=$$($$(call localised,CXX)); fi;\
        LOGFILE=LOG$$$${R};\
	COMMAND="$$$${CXX} -c -DCOMPDIR=\"$($(call localised,ABS_COMPDIR))\" $($(call localised,AUTOINCLUDE)) $$(INCFLAGS) $$($$(call localised,INCFLAGS)) $$(CPPFLAGS) $$(CXXFLAGS) $$($$(call localised,CPPFLAGS)) $$($$(call localised,CXXFLAGS)) $$< -o $$@";\
	$$$${COMMAND} > $$$${LOGFILE} && ($$(REPORTSUCCESS); $(RM) $$$${LOGFILE})\
        || (echo "->$$$${COMMAND}<- FAILED:" &&$(CAT) $$$${LOGFILE};$(RM) $$$${LOGFILE};exit -1);

$($(call localised,OBJDIR))%.o:$(1)%.$($(call localised,CSUFFIX)) $(ALLDEP) $($(call localised,DEP))%.d
	@echo "Building Object $$@ "
ifeq "$(DEBUG)" "TRUE"
	@echo $$(CC) -c -DCOMPDIR=\"$($(call localised,ABS_COMPDIR))\" $($(call localised,AUTOINCLUDE)) $$(INCFLAGS) $$($$(call localised,INCFLAGS)) $$(CPPFLAGS) $$(CFLAGS) $$($$(call localised,CFLAGS)) $$($$(call localised,CPPFLAGS)) $$< -o $$@
endif
	@R=$$$${RANDOM};\
	if [ -n $$(CC) ]; then CC=$$($$(call localised,CC)); fi;\
        LOGFILE=LOG$$$${R};\
	COMMAND="$$$${CC} -c -DCOMPDIR=\"$($(call localised,ABS_COMPDIR))\" $($(call localised,AUTOINCLUDE)) $$(INCFLAGS) $$($$(call localised,INCFLAGS)) $$(CPPFLAGS) $$(CFLAGS) $$($$(call localised,CFLAGS)) $$($$(call localised,CPPFLAGS)) $$< -o $$@";\
	$$$${COMMAND} > $$$${LOGFILE} && ($$(REPORTSUCCESS); $(RM) $$$${LOGFILE})\
        || (echo "->$$$${COMMAND}<- FAILED:" &&$(CAT) $$$${LOGFILE};$(RM) $$$${LOGFILE};exit -1);

$($(call localised,OBJDIR))%.o:$(1)%.$($(call localised,PSUFFIX)) $(ALLDEP) $($(call localised,DEP))%.d
	@echo "Building Object $$@ "
ifeq "$(DEBUG)" "TRUE"
	@echo $$(PC) -c $$(PFLAGS) $$($$(call localised,PFLAGS)) $$< -o $$@
endif
	@R=$$$${RANDOM};\
	if [ -n $$(PC) ]; then PC=$$($$(call localised,PC)); fi;\
        LOGFILE=LOG$$$${R};\
        COMMAND="$$$${PC} -c $$(PFLAGS) $$($$(call localised,PFLAGS)) $$< -o $$@";\
        $$$${COMMAND} > $$$${LOGFILE} && ($$(REPORTSUCCESS); $(RM) $$$${LOGFILE})\
        || (echo "->$$$${COMMAND}<- FAILED:" &&$(CAT) $$$${LOGFILE};$(RM) $$$${LOGFILE};exit -1);
endef

$(eval $(call OBJECTRULE,$($(call localised,SRC))))
$(eval $(call OBJECTRULE,$($(call localised,TEST))))
$(foreach SRCDIR,$($(call localised,SOURCEDIR)),$(eval $(call OBJECTRULE,$(SRCDIR))))
##############################################################################
## END OBJECT RULE                                                           #
##############################################################################

##############################################################################
## EXECUTE PREPROC RULE                                                      #
##############################################################################
define preproc_var
$(1)%.cxx_preproc : COMPDIR:=$(COMPDIR)
endef

$(call preproc_var,$(COMPDIR)include/) 
$(call preproc_var,$(COMPDIR)include/ci/)
$(call preproc_var,$($(call localised,SRC)))
$(call preproc_var,$($(call localised,TEST)))
$(foreach SRCDIR,$($(call localised,SOURCEDIR)),$(call preproc_var,$(SRCDIR)))

ifndef cxx_preproc_rule
cxx_preproc_rule=#DEFINED
%.cxx_preproc: %
	if [ -n $(CXX) ]; then CXX=$($(call localised,CXX)); fi; ${CXX} -E -DCOMPDIR=\"$($(call localised,ABS_COMPDIR))\" $($(call localised,AUTOINCLUDE)) $(INCFLAGS) $($(call localised,INCFLAGS)) $($(call localised,CPPFLAGS)) $($(call localised,CXXFLAGS)) $< -o $@
endif

##############################################################################
## EXEC RULE                                                                 #
##############################################################################
$($(call localised,BIN))%: LIBFLAGS=$(strip $(LDLIBS) $($(call localised,LDCOMPONENTLIBS)) $($(call localised,LDLIBS)))
$($(call localised,BIN))%: COMPILEFLAGS=#JUST LINKING 
$($(call localised,BIN))%: COMPDIR:=$(COMPDIR)
define EXECUTABLERULE
$($(call localised,BIN))%: $($(call localised,OBJDIR))%.o $($(call localised,OBJDIR))%CTLBind.o $(ALLDEP) $($(call localised,DEP))%.d $($(call localised,LOCALLIBS)) $(1)%.$(CCSUFFIX)
	@echo "Building Executable $$@ "
	@COMMAND="$$($$(call localised,CXX)) $$(COMPILEFLAGS) $$< $$($(call localised,OBJDIR))$$(notdir $$*)CTLBind.o -o $$@ $$(LIBFLAGS)";\
	$$$${COMMAND}&&$$(REPORTSUCCESS)\
	||(echo "->$$$${COMMAND}<- FAILED";exit -1)

$($(call localised,BIN))%: $($(call localised,OBJDIR))%.o $($(call localised,OBJDIR))%CTLBind.o $(ALLDEP) $($(call localised,DEP))%.d $($(call localised,LOCALLIBS)) $(1)%.$(FSUFFIX)
	@echo "Building Executable $$@ "
	@COMMAND="$$($$(call localised,FC)) $$(COMPILEFLAGS) $$< $$($(call localised,OBJDIR))$$(notdir $$*)CTLBind.o -o $$@ $$(LIBFLAGS)";\
        $$$${COMMAND}&&$$(REPORTSUCCESS)\
        ||(echo "->$$$${COMMAND}<- FAILED";exit -1)

$($(call localised,BIN))%: $($(call localised,OBJDIR))%.o $($(call localised,OBJDIR))%CTLBind.o $(ALLDEP) $($(call localised,DEP))%.d $($(call localised,LOCALLIBS)) $(1)%.$(CSUFFIX)
	@echo "Building Executable $$@ "
	@COMMAND="$$($$(call localised,CC)) $$(COMPILEFLAGS) $$< $$($(call localised,OBJDIR))$$(notdir $$*)CTLBind.o -o $$@ $$(LIBFLAGS)";\
        $$$${COMMAND}&&$$(REPORTSUCCESS)\
        ||(echo "->$$$${COMMAND}<- FAILED";exit -1)

$($(call localised,BIN))%TEST: $($(call localised,OBJDIR))%Test.o $($(call localised,OBJDIR))%CTLBind.o $(ALLDEP) $($(call localised,DEP))%Test.d $($(call localised,LOCALLIBS)) $(1)%Test.$(CCSUFFIX)
	@echo "Building Executable $$@ "
	@COMMAND="$$($$(call localised,CXX)) $$(COMPILEFLAGS) $$< $$($(call localised,OBJDIR))$$(notdir $$*)CTLBind.o -o $$@ $$(LIBFLAGS)";\
        $$$${COMMAND}&&$$(REPORTSUCCESS)\
        ||(echo "->$$$${COMMAND}<- FAILED";exit -1)

$($(call localised,BIN))%TEST: $($(call localised,OBJDIR))%Test.o $($(call localised,OBJDIR))%CTLBind.o $(ALLDEP) $($(call localised,DEP))%Test.d $($(call localised,LOCALLIBS)) $(1)%Test.$(FSUFFIX)
	@echo "Building Executable $$@ "
	@COMMAND="$$($$(call localised,FC)) $$(COMPILEFLAGS) $$< $$($(call localised,OBJDIR))$$(notdir $$*)CTLBind.o -o $$@ $$(LIBFLAGS)";\
        $$$${COMMAND}&&$$(REPORTSUCCESS)\
        ||(echo "->$$$${COMMAND}<- FAILED";exit -1)

$($(call localised,BIN))%TEST: $($(call localised,OBJDIR))%Test.o $($(call localised,OBJDIR))%CTLBind.o $(ALLDEP) $($(call localised,DEP))%Test.d $($(call localised,LOCALLIBS)) $(1)%Test.$(CSUFFIX)
	@echo "Building Executable $$@ "
	@COMMAND="$$($$(call localised,CC)) $$(COMPILEFLAGS) $$< $$($(call localised,OBJDIR))$$(notdir $$*)CTLBind.o -o $$@ $$(LIBFLAGS)";\
        $$$${COMMAND}&&$$(REPORTSUCCESS)\
        ||(echo "->$$$${COMMAND}<- FAILED";exit -1)

endef
$(eval $(call EXECUTABLERULE,$($(call localised,SRC))))
$(eval $(call EXECUTABLERULE,$($(call localised,TEST))))
$(foreach SRCDIR,$($(call localised,SOURCEDIR)),$(eval $(call EXECUTABLERULE,$(SRCDIR))))

$($(call localised,BIN))%TEST: $($(call localised,OBJDIR))%Test.o $(ALLDEP) $($(call localised,DEP))%Test.d $($(call localised,LOCALLIBS)) 	
	@echo "Building Executable $@ "	
	@COMMAND="$($(call localised,CXX)) $(COMPILEFLAGS) $< -o $@ $(LIBFLAGS)";\
	$${COMMAND}&&$(REPORTSUCCESS)\
	||(echo "->$${COMMAND}<- FAILED";exit -1)

$($(call localised,BIN))%: $($(call localised,OBJDIR))%.o $(ALLDEP) $($(call localised,DEP))%.d $($(call localised,LOCALLIBS)) 	
	@echo "Building Executable $@ "	
	@COMMAND="$($(call localised,CXX)) $(COMPILEFLAGS) $< -o $@ $(LIBFLAGS)";\
	$${COMMAND}&&$(REPORTSUCCESS)\
	||(echo "->$${COMMAND}<- FAILED";exit -1)
##############################################################################
## END EXEC RULE                                                             #
##############################################################################

##############################################################################
# EVALUATION OF ATTRIBUTES                                                   #
##############################################################################
$(BIN)%:$($(BIN)%.DEPEND)

##############################################################################
## METHODS OF EXECUTABLES                                                    #
##############################################################################
$($(call localised,BIN))%.output: COMPDIR:=$(COMPDIR)
$($(call localised,BIN))%.output: $($(call localised,BIN))% $(GEN_RES_FILE)
ifeq "$(GDB)" "TRUE"
	@echo "Executing : ./$<";$(PRE_EXEC)$(PRE_TEST)./$< $(TESTARGS) >$@\
	&&echo "$< RAN SUCCESSFULLY ..."||\
	( echo "$< FAILED ... STARTING DEBUGGER"; $(PRE_EXEC)$(PRE_TEST)$(GDB_EXEC) ./$<; $(RM) $@ ;exit -1 )
else
	@echo "Executing : ./$< $(TESTARGS)";\
	if test -f $<.input; then \
		$(PRE_EXEC)$(PRE_TEST)./$< $(TESTARGS) < $<.input > $@; \
	else \
		$(PRE_EXEC)$(PRE_TEST)./$< $(TESTARGS) > $@;\
	fi && echo "$< RAN SUCCESSFULLY ..."&& $(RM) $@.error ||\
	( echo "$< FAILED WITH OUTPUT:"; $(CAT) $@; $(MV) $@ $@.error; echo "$< Aborted due to error above..."; exit -1 )
endif

$($(call localised,BIN))%.rerun: COMPDIR:=$(COMPDIR)
$($(call localised,BIN))%.rerun: $($(call localised,BIN))% $(GEN_RES_FILE)
ifeq "$(GDB)" "TRUE"
	@echo "Executing Test : ./$<";$(PRE_TEST)./$< $(TESTARGS)\
	&&echo "TEST $< RAN SUCCESSFULLY ..."||\
	( echo "TEST $< FAILED ... STARTING DEBUGGER"; $(PRE_TEST)$(GDB_EXEC) ./$<; exit -1 )
else
	@echo "Executing Test : ./$< $(TESTARGS)";\
	if test -f $<.input; then \
		$(PRE_TEST)./$< $(TESTARGS) < $<.input;\
	else \
		$(PRE_TEST)./$< $(TESTARGS); \
	fi && echo "TEST $< RAN SUCCESSFULLY ..." ||  ( echo "TEST $< Aborted due to error above..."; exit -1 )
endif
##############################################################################
## END METHODS OF EXECUTABLES                                                #
##############################################################################

##############################################################################
## AUTO-DEPENDENCY-RULE                                                      #
##############################################################################
MKOBJDEPCOMMAND=$(SET) -e; $($(call localised,CXX)) -MM $($(call localised,AUTOINCLUDE)) $($(call localised,CPPFLAGS)) $($(call localised,CXXFLAGS)) $(INCFLAGS) $($(call localised,INCFLAGS)) $< 2>/dev/null \
       |$(SED) 's/\($*\)\.o[ :]*/$(subst .,\.,$(subst /,\/,$($(call localised,OBJDIR))))\1.o $(subst .,\.,$(subst /,\/,$@)) : /g'\
       |$(TOOLDIR)absolutify $(ABS_COMPDIR)|$(UNIQ) > $@; [ -s $@ ] || $(RM) $@;

MKCOBJDEPCOMMAND=$(SET) -e; $($(call localised,CC)) -MM $($(call localised,AUTOINCLUDE)) $($(call localised,CPPFLAGS)) $($(call localised,CFLAGS)) $($(call localised,CCFLAGS)) $(INCFLAGS) $($(call localised,INCFLAGS)) $($(call localised,ABS_COMPDIR))$< 2>/dev/null \
       |$(SED) 's/\($*\)\.o[ :]*/$(subst .,\.,$(subst /,\/,$($(call localised,OBJDIR))))\1.o $(subst .,\.,$(subst /,\/,$@)) : /g'\
       |$(TOOLDIR)absolutify $(ABS_COMPDIR)|$(UNIQ) > $@; [ -s $@ ] || $(RM) $@


MKFOBJDEPCOMMAND=touch $@#No standardised way here ...

define DEPENDRULE
$($(call localised,DEP))%.d: force
$($(call localised,DEP))%.d: COMPDIR:=$(COMPDIR)
$($(call localised,DEP))%.d: $(1)%.$($(call localised,CCSUFFIX))
	@echo Calculating dependencies of $$<
ifeq "$(DEBUG)" "TRUE"
	$$(MKOBJDEPCOMMAND)
	cat $$@|$(TOOLDIR)localise_dep $(ABS_COMPDIR)>$$(subst .d,.ld,$$@)
else
	@$$(MKOBJDEPCOMMAND)
	@cat $$@|$(TOOLDIR)localise_dep $(ABS_COMPDIR)>$$(subst .d,.ld,$$@)
endif

$($(call localised,DEP))%.d: $(1)%.$($(call localised,CSUFFIX))
	@echo Calculating dependencies of $$<
ifeq "$(DEBUG)" "TRUE"
	$$(MKCOBJDEPCOMMAND)
	cat $$@|$(TOOLDIR)localise_dep $(ABS_COMPDIR)>$$(subst .d,.ld,$$@)
else
	@$$(MKCOBJDEPCOMMAND)
	@cat $$@|$(TOOLDIR)localise_dep $(ABS_COMPDIR)>$$(subst .d,.ld,$$@)
endif

$($(call localised,DEP))%.d: $(1)%.$($(call localised,FSUFFIX))
	@echo Calculating dependencies of $$<
ifeq "$(DEBUG)" "TRUE"
	$$(MKFOBJDEPCOMMAND)
	cat $$@|$(TOOLDIR)localise_dep $(ABS_COMPDIR)>$$(subst .d,.ld,$$@)
else
	@$$(MKFOBJDEPCOMMAND)
	@cat $$@|$(TOOLDIR)localise_dep $(ABS_COMPDIR)>$$(subst .d,.ld,$$@)
endif

$($(call localised,DEP))%.d: $(1)%.$($(call localised,PSUFFIX))
	@echo Calculating dependencies of $$<
ifeq "$(DEBUG)" "TRUE"
	$$(MKFOBJDEPCOMMAND)
	cat $$@|$(TOOLDIR)localise_dep $$(ABS_COMPDIR>$$(subst .d,.ld,$$@)
else
	@$$(MKFOBJDEPCOMMAND)
	@cat $$@|$(TOOLDIR)localise_dep $$(ABS_COMPDIR>$$(subst .d,.ld,$$@)
endif
endef

$(eval $(call DEPENDRULE,$($(call localised,TEST))))
$(eval $(call DEPENDRULE,$($(call localised,SRC))))
$(foreach SRCDIR,$($(call localised,SOURCEDIR)),$(eval $(call DEPENDRULE,$(SRCDIR))))

MKTESTDEPCOMMAND=$(SET) -e; $($(call localised,CXX)) -MM $($(call localised,CPPFLAGS)) $($(call localised,CXXFLAGS)) $($(call localised,AUTOINCLUDE)) $(INCFLAGS) $($(call localised,INCFLAGS)) $< 2>/dev/null\
       |$(SED) 's/\($*Test\)\.o[ :]*/$(subst .,\.,$(subst /,\/,$($(call localised,BIN))$(notdir $*TEST))) $(subst .,\.,$(subst /,\/,$@)) : /g'\
       |$(TOOLDIR)absolutify $(ABS_COMPDIR)|$(UNIQ) > $@; [ -s $@ ] || $(RM) $@

$($(call localised,DEP))%Test.d: COMPDIR:=$(COMPDIR)
$($(call localised,DEP))%Test.d: $($(call localised,TEST))%Test.$($(call localised,CCSUFFIX))
ifeq "$(DEBUG)" "TRUE"
	$(MKTESTDEPCOMMAND)
	cat $@|$(TOOLDIR)localise_dep $(ABS_COMPDIR>$(subst .d,.ld,$@)
else	
	@$(MKTESTDEPCOMMAND)
	@cat $@|$(TOOLDIR)localise_dep $(ABS_COMPDIR)>$(subst .d,.ld,$@)
endif
$(error)
