##################################################################
# PYTHON/SWIG STUFF                                              #
##################################################################

PYTHONMODULELIB=$(subst $($(call localised,INCDIR)),$($(call localised,BIN))_,$(subst .i,.so,$(wildcard $($(call localised,INCDIR))*.i)))
PYTHONWRAPPER=$(subst $($(call localised,INCDIR)),$($(call localised,SRC)),$(subst .i,_wrap.cxx,$(wildcard $($(call localised,INCDIR))*.i)))
PYTHONMODULE=$(subst $($(call localised,INCDIR)),$($(call localised,BIN)),$(subst .i,.py,$(wildcard $($(call localised,INCDIR))*.i)))
PYTHONOBJECT=$(subst $($(call localised,SRC)),$($(call localised,OBJDIR)),$(subst _wrap.cxx,_wrap.o,$(PYTHONWRAPPER)))

$($(call localised,BIN))_%.so: LDLIBS+=$(PYTHONLIBS)
$($(call localised,BIN))_%.so: COMPDIR:=$(COMPDIR)
ifdef CTL_DIR
$($(call localised,BIN))_%.so: $(CTLLIB) 
endif
$($(call localised,BIN))_%.so: COMPDIR:=$(COMPDIR)
$($(call localised,BIN))_%.so: $($(call localised,OBJDIR))%_wrap.o
	$($(call localised,CXX)) --shared $< $($(call localised,LDLIBS)) $(LDLIBS) -o $@

$($(call localised,SRC))%_wrap.cxx: INPATH:=$($(call localised,INCDIR))
$($(call localised,SRC))%_wrap.cxx: SRPATH:=$($(call localised,SRC))
$($(call localised,SRC))%_wrap.cxx: BIPATH:=$($(call localised,BIN))

$($(call localised,BIN))%.py $($(call localised,SRC))%_wrap.cxx : COMPDIR:=$(COMPDIR)
$($(call localised,BIN))%.py $($(call localised,SRC))%_wrap.cxx : $($(call localised,INCDIR))%.i
	@echo Creating Python Wrapper $(BIPATH)$*.py $(SRPATH)$*_wrap.cxx using SWIG
ifdef DEBUG
	@echo $(SWIG) -python -c++ $($(BIPATH)INCLUDE) $(ALL_INCLUDE) -DSWIGPYTHON $<;
endif
	@R=$${RANDOM};\
        LOGFILE=LOG$${R};\
        COMMAND="$(SWIG) -python -c++ $($(call localised,INCFLAGS)) $(ALL_INCLUDE) $<";\
        $${COMMAND} > $${LOGFILE} && ($(REPORTSUCCESS); $(RM) $${LOGFILE})\
        || (echo "->$${COMMAND}<- FAILED:" &&$(CAT) $${LOGFILE};$(RM) $${LOGFILE};exit -1);
	@$(MV) $(INPATH)$*.py $(BIPATH)$*.py
	@$(MV) $(INPATH)$*_wrap.cxx $(SRPATH) 

$($(call localised,OBJDIR))%.o: COMPDIR:=$(COMPDIR)
$($(call localised,OBJDIR))%.o:$($(call localised,SRC))%.cxx 
	@echo "Building Swig Wrapper $@ "
ifdef DEBUG
	@echo $($(call localised,/CXX)) -c $(INCFLAGS) $($(call localised,INCFLAGS)) $(CPPFLAGS) $(CXXFLAGS) $($(call localised,CPPFLAGS)) $($(call localised,CXXFLAGS)) $($(call localised,CCFLAGS)) $< -o $@;
endif
	@R=$${RANDOM};\
        LOGFILE=LOG$${R};\
	COMMAND="$($(call localised,CXX)) -c $(INCFLAGS) $($(call localised,INCFLAGS)) $(CPPFLAGS) $(CXXFLAGS) $($(call localised,CPPFLAGS)) $($(call localised,CXXFLAGS)) $($(call localised,CCFLAGS)) $< -o $@";\
	$${COMMAND} > $${LOGFILE} && ($(REPORTSUCCESS); $(RM) $${LOGFILE})\
        || (echo "->$${COMMAND}<- FAILED:" &&$(CAT) $${LOGFILE};$(RM) $${LOGFILE};exit -1);

PYTHONCLEAN:=$(PYTHONCLEAN) $(wildcard $(PYTHONMODULELIB) $(PYTHONWRAPPER) $(PYTHONMODULE) $(PYTHONOBJECT))
CLEANALL:=$(CLEANALL) $(PYTHONCLEAN)

python: $(PYTHONMODULELIB)

PYTHONMODULELIB:=#CLEAR
PYTHONWRAPPER:=#CLEAR
PYTHONMODULE:=#CLEAR
PYTHONOBJECT:=#CLEAR

