#CREATING COMPONENT STACK
$(eval $(call LOCALISED_FUNCTION))
include $(COMPONENT_MAKEFILE)/pre_config.mk
-include $(COMPDIR)config.mk#//IMPORT LISTS...


ifdef REPOSITORY
$(eval $(call REPOSITORY))
endif
$(eval $(call append_move_local,DEPENDS))
$(eval $(call AUTOIMPORT))

$(call localised,INCLUDEDIR):=component
include $(COMPONENT_MAKEFILE)/include_make/create_stack.mk
$(call localised,INCLUDEDIR):=library
include $(COMPONENT_MAKEFILE)/include_make/create_stack.mk
include $(COMPONENT_MAKEFILE)/path.mk
include $(COMPONENT_MAKEFILE)/include_make/autoconfig.mk

ifneq "$(subst ./,,$(COMPDIR)config.ac)" "$(subst ./,,$(wildcard $(COMPDIR)config.ac))"
  ifeq  "$(subst ./,,$(COMPDIR)config.mk)" "$(subst ./,,$(wildcard $(COMPDIR)config.mk))"
    ifneq "$(MAKECMDGOALS)" "confclean"
      include $(COMPDIR)config.mk
    endif
  else
    $(error FATAL: CONFIGURATION $(COMPDIR)config.mk DOES NOT EXIST. Please use $(COMPONENT_MAKEFILE)/config.mk_template to create it.)
  endif #config.mk
else  #config.ac
  AUTORECONF?=$(shell if which autoreconf>/dev/null; then echo TRUE; else echo FALSE;fi)
  ifndef NOAUTOTOOLS
    ifeq "$(AUTORECONF)" "TRUE"
      CONFIGFILES:=$(CONFIGFILES) $(wildcard $(COMPDIR)config.mk)
      ifneq "$(MAKECMDGOALS)" "confclean"
        -include $(COMPDIR)config.mk
      endif # NOCLEAN
    else #AUTORECONF
      $(error AUTOTOOLS: autoreconf not present on this system)
    endif #AUTORECONF
  else
    ifeq  "$(subst ./,,$(COMPDIR)config.mk)" "$(subst ./,,$(wildcard $(COMPDIR)config.mk))"
      include $(COMPDIR)config.mk
    else
      $(error FATAL: NOAUTOTOOLS is defined, but there is no CONFIGURATION $(COMPDIR)config.mk)
    endif #config.mk
  endif #NOAUTOTOOLS
endif #config.ac
INCLUSIONS:=#ALLREADY INCLUDED ONCE; see line 3
USESDIR:=#ALLREADY INCLUDED ONCE; see line 3
IMPORT:=#ALLREADY INCLUDED ONCE; see line 3

ifneq "$(wildcard $(COMPDIR)struct.mk)" ""
include $(COMPDIR)struct.mk
endif

include $(COMPONENT_MAKEFILE)/include_make/default_targets.mk

ifeq "$(subst ./,,$(COMPDIR)deps.mk)" "$(subst ./,,$(wildcard $(COMPDIR)deps.mk))"
include $(COMPDIR)deps.mk
else
$(error FATAL: DEPENDENCY FILE $(COMPDIR)deps.mk DOES NOT EXIST. Please use $(COMPONENT_MAKEFILE)/deps.mk_template to create it.)
endif


ifneq "$(INCLUDETARGETS)" "false"
ifeq "$(COMPDIR)" ""
TARGETS+=$($(strip $(call localised,TARGETS)))
endif
endif

include $(COMPONENT_MAKEFILE)/include_make/autodepend.mk
include $(COMPONENT_MAKEFILE)/post_config.mk
GEN_RES_FILE:=$(GEN_RES_FILE) $(COMPDIR).ctl.env $(BIN)ctl.env
include $(COMPONENT_MAKEFILE)/include_make/rules.mk
include $(COMPONENT_MAKEFILE)/include_make/swig_python_rules.mk

CLEANALL:=$(wildcard $(COMPDIR)LOG* $(COMPDIR)core* $(TESTOUTPUT) $(CLEANALL) ) 
ifneq "$(INCLUDETARGETS)" "false" 
CLEANALL=+$(wildcard $($(call localised,OBJDIR))*.o $($(call localised,OBJDIR))*.a $($(call localised,DEP))*.d $(COMPDIR).ctl.env)
endif
########################################################
## CTL.ENV #############################################
########################################################
$(COMPDIR).ctl.env: COMPONENTS:=$($(call localised,LOCALSERVICETARGET))
$(COMPDIR).ctl.env: IMPORTS:=$($(call localised,IMPORTED))
$(COMPDIR).ctl.env: $($(call localised,LOCALSERVICETARGET))
	@if [ -n "$(wildcard $(@D)/component/*)" ];\
	 then echo "Including SUBDIRS=$(wildcard $(@D)/component/*) to environment"; fi
	@export COMPDIR="$(@D)/";\
	 export COMPONENT="$(COMPONENTS)";\
	 $(SHELL) $(COMPONENT_MAKEFILE)/generate_env.sh "$(SOLINKAGE)" "$(EXELINKAGE)";
	@export COMPDIR="$(@D)/";\
	 export COMPONENT="$(wildcard $(@D)/component/*)";\
         $(SHELL) $(COMPONENT_MAKEFILE)/include_subdirs_env.sh;
	@export COMPDIR="$(@D)/";\
	 export COMPONENT="$(IMPORTS)";\
         $(SHELL) $(COMPONENT_MAKEFILE)/include_subdirs_env.sh -a;

$(BIN)ctl.env:$(COMPDIR).ctl.env
	@echo include ../.ctl.env>$@

ctl.env:  .ctl.env
all:      $(GEN_RES_FILE)

########################################################
## RETEST  #############################################
########################################################
.PHONY:PRETEST
PRETEST:  $(GEN_RES_FILE)

########################################################
## PRINTVAR ############################################
########################################################
.PHONY: $(COMPDIR)PRINTVAR_% PRINTVARS

.PRINTVAR_%: COMPDIR:=
$(COMPDIR)PRINTVAR_%: COMPDIR:=$(COMPDIR)
$(COMPDIR)PRINTVAR_%:
	if [ -n "$(shell echo $($(call localised,$*)) | sed 's/[\t ]/jd/g')" ]; then echo $(call localised,$*)=\"$($(call localised,$*))\"; fi

$(call localised,TARGETLIST): $(call localised,PRINTVAR_SERVICETARGET) $(call localised,PRINTVAR_TESTTARGET)

########################################################
## LOCALTEST/RETEST  ###################################
########################################################
ifneq "$(COMPDIR)" ""
$(COMPDIR)TEST: COMPONENTNAME:=$($(call localised,COMPONENTNAME))
$(COMPDIR)TEST: $($(call localised,LOCALTESTOUTPUT))  $($(call localised,PRETEST))
	@echo "**** Tests of $(COMPONENTNAME) succeeded ****"
$(COMPDIR)RETEST: COMPONENTNAME:=$($(call localised,COMPONENTNAME))
$(COMPDIR)RETEST: $($(call localised,LOCALTESTRERUN)) PRETEST
	@echo "**** Tests of $(COMPONENTNAME) succeeded ****"
endif

########################################################
## DIST              ###################################
########################################################
DIST_EXCLUDE_PATTERNS?=.svn *~ *backup $(TARGETS) .ctl.env
include $(COMPONENT_MAKEFILE)/include_make/dist_target.mk


#######################################################
###CLEAN ##############################################
#######################################################
ifneq "$(COMPDIR)" ""
$(COMPDIR)clean: FILES=$(wildcard $($(call localised,CLEAN)) $($(call localised,CLEANALL)) $($(call localised,TARGETS)) $($(call localised,TESTTARGET)) $($(call localised,LOCALLIBS)) $($(call localised,COMPONENTLIBS)) $($(call localised,LOCALOBJECT)))
$(COMPDIR)clean: DIRS=$(wildcard $($(call localised,CLEANDIR)))
$(COMPDIR)clean: COMPDIR:=$(COMPDIR)
$(COMPDIR)clean:
	@if [ -z "$(word 1,$(FILES) $(DIRS))" ]; then\
          echo Project is clean...;\
         else\
         if [ -n "$(word 1,$(FILES))" ]; then\
          echo DELETING FILES: $(FILES);\
          $(RM) $(FILES);\
         fi;\
         if [ -n "$(word 1,$(DIRS))" ]; then\
          echo DELETING DIRECTORIES: $(DIRS);\
          $(RM) -rf $(DIRS);\
         fi;\
        fi
endif

###########################################################
####### DEPENDENCY CHECK        ###########################
###########################################################
$(foreach C,$($(call localised,$(strip $(DEPENDS)))),$(eval $(call ASSERTAVAILABLE,$C)))

