#THE FOLLOWING SECTION NEEDS TO BE HERE 
#FOR ALLOWING THE INCLUSIVE MAKE PROCESS TO WORK

include $(COMPONENT_MAKEFILE)/path.mk

CONNECTSOURCEPREFIX?=connect
CCSUFFIX?=cc
CSUFFIX?=c
PSUFFIX?=p
FSUFFIX?=f

#SOME CONFIGURATION OF LOCAL NAMING CONVENTIONS
#if FOLLOWING NEEDS TO BE SET IN PROJECT DEFINE LOCALLY WITH $(COMPDIR)
$(call localised,CONNECTSOURCEPREFIX)?=$(CONNECTSOURCEPREFIX)
$(call localised,CCSUFFIX)?=$(CCSUFFIX)
$(call localised,CSUFFIX)?=$(CSUFFIX)
$(call localised,PSUFFIX)?=$(PSUFFIX)
$(call localised,FSUFFIX)?=$(FSUFFIX)

#PREDEFAULTS FOR TOOLCHAIN
CAT?=cat
SED?=sed
UNIQ?=uniq
GDB_EXEC?=gdb
MKDIR?=mkdir
SET?=set
RANLIB?=ranlib
AR?=ar
CC?=cc
CXX?=cxx
SWIG?=swig
PC?=gpc
MV?=mv
IDL2CTL?=idl2ctl
SOLINKAGE?=-l thread
EXELINKAGE?=-l pipe
SHELL?=/bin/sh
TAR?=tar


#UNDEFINE LOCAL VARIABLES
define UNDEFINEVAR
  $(1):=#UNDEFINE
endef
LOCAL_VARIABLES:=NOCTL LDLIBS COMPONENTNAME VERSION CPPFLAGS CCFLAGS CFLAGS INCFLAGS
$(foreach VAR,$(LOCAL_VARIABLES),$(eval $(call UNDEFINEVAR,$(VAR))))

#CTL NAMING CONVENTION
OSTYPE             =$(shell uname -s)
HOSTTYPE           =$(shell uname -m)
TARGET             =$(CXX)$(OSTYPE)$(HOSTTYPE)
CTL_RELATIVE_LIBDIR=libctl_$(TARGET)/
ifeq "$(OSTYPE)" "Darwin"
	MD5:=md5
	SHARED ?= -dynamiclib
else
	MD5:=md5sum
	SHARED ?= -shared
endif

