
#define CTL_Connect
#include <iostream>
#include <fstream>
#include <ctl/ci/exception.ci>

namespace ctlexp
{
	class exceptionWrapper
	{
	public:
		exceptionWrapper()
		{
		}
		exceptionWrapper(double &x)
		{
				x = 300;
//				throw(x);
//				throw(std::string("error") );
		}
		exceptionWrapper(const std::string &filename)
		{
			std::ifstream infile;
			infile.open(filename.c_str());
			
			if(!infile.good())
			{
				ctl::exception msg("Can not open file '"+filename+"' or file '"+filename+"' doesn't exist!");
				throw msg;
			}
			else
			{
			}
			
		}
		double divide(double a, double b)
		{
			if(b == 0)
			{
				std::string msg = "Denominator can not be 0";
				throw msg;
			}
				
			return a/b;
		}
		static bool exist(const std::string &filename)
		{
			std::ifstream infile;
			infile.open(filename.c_str());
			
			if(!infile.good())
			{
				std::string msg= "Can not open file '"+filename+"' or file '"+filename+"' doesn't exist!";
			throw msg;
			}
			else
			{
				return true;
			}
			
		}
	};

	double func(const double &a)
	{
		if(a < 0)
		{
			//std::string msg = "Value can not be less than 0";
			ctl::exception msg("Value can not be less than 0");
			throw msg;
		}
		return sqrt(a);
	}
}

struct connectDetail
{
	CTL_Constructor(1, (const std::string &), 1);
	CTL_StaticMethod(1, bool, ctlexp::exceptionWrapper::exist, (const std::string &), 1);
};

void CTL_connect()
{
	ctl::result<double> (*f)(const double&) = ExpCI::squareRoot;
	ExpCI::connect(f, &ctlexp::func);
//	ExpCI::connect< 1 >(&ctlexp::func);
	
	ctl::connect<ExpCI::ExceptionCI, ctlexp::exceptionWrapper, connectDetail>();
}
