#include <iostream>
#include <string>
#include <ctl.h>
#include <ctl/ci/exception.ci>


int main(void)
{
//	ExpCI::use("bin/ExceptionCI.ctl.so -l lib -f log.txt");
//	ExpCI::use("bin/ExceptionCI.ctl.so  -l thread -f log.txt:all");
//	ExpCI::use("bin/ExceptionCI.ctl.exe  -l tcp -f log/log.txt:all");
	ExpCI::use("bin/ExceptionCI.ctl.exe  -l tcp -f log/log.txt:all");
	ExpCI::ExceptionCI exception;
	try 
	{
		if(!exception)
		{
				std::cout<<" creation of  ExpCI::ExceptionCI failed\n";
				return 0;
		}
	}
	catch(const ctl::exception &e)
	{ std::cout<<"ctl::exception"<<e.what()<<"\n"; return 0; }
	catch(const std::string &e)
	{ std::cout<<"std::string"<<e<<"\n"; return 0; }

	double a, b;
	std::cerr<<"a = ";
	std::cin>>a;
	std::cerr<<"b = ";
	std::cin>>b;
	ctl::result<double> temp1 = exception.divide( a ,b);
	try
	{
		double c= temp1;
		std::cerr<<"a/b = "<<c<<std::endl;
	}
	catch(std::string msg)
	{ std::cerr<<"caught std::string: "<<msg<<std::endl; }
	catch(ctl::exception & msg)
	{ std::cerr<<"caught ctl::exception: "<<msg.what()<<std::endl; }

	std::string filename;
	std::cerr<<"File: ";
	std::cin>>filename;
// Don't expect an exception here
	ctl::getLink("ExpCI::ExceptionCI");
	ctl::result<bool> temp2 = ExpCI::ExceptionCI::exist(filename);
	try
	{
// Exceptions are thrown here!
		bool exist = temp2;
		std::cout<<"File '"<<filename<<"' exist!"<<exist<<std::endl;
	}
	catch(std::string msg)
	{ std::cout<<"caught std::string: "<< msg<<std::endl; }
	catch(ctl::exception & msg)
	{ std::cout<<"caught ctl::exception: "<<msg.what()<<std::endl; }

	try
	{
		double d,e;
		std::cerr<<"d = ";
		std::cin>>d;

		e=ExpCI::squareRoot(d);
		std::cerr<<"sqrt(d) = "<<e<<std::endl;
	}
	catch(ctl::exception msg)
	{ std::cerr<<"caught ctl::exception: "<<msg<<std::endl; }
	catch(std::string msg)
	{ std::cerr<<"caught std::string: "<<msg<<std::endl; }
	return 0;
}
