#include <ctl/ci/performance.ci>

int main(int argc, char** argv)
{
	ctl::vector<ctl::location> loc = ctl::readLocation("rsc.txt");
	int M=0, N=0;
	if(argc>1)
	  sscanf(argv[1],"%d", &M);
	else
	{
		std::cerr<<" Number of calls =\n";
		std::cin>>M;
	}
	if(argc>2)
	  sscanf(argv[2],"%d", &N);
	else
	{
		std::cerr<<" Size of data =\n";
		std::cin>>N;
	}
	ctl::vector<double> x((N+7)>>3, 0.1);
	int Z=0;
	for(size_t P=0; P<loc.size(); P++ )
	{
		if(!loc[P])
		{
				std::cout<<"invalid location '%s'\n"<< loc[P].error()<<"\n" ;
				continue;
		}
		ctl::link lnk(loc[P]);
		if(!lnk)
		{
			std::cout<<"Could not create link -> "<< loc[P].getSSH() << "\n";
			continue;
		}
		performanceCI perform(lnk);
		if(!perform)
		{
			std::cout<<"Could not create performCI -> "<< loc[P].getSSH() << "\n";
			continue;
		}
		ctl::Timer &T=ctl::timer();
		(void)T.t();
		for(int i=0; i<M; i++)
		{
			try
			{ 
//				double x= perform.getD(3.3);
//				perform.set(x);
				ctl::vector<double> y = perform.get(x);
			}
			catch(const ctl::exception &e)
			{ std::cout << " caught exception: "<< e <<"\n"; break;}
		}
		double tt = T.dt();
		std::string locStr = loc[P].getSSH().c_str();
		std::cerr<<Z++<<": link: "<<locStr<<" "<<M<<" calls with "<<tt/M<<"sec/call \n\n\n";
		
	}
	return 0;
}
