/*
The remote component for AnyMapCI, which can be used to map any types of variables based
on the ctl template type "ctl::any". It share the interface "ctlanymap.ci" with the program who
uses it, and in the program it should be invoked as name: "AnyMapCI".
*/
#define CTL_Connect
#include <map>
#include <ctl/ci/anymap.ci>

class anymapWrapper
{
public:
	// set the map
	void set(const std::string &k, const ctl::any &v)
	{ anymap[k] = v; }
	// get the value of the map by telling the key
	ctl::any get(const std::string &k) const
	{
		std::map<std::string,ctl::any>::const_iterator a=anymap.find(k);
		if(a != anymap.end())
		{
			return a->second;
		}
		else
		{
			return ctl::any();
		}
	}
	
public:
	// standard map, map a "ctl::any" variable to a stardard string.
	std::map<std::string,ctl::any> anymap;
};
// connect AnyMapCI(declare in the file "ctlanymap.ci") with anymapWrapper.
void CTL_connect()
{
	ctl::connect<AnyMapCI, anymapWrapper >();
}
