#include <chain.ci>

int main(int n, char **arg)
{
	FILE *in=fopen("bin/chain.rsc","r");
	char line[1024], *s=ctl::readLine(line, 1023, in);
	ctl::link p(s);
	if(!p)
	{ 	
		printf(" Could not open link '%s'\n", s);
		return 1;
	}

	ctl::vector<ctl::string> locStr;
	while( (s=ctl::readLine(line, 1023, in) ) )
		if(strlen(s)>1)
			locStr.push_back(s);

	chainCI chain(p, locStr);
	try
	{
		size_t depth = chain();
		printf("depth = %d(%d)\n", int(depth), int(locStr.size()+1) );
		if(depth<locStr.size()+1)
			return 1;
	}
	catch(const ctl::exception &e)
	{ std::cout<<"caught exception:"<<e.what()<<"\n"; }
	chainLib::use(p);
// chainLib::f is not defined: try nethertheless
	try
	{ chainLib::f(33); }
	catch(const ctl::exception &e)
	{ std::cout<<"caught exception:"<<e.what()<<"\n"; }
	chainLib::use();
//	std::cout<<"please <enter>!\n"; getchar();
	return 0;
}

