#ifndef GCD_H_
#define GCD_H_

#include <ctl/ci/gcd.ci>

class gcdImpl
{
	int meM;
	ctl::uint8 nM;
	ctl::vector<gcdCI> teamM;
// no copy constructor
	gcdImpl(const gcdImpl &);
public:
	gcdImpl(const ctl::group &G, ctl::uint8 n =0): meM(G.logId()),nM(n) 
	{ teamM = G.sample(gcdCI(this)); }
	gcdImpl(ctl::uint8 n =0): meM(-1),nM(n) {} 
	void setTeam(int me, const ctl::vector<gcdCI> &team)
	{ meM = me; teamM = team; }
	ctl::uint8 getN() const
	{ return nM; }
	void operator() (const ctl::uint8 &x)
	{
		printf("me=%d: %d <- %d\n", meM, int(nM), int(x));
		if(x!=nM)
		{
			int s = teamM.size();
			nM = x<nM ? nM-x : x-nM;
			teamM[(meM+s-1)%s](nM);
			teamM[(meM+1)%s](nM);
		}
	}
};

class gcd: public gcdImpl,  public ctl::Interface<gcdCI>
{
	gcd(const gcd&);
public:
	gcd(const ctl::group &G, ctl::uint8 n =0): gcdImpl(G, n) {}
	gcd(ctl::uint8 n =0): gcdImpl(n) {} 
	ctl::result<ctl::uint8> getN() const
	{ return gcdImpl::getN(); }
	ctl::result<void> operator() (const ctl::uint8 &x)
	{
		gcdImpl::operator()(x);
		return ctl::result<void>();
	}
};

template<class Int> struct gcdAssign
{
	void operator()(Int &y, Int x) const
	{
		do
		{
 		  const Int tmp(x);
 		  x = y % x;
 		  y = tmp;
		} while (x != 0);
	}
};
#endif

