#include <ctl/ci/gcd.ci>
#include <gcd.h>

int groupTest(ctl::group &G)
{
	const ctl::uint8 num=77*(G.logId()+1);
//	gcdImpl g(num);
	gcd g(num);
// create a gcdCI implemented by a reference to g
	gcdCI local(&g);
// sample all local gcdCI instances
	ctl::vector<gcdCI> team = G.sample(local);
	g.setTeam( G.logId(), team);
// start gcd recursion
	g(0);
// run until termination detected
//	G.run();	
	printf("by recursion: me = %d gcd = %lld\n", G.logId(), ctl::uint8(g.getN() ) );

// the gcd operator is associative ==> log(n) algorithm exist
	printf("by merge: me = %d gcd = %lld \n", G.logId(), G.merge( num, gcdAssign<ctl::uint8>()) );

// the group::operator+ is another predefined merger
// also predefined  *,^(xor),|,&,<(min), >(max)
	int sum = G + int(G.logId());
	printf("me = %d: sum = %d\n",G.logId(), sum );

// exchange some data between group instances
	if(G.size() > 2)
	{
		if(G.logId()==1)
		{
			double x = 3.14159265358979;
			G[2]<<x;
		}
		if(G.logId()==2)
		{
			double x;
			G[1]>>x;
			printf("me = %d: got x = %e\n",G.logId(), x);
		}
	}
	fflush(stdout);
	return 0;
}
