/***************************************************************************
                          connect.cpp  -  description
                             -------------------
    begin                : Thu Nov 7 2002
    copyright            : (C) 2002 by r.n.
    email                : rniekamp@sc.cs.tu-bs.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define CTL_Connect

#include <ctl/ci/locator.ci>

class locator
{
		typedef std::map<ctl::string, ctl::location> mapT;
		mapT lmapM;
	public:
		locator(const ctl::string &rsc="../rsc.rsc")
		{
			ctl::vector<ctl::location> lvec = ctl::readLocation(rsc.c_str());
			for(size_t i=0; i<lvec.size(); i++)
					lmapM[lvec[i].ciName] = lvec[i];
		}
		ctl::string get(const ctl::string &ci_name, const ctl::any &property) const
		{
			std::cerr<<"locator <- "<<ci_name<<"\n";
			mapT::const_iterator l=lmapM.find(ci_name);
			if(l!=lmapM.end() )
				std::cerr<< l->second.getSSH()<<"\n";
			return l==lmapM.end() ? ctl::string() : l->second.getSSH();
		}
		ctl::string operator()(const ctl::string &ci_name, const ctl::any &property) const
		{ return get(ci_name, property); }
		ctl::vector<ctl::string> getArray(unsigned int /*length*/, const ctl::string&/*CI_Name*/ , const ctl::any &/*property*/, int /*mode*/) 
		{ return  ctl::vector<ctl::string>(); }
		ctl::vector<ctl::string> getArray(unsigned int length, const ctl::string& CI_Name , const ctl::any &property)
		{ return getArray(length, CI_Name, property, 0); } 
};


struct connectDetails
{ 
		CTL_Constructor(1, (const ctl::string &), 1); 
		CTL_Method(2, ctl::vector<ctl::string>, locator::getArray, (unsigned int,  const ctl::string&,  const ctl::any &), 3);
		CTL_Method(3, ctl::vector<ctl::string>, locator::getArray, (unsigned int,  const ctl::string&,  const ctl::any &, int), 4);
};

inline void CTL_connect()
{ ctl::connect<CTL_Locator,locator, connectDetails>(); }

