/***************************************************************************
                          connect.cpp  -  description
                             -------------------
    begin                : Thu Nov 7 2002
    copyright            : (C) 2002 by r.n.
    email                : rniekamp@sc.cs.tu-bs.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define CTL_Connect

#include <example.ci>

#define CTL_Class examplePI
#define CTL_Extends (exampleCI), 1
#include CTL_ClassBegin
#include CTL_ClassEnd

class example
{
public:
	void method_(int val)
	{ fprintf(stderr, "child meth(%d) \n",  val); }
};

struct detail
{
	CTL_Method(1, void, example::method_, (int), 1 ); 
};

class mpi_example
{
	ctl::group G;
	ctl::vector<examplePI> worker;
public:
	mpi_example()
	{
		G = ctl::getMainGroup();
	std::cout<<"|G| = "<< G.size() <<" "<< G.logId()<<" "<<!!G<<"\n";
// The master creates worker on all mpi processes
		if(G.logId()==0) // called as parent of mpi group
		{
			worker.resize(G.size());	
			example impl;
			for(size_t p=0; p<worker.size(); p++)
				worker[p] = examplePI(G[p]);
		}
		else
		{
			worker.resize(1);	
			worker[0] = examplePI(G[1]);
		}
	}
// implements call in mpi_example.ci
	void method(int val)
	{
		fprintf(stderr, "meth of master object (%d) of process[%d] called \n",  val, G.logId());
// The master invokes all other worker
		for(size_t p=1; p<worker.size(); p++)
	 		worker[p].method(val+p);
		worker[0].method(val);
	}
};


void CTL_connect()
{ 
	ctl::connect<examplePI, example, detail>(); 
	ctl::connect<exampleCI, mpi_example>(); 
}
