#include <provide.ci>
#include <uses.ci>
class Provide
{
  public:
	mutable bool visitedM;
	Provide(): visitedM(false) {}
  ctl::string hello(const ctl::string &m) const
  {
		visitedM = true;
    std::cerr<<m<<"\n";
    return m + "received";
  }
};

int main()
{
	ctl::vector<ctl::location> loc = ctl::readLocation("rsc.txt");
	for(size_t i=0; i+1<loc.size(); i+=2)
	{
		ctl::link provLink(loc[i]);
		ctl::link usesLink(loc[i+1]);
		printf(" %s with %s\n", ctl::location::channel2string(provLink.getType()),
										ctl::location::channel2string(usesLink.getType()) );

//   adding linkage thred as default location		
		provideCI::use("+ -l thread");
		Provide pLocal;
//  instantiate provideCI by reference to pLocal
		provideCI p(&pLocal);

//  instantiate provideCI by pLocal object explicitly by thread linkage
//		provideCI p(pLocal, ctl::thread);

//	instantiate provideCI on component given by provLink
//		provideCI p(provLink);

//	instantiate usesCI on component given by usesLink
		usesCI u(usesLink, p);
		try
//	let result of u.call(...) listen to remote invokations
//		{ u.call("hello provide").listen(); }
		{ 
			u.call("hello provide"); 
			std::cout << pLocal.visitedM << "\n";
		}
		catch(const ctl::exception &e)
		{ std::cout << e <<"\n"; }
	}
	return 0;
}
