
#ifndef PI_TASK_TYPES_H
#define PI_TASK_TYPES_H

#include "SPWorkerRI.h"

namespace wire{
	class WorkException {
		
	public:
		int state;
		ctl::string what;

		~WorkException(){ }
		WorkException(int s=-1, const ctl::string &w =ctl::string()): state(s), what(w){}
		CTL_Type(WorkException, tupel, (state, what), 2);
	};
	
	enum ErrorEnum{
		PermanentWorkerError,
		PermanentJobError,
		Unknown
	};
	
	struct SubTaskTypes{
		typedef int ResultT;
		typedef int ParameterT;
		typedef std::vector<double> ConstructorParameterT;
		typedef WorkException ExceptionT;
	};
	struct TaskTypes{
		typedef int JobIDT;
		typedef double ResultT;
		typedef int ParameterT;
		typedef std::string ConstructorParameterT;
		typedef ErrorEnum StatusT;
		typedef SubTaskTypes::ResultT PartialResultT;
		typedef SubTaskTypes::ParameterT PartialParameterT;
		typedef SubTaskTypes::ConstructorParameterT SubTaskConstructorParameterT;
		typedef SubTaskTypes::ExceptionT ExceptionT;
		typedef wire::SPWorkerRI<SubTaskTypes> WorkerT;
	};
};

#endif
