#include "PiWorker.h"

namespace wire{
	PiWorker::PiWorker(const ConstructorParameterT param) : x0_(param[0]), c0_(param[0]), y0_(param[1]), d0_(param[1]){
	}
	
	PiWorker::PiWorker() : x0_(sqrt(2)), c0_(sqrt(2)), y0_(sqrt(3)), d0_(sqrt(3)){
	}
		
	PiWorker::ResultT PiWorker::work(const PiWorker::ParameterT parameter) throw (ExceptionT){
		double s,t;
		PiWorker::ResultT res = 0;
		
		for(int i = 0; i < parameter; i++){
			x0_ += c0_;
			while(x0_ > 1) x0_ -= 1.0;
			s = 2 * x0_ - 1;
			
			y0_ += d0_;
			while(y0_ > 1) y0_ -= 1.0;
			t = 2 * y0_ - 1;
			
			if((s*s + t*t) < 1)
				res++;
		
		}
		
		return res;
	}
};
