
#include <cstdlib>
#include <vector>
#include <iostream>

#include "PiTaskTypes.h"

int main (int argc, char** argv) {
	const double PI = 3.1415926535897932384626433832795028841972; // for error estimation
    
//	ctl::link lnk("manager.exe -l tcp -f log/manager");
	ctl::link lnk("manager.so -l lib -f log/manager ");
	wire::SPWorkerRI<wire::TaskTypes> worker;
	try{
//		worker = wire::SPWorkerRI<wire::TaskTypes>(std::string("resourcen.lst"));
		worker = wire::SPWorkerRI<wire::TaskTypes>(lnk,"resourcen.lst");
	}
	catch(const ctl::exception &e){
		std::cout << e <<"\n";
	}
			
	if(!!worker){
		try{
			double pi = worker.work(1000*1000);
			printf("Final PI: %.15E\n", pi);
			printf("Absolute error: %.15E\n", fabs(PI - pi));
		}
		catch(ctl::exception &e){
			std::cout << e << std::endl;
		}
	}
	else{
		std::cout << "Worker is not working ;-) : " << std::endl;
	}
	
    return 0;
}
