#include <qwidget.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qimage.h>

#include <qcursor.h>
#include <qapplication.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include <ctl.h>


struct initWidget
{
	int n;
	const char *arg[2];
	QApplication *qapplM; 
	initWidget(): n(1)
	{ 
		arg[0] = "qtpaint"; arg[1] = 0;
		qapplM = new QApplication(n, (char**)arg); 
	}
};

class paintQT : initWidget, public QWidget
{
struct point
{
	int x, y;
	void set(int a, int b)
	{ x = a; y = b; }
};
struct line
{
 point p0, p1;
	line() {}
	line(const point& p0, const point& p1): p0(p0), p1(p1)
	{}
};
	float xm, xM, ym, yM;
	ctl::link clientM;
	ctl::vector<point> pointM;
	ctl::vector<line> lineM;
	bool readyM;
	unsigned int L,H;
	int penTypeM, penSizeM;
	float scaleXM, scaleYM, mxM, myM;
	bool runningM;
	mutable char eventTypeM, eventValM;
	void init(int l, int h)
	{
		eventTypeM = eventValM = 0;
		L = l; H = h;
		setFixedSize(L, H);
		setBackgroundColor( white );
	  startTimer(10);

		qapplM->setMainWidget(this);
		show();
 	}
public:
	paintQT(int l, int h, QWidget *parent=0, const char *name=0):
							QWidget( parent, name, Qt::WNorthWestGravity ),
							readyM(false),penTypeM(0), penSizeM(1),
							scaleXM(1), scaleYM(1),mxM(0), myM(0), runningM(false) 
	{ init(l, h); }
	paintQT(QWidget *parent=0, const char *name=0):
							QWidget( parent, name, Qt::WNorthWestGravity ),
							readyM(false),penTypeM(0), penSizeM(1),
							scaleXM(1), scaleYM(1),mxM(0), myM(0), runningM(false) 
	{ init(1024, 720); }
	char event(char& type) const
	{ 
		type = eventTypeM;
		eventTypeM = 0;
		char val = eventValM;
		eventValM = 0;
		return val;
	}
	void run()
	{ 
		if(!runningM)
		{
			clientM = ctl::getClient();
			if(clientM.getIType()==ctl::lib)
				throw(ctl::exception(" call of paint2dCI::run() with synchron linkage"));
			runningM = true;
			qapplM->exec();
		}
	}
	void setPen(int type, int size)
	{
		penTypeM = type;
		penSizeM = size;
	}
	void setBBox(float x, float X, float y, float Y)
	{ xm=x; xM = X; ym = y; yM = Y; }
	void computeBBox(const ctl::vector<float> &x, const ctl::vector<float> &y)
	{
		if(!x)
			return;
		xm=x[0],ym=y[0],xM=xm,yM=ym;
		for(size_t i=1; i<x.size(); i++)
		{
			if(x[i] <xm)
				xm = x[i];
			else if(x[i]>xM)
				xM = x[i];
			if(y[i] <ym)
				ym = y[i];
			else if(y[i]>yM)
				yM = y[i];
		}
	}
	void setPoints(const ctl::vector<float> &x, const ctl::vector<float> &y, bool clear=true)
	{
		computeBBox(x, y);
		setPoints(x,y, xm, xM, ym, yM, clear);

	}
	ctl::vector<point> scalePoints(const ctl::vector<float> &x, const ctl::vector<float> &y, 
									float mx,float Mx,float my,float My)
	{ 
		float ax = (mx+Mx)/2, ay = (my+My)/2, dx= (Mx-mx)/(L-20), dy = (My-my)/(H-20);
		if(dx==0)
			dx = 1;
		if(dy==0)
			dy = 1;
		scaleXM = dx;
		scaleYM = dy;
		mxM = ax;
		myM = ay;
		size_t i;
		ctl::vector<point> p(x.size());
		for(i=0; i<x.size(); i++)
			p[i].set(int( 0.5 + L/2+(x[i]-ax)/dx),int( 0.5 + H/2 - (y[i] - ay)/dy));
		return p;
	}
	void setPoints(const ctl::vector<float> &x, const ctl::vector<float> &y, 
									float mx,float Mx,float my,float My, bool clear=true)
	{
		ctl::vector<point> p = scalePoints(x, y, mx, Mx, my, My);
		pointM.push_back(p);
		if(clear)
			update();
		else
			paint();
	}
	void setLines(const ctl::vector<float> &x0, const ctl::vector<float> &y0, const ctl::vector<float> &x1, const ctl::vector<float> &y1,  bool clear=true) 
	{
		ctl::vector<point> p0=scalePoints(x0, y0, xm, xM, ym, yM), 
				p1 =scalePoints(x1, y1, xm, xM, ym, yM);
		for(size_t i=0; i<x0.size(); i++)
			lineM.push_back(line(p0[i], p1[i]) );
		if(clear)
			update();
		else
			paint();
	}
	void  mousePressEvent( QMouseEvent *e)
	{
		eventTypeM = 'M';
		eventValM = 'P';
		QPoint p=e->pos();
		double x= mxM + (float(p.x())-L/2)*scaleXM;
		double y= myM + (H/2 -float(p.y()))*scaleYM;
		char c[1024];
		sprintf(c,"(%e %e)\n",x,y);
		QPainter painter(this);
		painter.setPen(QPen(QColor(0,0,0), penSizeM) );
		painter.drawText(p.x(), p.y(), c);
	}
  void mouseReleaseEvent( QMouseEvent *)
  {
		eventTypeM = 'M';
		eventValM = 'R';
		update();
		paint();
	}
	void timerEvent(QTimerEvent *)
	{
		if(!ctl::run())
			qapplM->quit();
	}
	void keyPressEvent(QKeyEvent *e)
	{
		eventTypeM = 'K';
		eventValM = char(e->key());
		if(e->key()==Key_Q)
		{
			qapplM->quit();
			runningM = false;
		}
		if(e->key()==Key_B)
		{
			char bmp[1024];
			sprintf(bmp,"paint%d.bmp", int(pointM.size()));
		QPixmap map =  QPixmap::grabWindow(winId(),0,0,L,H);
		map.save(bmp,"BMP");
		}
	}
	void paintEvent(QPaintEvent *)
	{ paint(); }
	void paint()
	{
		QPainter painter(this);
		painter.setPen(QPen(QColor(0,0,0), penSizeM) );
	
		for(size_t i=0; i<lineM.size(); i++)
		{
			painter.moveTo(lineM[i].p0.x, lineM[i].p0.y);
			painter.lineTo(lineM[i].p1.x, lineM[i].p1.y);
		}
		if(!pointM)
			return;
		if(penTypeM==0)
		{
			painter.moveTo(pointM[0].x, pointM[0].y);
			for(unsigned int i=1; i<pointM.size(); i++)
				painter.lineTo(pointM[i].x, pointM[i].y);
			return;
		}
		for(unsigned int i=0; i<pointM.size(); i++)
			painter.drawRect(pointM[i].x-penSizeM, pointM[i].y-penSizeM,2*penSizeM,2*penSizeM);

	}
};

