#include <ctl/ci/paint2d.ci>
#include <math.h>


int main()
{
	const int N = 800;
	ctl::vector<float>  x(N), y(N);
	for(int i=0; i<N; i++)
	{
		double arg=20.0 * i * 3.141592653589793 /N;
		x[i] = 2*i * sin(arg);
		y[i] = 2*i * cos(arg);
	}
	ctl::location paintLoc("bin/Paint2dCI.ctl.exe  -l tcp ");
	ctl::link p(paintLoc);

	paint2dCI painter;
	try
	{ painter=paint2dCI(p,ctl::named); }
	catch(const ctl::exception &e)
	{
		printf(" caught exception: '%s'\n", e.what() );
		return 1;
	}
//	painter.run();
	ctl::result<void> wait=painter.run();
	double ds = 0.01, dc =  (1-ds)*sqrt((1+ds)/(1-ds) );
	int z=10000;
	while(--z)
	{
//		printf("**** %d %d *****\n", x.getRefCount(), y.getRefCount() );
		for(int i=0; i<N; i++)
		{
			double tmp = dc*x[i] + ds * y[i];
			y[i] = dc*y[i] - ds * x[i];
			x[i] = tmp;
		}
//		printf("****** %d %d *****\n", x.getRefCount(), y.getRefCount() );
		ctl::sys::usleep(500);
		try
		{ painter.paint(x, y, -1.1f * N, 1.1f*N, -1.1f*N, 1.1f * N, true); }
		catch(ctl::exception e)
		{
			printf(" caught exception: '%s'\n", e.what() );
			break;
		}
	}

	printf(" please hit <return> \n");
	getchar();
	return 0;
}

