       subroutine simu_new2_impl(s0,x0,s1,x1)
       integer*8  s0
       character  x0(s0)
       integer*8  s1
       real*8  x1(s1)
 
       call simu_init_impl(s0,x0)
       end

       subroutine simu_delete_impl()
c       write(*,*) 'simu_delete_impl:' 
       end

       subroutine simu_new1_impl(s0,x0)
       integer*8  s0
       character  x0(s0)
 
       call simu_init_impl(s0,x0)
       end

       subroutine simu_init_impl(s0, x0)
       include 'system'
       integer*8 s0
       character x0(s0)
       integer*8 len;
       character path(1024)

       len = 1024
       call ctl_cwd(path, len);
c       write(6,* path, len
       write(6,*) 'simu.f: ', x0, s0 
       ndof = 3
       ncpl = 1
       npar = 3
       do 10 i = 1, ndof
          sys_x(i) = 0.e0
          sys_b(i) = 0.e0
10     continue
       do 15 i = 1, ncpl
          sys_i(i) = i
          sys_y(i) = 0.e0
15     continue
       end

       subroutine simu_getparam_impl(s0, x0)
       include 'system'
       integer*8 s0
       real*8 x0(s0)
       if (s0 .eq. npar) then
         do 20 i = 1, npar 
            x0(i)  = sys_p(i)
20       continue
       else
         s0 = npar
       endif

       end

       subroutine simu_setparam_impl(s0, x0)
       include 'system'
       integer*8 s0
       real*8 x0(s0)

       if (s0 .ne. npar) then
         write(*,*) s0,'  ',npar, '  error in simu_setparam_impl'
       endif
       do 17 i = 1, npar
          sys_p(i) = x0(i)
17     continue

       end

       subroutine simu_getstate_impl(s0, x0)
       include 'system'
       integer*8 s0
       real*8 x0(s0)

       if(s0 .eq. ndof) then
         do 20 i = 1, ndof 
            x0(i)  = sys_x(i)
20       continue
       else
         s0 = ndof
       endif

       end


       subroutine simu_setstate_impl(s0, x0)
       include 'system'
       integer*8 s0
       real*8 x0(s0)

       if (s0 .ne. ndof) then
         write(*,*) 'error in simu_setstate_impl'
       endif
       do 30 i = 1, ndof 
          sys_x(i) = x0(i)
30     continue
       end

       subroutine simu_setload_impl(s0, x0)
       include 'system'
       integer*8 s0
       real*8 x0(s0)

       if (s0 .ne. ndof) then
         write(*,*) 'error in simu_setload_impl'
       endif
       do 40 i = 1, ndof 
          sys_b(i) = x0(i)
40     continue

       end

       subroutine simu_getcoupling_impl(s0, x0, s1, x1)
       include 'system'
       integer*8 s0
       integer*4 x0(s0)
       integer*8 s1
       real*8 x1(s1)

       if (s0 .eq. ncpl) then
         do 50 i = 1, ncpl 
c	we count from 0
            x0(i)  = sys_i(i) - 1
            x1(i)  = sys_x(i)
50       continue
       else
         s0 = ncpl
         s1 = ncpl
       endif

       end

       subroutine simu_setcoupling_impl(s0, x0)
       include 'system'
       integer*8 s0
       real*8 x0(s0)

       if (s0 .ne. ncpl) then
         write(*,*) 'error in simu_setcoupling_impl'
       endif
       do 60 i = 1, ncpl 
          sys_y(i) = x0(sys_i(i))
60     continue

       end

       subroutine simu_residual_impl(s0, x0)
       include 'system'
       integer*8 s0
       real*8 x0(s0)

c       write(6,*) 'simu.residual: ', ndof, s0,  x0, sys_x, sys_p 
       if (s0 .ge. ndof) then
         do 65 i = 1, ndof 
            x0(i) = -sys_b(i)
65       continue
         do 70 i = 1, ndof-1 
            x0(i) = x0(i) + sys_p(i) * (sys_x(i) - sys_x(i+1) )
            x0(i+1) = x0(i+1) + sys_p(i) * (sys_x(i+1) - sys_x(i) )
70       continue
         x0(ndof) = x0(ndof) + sys_p(ndof) * sys_x(ndof)
       else
        s0 = ndof
       endif
c      write(6,*) 'simu.residual end: ', s0,  x0 

       end

       subroutine simu_solve_impl( x0, s1, x1)
       real*8 x0
       integer*8 s1
       real*8 x1(s1)

       end

       subroutine simu_timestep_impl( x0, s1, x1)
       real*8 x0
       integer*8 s1
       real*8 x1(s1)

       end
 
       subroutine simu_precond_impl( s0, x0, s1, x1)
       integer*8 s0
       real*8 x0(s0)
       integer*8 s1
       real*8 x1(s1)
 
       end

       subroutine simu_dirderivative_impl( s0, x0, s1, x1, s2, x2)
       integer*8 s0
       real*8 x0(s0)
       integer*8 s1
       real*8 x1(s1)
       integer*8 s2
       real*8 x2(s2)
 
       end

       subroutine simu_getnodes_impl(dim, s0, x0)
       integer*4 dim
       integer*8 s0
       real*8 x0(s0)

       end

       subroutine simu_command_impl(s0, x0, x1)
       integer*8 s0
       character x0(s0)
			 integer*4 x1	

       write(6,*) 'simu.f: command ', x0 
       x1 = 33
       x0(1) = 'X'
       write(6,*) 'simu.f: command ', x0 

       end

