#include <iostream>
#include <string>
#include <vector>

#include <ctl/ci/simu.ci>
#include "penaltySolver.h"

int main(int n, const char **args)
{
using namespace solver;
	ctl::group grp;
	if(n<2)
	{
		ctl::vector<ctl::location> locV(1);
		locV[0] = "bin/solverTEST -l tcp -d..";
		grp = ctl::group(locV,ctl::tcp);
	}
	else
		grp = ctl::group(n, args);
	ctl::messageInfo(stderr);

	if(grp.size()!=2)
	{
		std::cout<<"solver must be invoked by\n\t\"mpirun -np 2 solver.exe mpi\"\n"; 
		return 0;
	}
	ctl::vector<ctl::location> loc=ctl::readLocation("solver.rsc");

	if(loc.size()<2)
	{
		std::cout<<"reading solver.rsc failed or not enough entries\n";
		return 0;
	}

	ctl::link p(loc[grp.logId()]);
	simuCI<double> sim(p);

	if(grp.logId()==0)
		sim.init("Itr1");
	if(grp.logId()==1)
		sim.init("Itr2");

	realVec param;
	param = sim.getparam(); 
	for(int i=0; i<param.size(); i++)
		param[i] = 1;

	std::cout<<"me = "<<int(grp.logId())<<": p = "<<param<<"\n";
	sim.setparam(param);

	penaltyResiduum res(grp, sim, 1e4);
	quasiNewtonSolver<penaltyResiduum> solver(res);
	realVec x=solver();
	std::cout<<"me = "<<int(grp.logId())<<": T = "<<x<<"\n";
//	std::cout<<"Please hit <return> \n";
//	getchar();
	return 0;
}
