/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/


#ifndef CTL_CTL_H_
#define CTL_CTL_H_

#if defined CTL_ConnectC || defined CTL_ConnectF || defined CTL_ConnectP
#	define  CTL_Connect
#endif

#define CTL_LibBegin 		"ctl/gen/lib_begin.h"

#define CTL_LibEnd 			"ctl/gen/lib_end.h"
#define CTL_ClassBegin 	"ctl/gen/class_begin.h"

#define CTL_ClassEnd 		"ctl/gen/class_end.h"
#define CTL_ExpandAll 	"ctl/gen/expand.h"

#include "ctl/config.h"
#include "ctl/gen/ri.mcr"
#include "ctl/group.h"
#include "ctl/ci/ctl.ci"
#include "ctl/ci/commu.ci"




#if defined CTL_ConnectC || defined CTL_ConnectP || defined CTL_AnsiC || defined CTL_ClientC || defined CTL_ClientP
#	include "ctl/gen/c.h"
#elif defined CTL_ConnectF || defined CTL_Fortran || defined CTL_ClientF
#	include "ctl/gen/fortran.h"
#elif defined CTL_Connect
void CTL_Initialize() {}
void CTL_Finalize() {}
#endif

#ifndef CTL_Lib
#	include "ctl/inl/environment.inl"
#endif


#if defined(CTL_Connect)

static void CTL_connect();

extern "C"
{
  const char *CTL_getLocatorName()
	{
#ifdef CTL_Locate
		return CTL_Str(CTL_Locate);
#else
		return ctl::sys::getLocatorName();
#endif
	}


CTL_Export void CTL_openLibrary(void **vmyenv, void *venv, void *proc, const char *arg, const char* (*locator)(), void (*)())
{ 
	CTL_Initialize();
	ctl::openLibrary(vmyenv, venv, proc, arg, locator, CTL_connect); 
} 

CTL_Export void CTL_closeLibrary(void *venv, bool typ)
{ 
	ctl::closeLibrary(venv, typ);
	CTL_Finalize(); 
}

// ensure instantiation
void *CTL_openLibraryP = (void*)&CTL_openLibrary;
void *CTL_closeLibraryP = (void*)&CTL_closeLibrary;

#ifdef CTL_unSaveMT
CTL_Export void CTL_unsaveMT()
{}
void *CTL_unsaveMTP = (void*)&CTL_unsaveMT;
#endif


CTL_Export int main(int n, char **arg)
{
	CTL_Initialize();
	void *venv=0;
	int res=ctl::openMain(n, arg, &venv, 0, CTL_getLocatorName, CTL_connect); 
	CTL_Finalize(); 
	return res;
}

#	if defined CTL_Unix && defined __GNUC__ && defined CTL_Loader
	const char CTL_interp[] __attribute__((section(".interp"))) = CTL_Loader;
#	endif
//  entry point for dynamic library
CTL_Export void CTL_somain()
{
	enum { maxArg=1024 };
	char* arg[maxArg];
	int n=ctl::sys::getCommandArgs(arg, maxArg);
	(void)main(n, arg);
	exit(0);
}

} // extern "C"

#	endif

#endif






