/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL_MPI_H_
#define CTL_MPI_H_

#include <ctl.h>

namespace ctl
{

template<> class CommunicatorImpl<mpi> : public Communicator
{
	char *mpiBufferM;
	int mpiBufferSizeM; 
public:
	static void initMPI(int n =0, const char* const *arg =0);
	static int getLogIdS(int n , const char* const *arg, const location &loc);
   int write_(oStream&,const PID &dest ,int type) const;
   int test_(PID &source, int *type) const;
   int read_(iStream&, PID &source, int *type) const;
   CommunicatorImpl(int n, const char * const  *arg);
public:
	~CommunicatorImpl();
	channelT getType() const
	{ return mpi; }

};

} //ctl


#endif
