/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL_PVM_H_
#define CTL_PVM_H_

#include <stdlib.h>
#include <map>
#include <iostream>

#include <ctl.h>
#include "ctl/utl/timer.h"
 
namespace ctl
{

template<> class CommunicatorImpl<pvm> : public Communicator
{
	mutable std::map<int,int> pid2lid;
	mutable std::map<int,int> lid2pid;
protected:
	void initWithoutParent(const ctl::vector<location> &locV);
	void initWithParent(int parent);
public:
	static int getLogIdS(int n , const char* const *arg, const location &loc);
// called by ctlGroup(const ctl::vector<location> &loc,type=pvm)
	CommunicatorImpl(const ctl::vector<location> &loc =ctl::vector<location>()): Communicator(false)
	{ initWithoutParent(loc); 	}
// called by ctl init
	CommunicatorImpl(int , const char * const *);
 ~CommunicatorImpl()
  {
//	 ctl::log(envM, "#4 -- Communicator<pvm>\n");
  }

  int write_(oStream &,const PID &dest, int type) const;
  int read_ (iStream &, PID &source, int *type) const;
  int test_(PID &source, int *type) const;
	channelT getType() const
	{ return pvm; }

};

} // e.o ctl

#endif

