/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL_SERIAL_H_
#define CTL_SERIAL_H_

#include<stdio.h>
#include <string>
#include <list>

namespace ctl
{

template<> class CommunicatorImpl<serial> : public Communicator
{    
	struct item
	{
		void *buf;
		int size;
		int tag;
		item(void *b, int s, int t): buf(b), size(s), tag(t) {}
	};
	mutable std::list<item> queue;
	typedef std::list<item>::iterator iterator;
	int write_(oStream&, const PID & source , int tag) const;
	int test_(PID &source, int *type) const;
	int read_(iStream&  ,PID &source, int* type) const;
public:
  CommunicatorImpl(int =0, const char * const * =0): Communicator(false)
  { ctl::log(envM, "#m ++ Communicator<serial>\n"); set(0,1); }
   	~CommunicatorImpl() 
	{
		ctl::log(envM, "#m -- Communicator<serial>(%p)\n", this);
	}
	channelT getType() const
	{ return serial; }
};


} // ctl

#endif
