/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL_SERIAL_INL
#define CTL_SERIAL_INL

#include "serial.h"

namespace ctl
{

	CTL_Inline int CommunicatorImpl<serial>::write_(oStream &os, const PID & source , int tag) const
	{
		int size = os.size();
		(void)source;
		void *mm=(void *)new char[size];
		memcpy(mm,os.buffer(),size);
		queue.push_back(item(mm, size, tag));
		ctl::log(envM, "#m << serial: dest=%d size=%d tag=%d\n",int(source),size,tag);

		return size;
	}
   CTL_Inline int CommunicatorImpl<serial>::test_(PID &source, int *type) const
   {
  		source=0;
		for(iterator i=queue.begin(); i!=queue.end(); i++)
			if(*type<0 || i->tag==*type)
				return i->size;
  		return -1;
	}
   CTL_Inline int CommunicatorImpl<serial>::read_(iStream &is  ,PID &source, int* type) const
	{
		source = 0;
		for(iterator i=queue.begin(); i!=queue.end(); i++)
			if(*type<0 || i->tag==*type)
			{
				*type = i->tag;
				int size = i->size;
				is.setBuffer(size, 0);
				memcpy(is.buffer(), i->buf, size);
				queue.erase(i);
	   ctl::log(envM, "#m >> serial: src=%d size = %d tag = %d\n",int(source),size,*type);

				return size;
			}
		return -1;
	} 	

} // ctl

#endif

