/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL_ExpandMethod
#	define CTL_ExpandMethod(x)
#endif
#ifndef CTL_ExpandStaticMethod
#	define CTL_ExpandStaticMethod(x)
#endif
#ifndef CTL_ExpandConstructor
#	define CTL_ExpandConstructor(x)
#endif
#ifndef CTL_ExpandFunction
#	define CTL_ExpandFunction(x)
#endif
#ifndef CTL_ExpandFunctionTmpl
#	define CTL_ExpandFunctionTmpl(x)
#endif

#ifdef CTL_MaxCtrArgs
#	define CTL_GetMaxList(n) CTL_Get_2_2((CTL_Cat2(CTL_Constructor, n)))
#	define CTL_MaxList 0
#elif defined CTL_MaxTmplParam
#	define CTL_GetMaxList(n) CTL_Get_7_7((CTL_Cat2(CTL_FunctionTmpl, n)))
#	define CTL_MaxList 0
#else
#	undef CTL_GetMaxList 
#	undef CTL_MaxList
#endif

#define  CTL_StaticMethodDefined defined CTL_StaticMethod0
#define CTL_Count 0
#include "expand_func.h"

#define  CTL_MethodDefined defined CTL_Method1
#define  CTL_MethodThrowDefined defined CTL_Method1Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod1
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod1Throws
#define  CTL_ConstructorDefined defined CTL_Constructor1
#define  CTL_ConstructorThrowDefined defined CTL_Constructor1Throws
#define  CTL_FunctionDefined defined CTL_Function1
#define  CTL_FunctionThrowDefined defined CTL_Function1Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl1
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl1Throws
#define CTL_Count 1
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(1)
#endif

#define  CTL_MethodDefined defined CTL_Method2
#define  CTL_MethodThrowDefined defined CTL_Method2Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod2
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod2Throws
#define  CTL_ConstructorDefined defined CTL_Constructor2
#define  CTL_ConstructorThrowDefined defined CTL_Constructor2Throws
#define  CTL_FunctionDefined defined CTL_Function2
#define  CTL_FunctionThrowDefined defined CTL_Function2Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl2
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl2Throws
#define CTL_Count 2
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(2)
#endif

#define  CTL_MethodDefined defined CTL_Method3
#define  CTL_MethodThrowDefined defined CTL_Method3Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod3
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod3Throws
#define  CTL_ConstructorDefined defined CTL_Constructor3
#define  CTL_ConstructorThrowDefined defined CTL_Constructor3Throws
#define  CTL_FunctionDefined defined CTL_Function3
#define  CTL_FunctionThrowDefined defined CTL_Function3Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl3
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl3Throws
#define CTL_Count 3
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(3)
#endif

#define  CTL_MethodDefined defined CTL_Method4
#define  CTL_MethodThrowDefined defined CTL_Method4Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod4
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod4Throws
#define  CTL_ConstructorDefined defined CTL_Constructor4
#define  CTL_ConstructorThrowDefined defined CTL_Constructor4Throws
#define  CTL_FunctionDefined defined CTL_Function4
#define  CTL_FunctionThrowDefined defined CTL_Function4Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl4
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl4Throws
#define CTL_Count 4
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(4)
#endif

#define  CTL_MethodDefined defined CTL_Method5
#define  CTL_MethodThrowDefined defined CTL_Method5Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod5
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod5Throws
#define  CTL_ConstructorDefined defined CTL_Constructor5
#define  CTL_ConstructorThrowDefined defined CTL_Constructor5Throws
#define  CTL_FunctionDefined defined CTL_Function5
#define  CTL_FunctionThrowDefined defined CTL_Function5Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl5
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl5Throws
#define CTL_Count 5
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(5)
#endif

#define  CTL_MethodDefined defined CTL_Method6
#define  CTL_MethodThrowDefined defined CTL_Method6Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod6
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod6Throws
#define  CTL_ConstructorDefined defined CTL_Constructor6
#define  CTL_ConstructorThrowDefined defined CTL_Constructor6Throws
#define  CTL_FunctionDefined defined CTL_Function6
#define  CTL_FunctionThrowDefined defined CTL_Function6Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl6
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl6Throws
#define CTL_Count 6
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(6)
#endif

#define  CTL_MethodDefined defined CTL_Method7
#define  CTL_MethodThrowDefined defined CTL_Method7Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod7
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod7Throws
#define  CTL_ConstructorDefined defined CTL_Constructor7
#define  CTL_ConstructorThrowDefined defined CTL_Constructor7Throws
#define  CTL_FunctionDefined defined CTL_Function7
#define  CTL_FunctionThrowDefined defined CTL_Function7Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl7
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl7Throws
#define CTL_Count 7
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(7)
#endif

#define  CTL_MethodDefined defined CTL_Method8
#define  CTL_MethodThrowDefined defined CTL_Method8Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod8
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod8Throws
#define  CTL_ConstructorDefined defined CTL_Constructor8
#define  CTL_ConstructorThrowDefined defined CTL_Constructor8Throws
#define  CTL_FunctionDefined defined CTL_Function8
#define  CTL_FunctionThrowDefined defined CTL_Function8Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl8
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl8Throws
#define CTL_Count 8
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(8)
#endif

#define  CTL_MethodDefined defined CTL_Method9
#define  CTL_MethodThrowDefined defined CTL_Method9Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod9
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod9Throws
#define  CTL_ConstructorDefined defined CTL_Constructor9
#define  CTL_ConstructorThrowDefined defined CTL_Constructor9Throws
#define  CTL_FunctionDefined defined CTL_Function9
#define  CTL_FunctionThrowDefined defined CTL_Function9Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl9
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl9Throws
#define CTL_Count 9
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(9)
#endif

#define  CTL_MethodDefined defined CTL_Method10
#define  CTL_MethodThrowDefined defined CTL_Method10Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod10
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod10Throws
#define  CTL_ConstructorDefined defined CTL_Constructor10
#define  CTL_ConstructorThrowDefined defined CTL_Constructor10Throws
#define  CTL_FunctionDefined defined CTL_Function10
#define  CTL_FunctionThrowDefined defined CTL_Function10Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl10
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl10Throws
#define CTL_Count 10
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(10)
#endif

#define  CTL_MethodDefined defined CTL_Method11
#define  CTL_MethodThrowDefined defined CTL_Method11Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod11
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod11Throws
#define  CTL_ConstructorDefined defined CTL_Constructor11
#define  CTL_ConstructorThrowDefined defined CTL_Constructor11Throws
#define  CTL_FunctionDefined defined CTL_Function11
#define  CTL_FunctionThrowDefined defined CTL_Function11Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl11
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl11Throws
#define CTL_Count 11
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(11)
#endif

#define  CTL_MethodDefined defined CTL_Method12
#define  CTL_MethodThrowDefined defined CTL_Method12Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod12
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod12Throws
#define  CTL_ConstructorDefined defined CTL_Constructor12
#define  CTL_ConstructorThrowDefined defined CTL_Constructor12Throws
#define  CTL_FunctionDefined defined CTL_Function12
#define  CTL_FunctionThrowDefined defined CTL_Function12Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl12
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl12Throws
#define CTL_Count 12
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(12)
#endif

#define  CTL_MethodDefined defined CTL_Method13
#define  CTL_MethodThrowDefined defined CTL_Method13Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod13
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod13Throws
#define  CTL_ConstructorDefined defined CTL_Constructor13
#define  CTL_ConstructorThrowDefined defined CTL_Constructor13Throws
#define  CTL_FunctionDefined defined CTL_Function13
#define  CTL_FunctionThrowDefined defined CTL_Function13Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl13
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl13Throws
#define CTL_Count 13
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(13)
#endif

#define  CTL_MethodDefined defined CTL_Method14
#define  CTL_MethodThrowDefined defined CTL_Method14Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod14
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod14Throws
#define  CTL_ConstructorDefined defined CTL_Constructor14
#define  CTL_ConstructorThrowDefined defined CTL_Constructor14Throws
#define  CTL_FunctionDefined defined CTL_Function14
#define  CTL_FunctionThrowDefined defined CTL_Function14Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl14
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl14Throws
#define CTL_Count 14
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(14)
#endif

#define  CTL_MethodDefined defined CTL_Method15
#define  CTL_MethodThrowDefined defined CTL_Method15Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod15
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod15Throws
#define  CTL_ConstructorDefined defined CTL_Constructor15
#define  CTL_ConstructorThrowDefined defined CTL_Constructor15Throws
#define  CTL_FunctionDefined defined CTL_Function15
#define  CTL_FunctionThrowDefined defined CTL_Function15Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl15
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl15Throws
#define CTL_Count 15
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(15)
#endif

#define  CTL_MethodDefined defined CTL_Method16
#define  CTL_MethodThrowDefined defined CTL_Method16Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod16
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod16Throws
#define  CTL_ConstructorDefined defined CTL_Constructor16
#define  CTL_ConstructorThrowDefined defined CTL_Constructor16Throws
#define  CTL_FunctionDefined defined CTL_Function16
#define  CTL_FunctionThrowDefined defined CTL_Function16Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl16
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl16Throws
#define CTL_Count 16
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(16)
#endif

#define  CTL_MethodDefined defined CTL_Method17
#define  CTL_MethodThrowDefined defined CTL_Method17Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod17
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod17Throws
#define  CTL_ConstructorDefined defined CTL_Constructor17
#define  CTL_ConstructorThrowDefined defined CTL_Constructor17Throws
#define  CTL_FunctionDefined defined CTL_Function17
#define  CTL_FunctionThrowDefined defined CTL_Function17Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl17
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl17Throws
#define CTL_Count 17
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(17)
#endif

#define  CTL_MethodDefined defined CTL_Method18
#define  CTL_MethodThrowDefined defined CTL_Method18Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod18
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod18Throws
#define  CTL_ConstructorDefined defined CTL_Constructor18
#define  CTL_ConstructorThrowDefined defined CTL_Constructor18Throws
#define  CTL_FunctionDefined defined CTL_Function18
#define  CTL_FunctionThrowDefined defined CTL_Function18Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl18
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl18Throws
#define CTL_Count 18
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(18)
#endif

#define  CTL_MethodDefined defined CTL_Method19
#define  CTL_MethodThrowDefined defined CTL_Method19Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod19
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod19Throws
#define  CTL_ConstructorDefined defined CTL_Constructor19
#define  CTL_ConstructorThrowDefined defined CTL_Constructor19Throws
#define  CTL_FunctionDefined defined CTL_Function19
#define  CTL_FunctionThrowDefined defined CTL_Function19Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl19
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl19Throws
#define CTL_Count 19
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(19)
#endif

#define  CTL_MethodDefined defined CTL_Method20
#define  CTL_MethodThrowDefined defined CTL_Method20Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod20
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod20Throws
#define  CTL_ConstructorDefined defined CTL_Constructor20
#define  CTL_ConstructorThrowDefined defined CTL_Constructor20Throws
#define  CTL_FunctionDefined defined CTL_Function20
#define  CTL_FunctionThrowDefined defined CTL_Function20Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl20
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl20Throws
#define CTL_Count 20
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(20)
#endif

#define  CTL_MethodDefined defined CTL_Method21
#define  CTL_MethodThrowDefined defined CTL_Method21Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod21
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod21Throws
#define  CTL_ConstructorDefined defined CTL_Constructor21
#define  CTL_ConstructorThrowDefined defined CTL_Constructor21Throws
#define  CTL_FunctionDefined defined CTL_Function21
#define  CTL_FunctionThrowDefined defined CTL_Function21Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl21
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl21Throws
#define CTL_Count 21
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(21)
#endif

#define  CTL_MethodDefined defined CTL_Method22
#define  CTL_MethodThrowDefined defined CTL_Method22Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod22
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod22Throws
#define  CTL_ConstructorDefined defined CTL_Constructor22
#define  CTL_ConstructorThrowDefined defined CTL_Constructor22Throws
#define  CTL_FunctionDefined defined CTL_Function22
#define  CTL_FunctionThrowDefined defined CTL_Function22Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl22
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl22Throws
#define CTL_Count 22
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(22)
#endif

#define  CTL_MethodDefined defined CTL_Method23
#define  CTL_MethodThrowDefined defined CTL_Method23Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod23
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod23Throws
#define  CTL_ConstructorDefined defined CTL_Constructor23
#define  CTL_ConstructorThrowDefined defined CTL_Constructor23Throws
#define  CTL_FunctionDefined defined CTL_Function23
#define  CTL_FunctionThrowDefined defined CTL_Function23Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl23
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl23Throws
#define CTL_Count 23
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(23)
#endif

#define  CTL_MethodDefined defined CTL_Method24
#define  CTL_MethodThrowDefined defined CTL_Method24Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod24
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod24Throws
#define  CTL_ConstructorDefined defined CTL_Constructor24
#define  CTL_ConstructorThrowDefined defined CTL_Constructor24Throws
#define  CTL_FunctionDefined defined CTL_Function24
#define  CTL_FunctionThrowDefined defined CTL_Function24Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl24
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl24Throws
#define CTL_Count 24
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(24)
#endif

#define  CTL_MethodDefined defined CTL_Method25
#define  CTL_MethodThrowDefined defined CTL_Method25Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod25
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod25Throws
#define  CTL_ConstructorDefined defined CTL_Constructor25
#define  CTL_ConstructorThrowDefined defined CTL_Constructor25Throws
#define  CTL_FunctionDefined defined CTL_Function25
#define  CTL_FunctionThrowDefined defined CTL_Function25Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl25
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl25Throws
#define CTL_Count 25
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(25)
#endif

#define  CTL_MethodDefined defined CTL_Method26
#define  CTL_MethodThrowDefined defined CTL_Method26Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod26
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod26Throws
#define  CTL_ConstructorDefined defined CTL_Constructor26
#define  CTL_ConstructorThrowDefined defined CTL_Constructor26Throws
#define  CTL_FunctionDefined defined CTL_Function26
#define  CTL_FunctionThrowDefined defined CTL_Function26Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl26
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl26Throws
#define CTL_Count 26
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(26)
#endif

#define  CTL_MethodDefined defined CTL_Method27
#define  CTL_MethodThrowDefined defined CTL_Method27Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod27
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod27Throws
#define  CTL_ConstructorDefined defined CTL_Constructor27
#define  CTL_ConstructorThrowDefined defined CTL_Constructor27Throws
#define  CTL_FunctionDefined defined CTL_Function27
#define  CTL_FunctionThrowDefined defined CTL_Function27Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl27
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl27Throws
#define CTL_Count 27
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(27)
#endif

#define  CTL_MethodDefined defined CTL_Method28
#define  CTL_MethodThrowDefined defined CTL_Method28Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod28
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod28Throws
#define  CTL_ConstructorDefined defined CTL_Constructor28
#define  CTL_ConstructorThrowDefined defined CTL_Constructor28Throws
#define  CTL_FunctionDefined defined CTL_Function28
#define  CTL_FunctionThrowDefined defined CTL_Function28Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl28
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl28Throws
#define CTL_Count 28
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(28)
#endif

#define  CTL_MethodDefined defined CTL_Method29
#define  CTL_MethodThrowDefined defined CTL_Method29Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod29
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod29Throws
#define  CTL_ConstructorDefined defined CTL_Constructor29
#define  CTL_ConstructorThrowDefined defined CTL_Constructor29Throws
#define  CTL_FunctionDefined defined CTL_Function29
#define  CTL_FunctionThrowDefined defined CTL_Function29Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl29
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl29Throws
#define CTL_Count 29
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(29)
#endif

#define  CTL_MethodDefined defined CTL_Method30
#define  CTL_MethodThrowDefined defined CTL_Method30Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod30
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod30Throws
#define  CTL_ConstructorDefined defined CTL_Constructor30
#define  CTL_ConstructorThrowDefined defined CTL_Constructor30Throws
#define  CTL_FunctionDefined defined CTL_Function30
#define  CTL_FunctionThrowDefined defined CTL_Function30Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl30
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl30Throws
#define CTL_Count 30
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(30)
#endif

#define  CTL_MethodDefined defined CTL_Method31
#define  CTL_MethodThrowDefined defined CTL_Method31Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod31
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod31Throws
#define  CTL_ConstructorDefined defined CTL_Constructor31
#define  CTL_ConstructorThrowDefined defined CTL_Constructor31Throws
#define  CTL_FunctionDefined defined CTL_Function31
#define  CTL_FunctionThrowDefined defined CTL_Function31Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl31
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl31Throws
#define CTL_Count 31
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(31)
#endif

#define  CTL_MethodDefined defined CTL_Method32
#define  CTL_MethodThrowDefined defined CTL_Method32Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod32
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod32Throws
#define  CTL_ConstructorDefined defined CTL_Constructor32
#define  CTL_ConstructorThrowDefined defined CTL_Constructor32Throws
#define  CTL_FunctionDefined defined CTL_Function32
#define  CTL_FunctionThrowDefined defined CTL_Function32Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl32
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl32Throws
#define CTL_Count 32
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(32)
#endif

#define  CTL_MethodDefined defined CTL_Method33
#define  CTL_MethodThrowDefined defined CTL_Method33Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod33
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod33Throws
#define  CTL_ConstructorDefined defined CTL_Constructor33
#define  CTL_ConstructorThrowDefined defined CTL_Constructor33Throws
#define  CTL_FunctionDefined defined CTL_Function33
#define  CTL_FunctionThrowDefined defined CTL_Function33Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl33
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl33Throws
#define CTL_Count 33
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(33)
#endif

#define  CTL_MethodDefined defined CTL_Method34
#define  CTL_MethodThrowDefined defined CTL_Method34Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod34
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod34Throws
#define  CTL_ConstructorDefined defined CTL_Constructor34
#define  CTL_ConstructorThrowDefined defined CTL_Constructor34Throws
#define  CTL_FunctionDefined defined CTL_Function34
#define  CTL_FunctionThrowDefined defined CTL_Function34Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl34
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl34Throws
#define CTL_Count 34
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(34)
#endif

#define  CTL_MethodDefined defined CTL_Method35
#define  CTL_MethodThrowDefined defined CTL_Method35Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod35
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod35Throws
#define  CTL_ConstructorDefined defined CTL_Constructor35
#define  CTL_ConstructorThrowDefined defined CTL_Constructor35Throws
#define  CTL_FunctionDefined defined CTL_Function35
#define  CTL_FunctionThrowDefined defined CTL_Function35Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl35
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl35Throws
#define CTL_Count 35
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(35)
#endif

#define  CTL_MethodDefined defined CTL_Method36
#define  CTL_MethodThrowDefined defined CTL_Method36Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod36
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod36Throws
#define  CTL_ConstructorDefined defined CTL_Constructor36
#define  CTL_ConstructorThrowDefined defined CTL_Constructor36Throws
#define  CTL_FunctionDefined defined CTL_Function36
#define  CTL_FunctionThrowDefined defined CTL_Function36Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl36
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl36Throws
#define CTL_Count 36
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(36)
#endif

#define  CTL_MethodDefined defined CTL_Method37
#define  CTL_MethodThrowDefined defined CTL_Method37Throws
#define  CTL_StaticMethodDefined defined CTL_StaticMethod37
#define  CTL_StaticMethodThrowDefined defined CTL_StaticMethod37Throws
#define  CTL_ConstructorDefined defined CTL_Constructor37
#define  CTL_ConstructorThrowDefined defined CTL_Constructor37Throws
#define  CTL_FunctionDefined defined CTL_Function37
#define  CTL_FunctionThrowDefined defined CTL_Function37Throws
#define  CTL_FunctionTmplDefined defined CTL_FunctionTmpl37
#define  CTL_FunctionTmplThrowDefined defined CTL_FunctionTmpl37Throws
#define CTL_Count 37
#include "expand_func.h"
#ifdef CTL_SetMaxList
#	define CTL_MaxList CTL_GetMaxList(37)
#endif

#ifdef CTL_UndefMethods
#	undef CTL_Method1
#	undef CTL_Method1Throws
#	undef CTL_Constructor1
#	undef CTL_Constructor1Throws
#	undef CTL_StaticMethod1
#	undef CTL_StaticMethod1Throws
#	undef CTL_Method2
#	undef CTL_Method2Throws
#	undef CTL_Constructor2
#	undef CTL_Constructor2Throws
#	undef CTL_StaticMethod2
#	undef CTL_StaticMethod2Throws
#	undef CTL_Method3
#	undef CTL_Method3Throws
#	undef CTL_Constructor3
#	undef CTL_Constructor3Throws
#	undef CTL_StaticMethod3
#	undef CTL_StaticMethod3Throws
#	undef CTL_Method4
#	undef CTL_Method4Throws
#	undef CTL_Constructor4
#	undef CTL_Constructor4Throws
#	undef CTL_StaticMethod4
#	undef CTL_StaticMethod4Throws
#	undef CTL_Method5
#	undef CTL_Method5Throws
#	undef CTL_Constructor5
#	undef CTL_Constructor5Throws
#	undef CTL_StaticMethod5
#	undef CTL_StaticMethod5Throws
#	undef CTL_Method6
#	undef CTL_Method6Throws
#	undef CTL_Constructor6
#	undef CTL_Constructor6Throws
#	undef CTL_StaticMethod6
#	undef CTL_StaticMethod6Throws
#	undef CTL_Method7
#	undef CTL_Method7Throws
#	undef CTL_Constructor7
#	undef CTL_Constructor7Throws
#	undef CTL_StaticMethod7
#	undef CTL_StaticMethod7Throws
#	undef CTL_Method8
#	undef CTL_Method8Throws
#	undef CTL_Constructor8
#	undef CTL_Constructor8Throws
#	undef CTL_StaticMethod8
#	undef CTL_StaticMethod8Throws
#	undef CTL_Method9
#	undef CTL_Method9Throws
#	undef CTL_Constructor9
#	undef CTL_Constructor9Throws
#	undef CTL_StaticMethod9
#	undef CTL_StaticMethod9Throws
#	undef CTL_Method10
#	undef CTL_Method10Throws
#	undef CTL_Constructor10
#	undef CTL_Constructor10Throws
#	undef CTL_StaticMethod10
#	undef CTL_StaticMethod10Throws
#	undef CTL_Method11
#	undef CTL_Method11Throws
#	undef CTL_Constructor11
#	undef CTL_Constructor11Throws
#	undef CTL_StaticMethod11
#	undef CTL_StaticMethod11Throws
#	undef CTL_Method12
#	undef CTL_Method12Throws
#	undef CTL_Constructor12
#	undef CTL_Constructor12Throws
#	undef CTL_StaticMethod12
#	undef CTL_StaticMethod12Throws
#	undef CTL_Method13
#	undef CTL_Method13Throws
#	undef CTL_Constructor13
#	undef CTL_Constructor13Throws
#	undef CTL_StaticMethod13
#	undef CTL_StaticMethod13Throws
#	undef CTL_Method14
#	undef CTL_Method14Throws
#	undef CTL_Constructor14
#	undef CTL_Constructor14Throws
#	undef CTL_StaticMethod14
#	undef CTL_StaticMethod14Throws
#	undef CTL_Method15
#	undef CTL_Method15Throws
#	undef CTL_Constructor15
#	undef CTL_Constructor15Throws
#	undef CTL_StaticMethod15
#	undef CTL_StaticMethod15Throws
#	undef CTL_Method16
#	undef CTL_Method16Throws
#	undef CTL_Constructor16
#	undef CTL_Constructor16Throws
#	undef CTL_StaticMethod16
#	undef CTL_StaticMethod16Throws
#	undef CTL_Method17
#	undef CTL_Method17Throws
#	undef CTL_Constructor17
#	undef CTL_Constructor17Throws
#	undef CTL_StaticMethod17
#	undef CTL_StaticMethod17Throws
#	undef CTL_Method18
#	undef CTL_Method18Throws
#	undef CTL_Constructor18
#	undef CTL_Constructor18Throws
#	undef CTL_StaticMethod18
#	undef CTL_StaticMethod18Throws
#	undef CTL_Method19
#	undef CTL_Method19Throws
#	undef CTL_Constructor19
#	undef CTL_Constructor19Throws
#	undef CTL_StaticMethod19
#	undef CTL_StaticMethod19Throws
#	undef CTL_Method20
#	undef CTL_Method20Throws
#	undef CTL_Constructor20
#	undef CTL_Constructor20Throws
#	undef CTL_StaticMethod20
#	undef CTL_StaticMethod20Throws
#	undef CTL_Method21
#	undef CTL_Method21Throws
#	undef CTL_Constructor21
#	undef CTL_Constructor21Throws
#	undef CTL_StaticMethod21
#	undef CTL_StaticMethod21Throws
#	undef CTL_Method22
#	undef CTL_Method22Throws
#	undef CTL_Constructor22
#	undef CTL_Constructor22Throws
#	undef CTL_StaticMethod22
#	undef CTL_StaticMethod22Throws
#	undef CTL_Method23
#	undef CTL_Method23Throws
#	undef CTL_Constructor23
#	undef CTL_Constructor23Throws
#	undef CTL_StaticMethod23
#	undef CTL_StaticMethod23Throws
#	undef CTL_Method24
#	undef CTL_Method24Throws
#	undef CTL_Constructor24
#	undef CTL_Constructor24Throws
#	undef CTL_StaticMethod24
#	undef CTL_StaticMethod24Throws
#	undef CTL_Method25
#	undef CTL_Method25Throws
#	undef CTL_Constructor25
#	undef CTL_Constructor25Throws
#	undef CTL_StaticMethod25
#	undef CTL_StaticMethod25Throws
#	undef CTL_Method26
#	undef CTL_Method26Throws
#	undef CTL_Constructor26
#	undef CTL_Constructor26Throws
#	undef CTL_StaticMethod26
#	undef CTL_StaticMethod26Throws
#	undef CTL_Method27
#	undef CTL_Method27Throws
#	undef CTL_Constructor27
#	undef CTL_Constructor27Throws
#	undef CTL_StaticMethod27
#	undef CTL_StaticMethod27Throws
#	undef CTL_Method28
#	undef CTL_Method28Throws
#	undef CTL_Constructor28
#	undef CTL_Constructor28Throws
#	undef CTL_StaticMethod28
#	undef CTL_StaticMethod28Throws
#	undef CTL_Method29
#	undef CTL_Method29Throws
#	undef CTL_Constructor29
#	undef CTL_Constructor29Throws
#	undef CTL_StaticMethod29
#	undef CTL_StaticMethod29Throws
#	undef CTL_Method30
#	undef CTL_Method30Throws
#	undef CTL_Constructor30
#	undef CTL_Constructor30Throws
#	undef CTL_StaticMethod30
#	undef CTL_StaticMethod30Throws
#	undef CTL_Method31
#	undef CTL_Method31Throws
#	undef CTL_Constructor31
#	undef CTL_Constructor31Throws
#	undef CTL_StaticMethod31
#	undef CTL_StaticMethod31Throws
#	undef CTL_Method32
#	undef CTL_Method32Throws
#	undef CTL_Constructor32
#	undef CTL_Constructor32Throws
#	undef CTL_StaticMethod32
#	undef CTL_StaticMethod32Throws
#	undef CTL_Method33
#	undef CTL_Method33Throws
#	undef CTL_Constructor33
#	undef CTL_Constructor33Throws
#	undef CTL_StaticMethod33
#	undef CTL_StaticMethod33Throws
#	undef CTL_Method34
#	undef CTL_Method34Throws
#	undef CTL_Constructor34
#	undef CTL_Constructor34Throws
#	undef CTL_StaticMethod34
#	undef CTL_StaticMethod34Throws
#	undef CTL_Method35
#	undef CTL_Method35Throws
#	undef CTL_Constructor35
#	undef CTL_Constructor35Throws
#	undef CTL_StaticMethod35
#	undef CTL_StaticMethod35Throws
#	undef CTL_Method36
#	undef CTL_Method36Throws
#	undef CTL_Constructor36
#	undef CTL_Constructor36Throws
#	undef CTL_StaticMethod36
#	undef CTL_StaticMethod36Throws
#	undef CTL_Method37
#	undef CTL_Method37Throws
#	undef CTL_Constructor37
#	undef CTL_Constructor37Throws
#	undef CTL_StaticMethod37
#	undef CTL_StaticMethod37Throws

#endif

#ifdef CTL_UndefFunctions
#	undef CTL_Function1
#	undef CTL_Function1Throws
#	undef CTL_FunctionTmpl1
#	undef CTL_FunctionTmpl1Throws
#	undef CTL_Function2
#	undef CTL_Function2Throws
#	undef CTL_FunctionTmpl2
#	undef CTL_FunctionTmpl2Throws
#	undef CTL_Function3
#	undef CTL_Function3Throws
#	undef CTL_FunctionTmpl3
#	undef CTL_FunctionTmpl3Throws
#	undef CTL_Function4
#	undef CTL_Function4Throws
#	undef CTL_FunctionTmpl4
#	undef CTL_FunctionTmpl4Throws
#	undef CTL_Function5
#	undef CTL_Function5Throws
#	undef CTL_FunctionTmpl5
#	undef CTL_FunctionTmpl5Throws
#	undef CTL_Function6
#	undef CTL_Function6Throws
#	undef CTL_FunctionTmpl6
#	undef CTL_FunctionTmpl6Throws
#	undef CTL_Function7
#	undef CTL_Function7Throws
#	undef CTL_FunctionTmpl7
#	undef CTL_FunctionTmpl7Throws
#	undef CTL_Function8
#	undef CTL_Function8Throws
#	undef CTL_FunctionTmpl8
#	undef CTL_FunctionTmpl8Throws
#	undef CTL_Function9
#	undef CTL_Function9Throws
#	undef CTL_FunctionTmpl9
#	undef CTL_FunctionTmpl9Throws
#	undef CTL_Function10
#	undef CTL_Function10Throws
#	undef CTL_FunctionTmpl10
#	undef CTL_FunctionTmpl10Throws
#	undef CTL_Function11
#	undef CTL_Function11Throws
#	undef CTL_FunctionTmpl11
#	undef CTL_FunctionTmpl11Throws
#	undef CTL_Function12
#	undef CTL_Function12Throws
#	undef CTL_FunctionTmpl12
#	undef CTL_FunctionTmpl12Throws
#	undef CTL_Function13
#	undef CTL_Function13Throws
#	undef CTL_FunctionTmpl13
#	undef CTL_FunctionTmpl13Throws
#	undef CTL_Function14
#	undef CTL_Function14Throws
#	undef CTL_FunctionTmpl14
#	undef CTL_FunctionTmpl14Throws
#	undef CTL_Function15
#	undef CTL_Function15Throws
#	undef CTL_FunctionTmpl15
#	undef CTL_FunctionTmpl15Throws
#	undef CTL_Function16
#	undef CTL_Function16Throws
#	undef CTL_FunctionTmpl16
#	undef CTL_FunctionTmpl16Throws
#	undef CTL_Function17
#	undef CTL_Function17Throws
#	undef CTL_FunctionTmpl17
#	undef CTL_FunctionTmpl17Throws
#	undef CTL_Function18
#	undef CTL_Function18Throws
#	undef CTL_FunctionTmpl18
#	undef CTL_FunctionTmpl18Throws
#	undef CTL_Function19
#	undef CTL_Function19Throws
#	undef CTL_FunctionTmpl19
#	undef CTL_FunctionTmpl19Throws
#	undef CTL_Function20
#	undef CTL_Function20Throws
#	undef CTL_FunctionTmpl20
#	undef CTL_FunctionTmpl20Throws
#	undef CTL_Function21
#	undef CTL_Function21Throws
#	undef CTL_FunctionTmpl21
#	undef CTL_FunctionTmpl21Throws
#	undef CTL_Function22
#	undef CTL_Function22Throws
#	undef CTL_FunctionTmpl22
#	undef CTL_FunctionTmpl22Throws
#	undef CTL_Function23
#	undef CTL_Function23Throws
#	undef CTL_FunctionTmpl23
#	undef CTL_FunctionTmpl23Throws
#	undef CTL_Function24
#	undef CTL_Function24Throws
#	undef CTL_FunctionTmpl24
#	undef CTL_FunctionTmpl24Throws
#	undef CTL_Function25
#	undef CTL_Function25Throws
#	undef CTL_FunctionTmpl25
#	undef CTL_FunctionTmpl25Throws
#	undef CTL_Function26
#	undef CTL_Function26Throws
#	undef CTL_FunctionTmpl26
#	undef CTL_FunctionTmpl26Throws
#	undef CTL_Function27
#	undef CTL_Function27Throws
#	undef CTL_FunctionTmpl27
#	undef CTL_FunctionTmpl27Throws
#	undef CTL_Function28
#	undef CTL_Function28Throws
#	undef CTL_FunctionTmpl28
#	undef CTL_FunctionTmpl28Throws
#	undef CTL_Function29
#	undef CTL_Function29Throws
#	undef CTL_FunctionTmpl29
#	undef CTL_FunctionTmpl29Throws
#	undef CTL_Function30
#	undef CTL_Function30Throws
#	undef CTL_FunctionTmpl30
#	undef CTL_FunctionTmpl30Throws
#	undef CTL_Function31
#	undef CTL_Function31Throws
#	undef CTL_FunctionTmpl31
#	undef CTL_FunctionTmpl31Throws
#	undef CTL_Function32
#	undef CTL_Function32Throws
#	undef CTL_FunctionTmpl32
#	undef CTL_FunctionTmpl32Throws
#	undef CTL_Function33
#	undef CTL_Function33Throws
#	undef CTL_FunctionTmpl33
#	undef CTL_FunctionTmpl33Throws
#	undef CTL_Function34
#	undef CTL_Function34Throws
#	undef CTL_FunctionTmpl34
#	undef CTL_FunctionTmpl34Throws
#	undef CTL_Function35
#	undef CTL_Function35Throws
#	undef CTL_FunctionTmpl35
#	undef CTL_FunctionTmpl35Throws
#	undef CTL_Function36
#	undef CTL_Function36Throws
#	undef CTL_FunctionTmpl36
#	undef CTL_FunctionTmpl36Throws
#	undef CTL_Function37
#	undef CTL_Function37Throws
#	undef CTL_FunctionTmpl37
#	undef CTL_FunctionTmpl37Throws

#endif

#undef CTL_ExpandMethod
#undef CTL_ExpandStaticMethod
#undef CTL_ExpandConstructor
#undef CTL_ExpandFunction
#undef CTL_ExpandFunctionTmpl

