/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#	undef CTL_SetMaxList

#if defined CTL_LogOff || defined CTL_NoLog
#	define CTL_Pretty (const char*)0
#else
#	define CTL_Pretty pretty
#endif

#define CTL_ArgX(X,n) CTL_Cat5(CTL_, X, CTL_Count,_,n)
#if CTL_MethodDefined
#	if CTL_MethodThrowDefined
#		define CTL_Throws ( CTL_Cat3(CTL_Method,CTL_Count, Throws) )
#	else
#		define CTL_Throws ( (), 0 )
#	endif
	CTL_ExpandMethod ((CTL_Count, CTL_Cat2(CTL_Method,CTL_Count)))
#undef CTL_Throws
#endif

#if CTL_StaticMethodDefined
#	if CTL_StaticMethodThrowDefined
#		define CTL_Throws ( CTL_Cat3(CTL_StaticMethod,CTL_Count, Throws) )
#	else
#		define CTL_Throws  ( (), 0 )
#	endif
	CTL_ExpandStaticMethod ((CTL_Count, CTL_Cat2(CTL_StaticMethod,CTL_Count)))
#undef  CTL_Throws
#endif

#if CTL_ConstructorDefined
#	if CTL_ConstructorThrowDefined
#		define CTL_Throws ( CTL_Cat3(CTL_Constructor,CTL_Count, Throws) )
#	else
#		define CTL_Throws ( (), 0 )
#	endif
	CTL_ExpandConstructor ((CTL_Count, CTL_Cat2(CTL_Constructor,CTL_Count)))
#undef CTL_Throws

#if defined(CTL_MaxCtrArgs)
#	if CTL_MaxList < CTL_GetMaxList(CTL_Count)
#		define CTL_SetMaxList
#		undef CTL_MaxList
#	endif
#endif 

#endif

#if CTL_FunctionDefined
#	ifndef CTL_Typename
#		define CTL_Typename
#		define CTL_TypenameSet 
#	endif
#	if CTL_FunctionThrowDefined
#		define CTL_Throws ( CTL_Cat3(CTL_Function,CTL_Count, Throws) )
#	else
#		define CTL_Throws ( (), 0 )
#	endif
	CTL_ExpandFunction ((CTL_Count, CTL_Cat2(CTL_Function,CTL_Count)))
#undef CTL_Throws
#	ifdef CTL_TypenameSet 
#		undef CTL_Typename
#		undef CTL_TypenameSet
#	endif
#endif

#if CTL_FunctionTmplDefined
#	ifndef CTL_Typename
#		define CTL_Typename typename
#		define CTL_TypenameSet 
#	endif
#	if CTL_FunctionTmplThrowDefined
#		define CTL_Throws ( CTL_Cat3(CTL_FunctionTmpl,CTL_Count, Throws) )
#	else
#		define CTL_Throws ( (), 0  )
#	endif
	CTL_ExpandFunctionTmpl ((CTL_Count, CTL_Cat2(CTL_FunctionTmpl,CTL_Count)))
#undef CTL_Throws
#	ifdef CTL_TypenameSet 
#		undef CTL_Typename
#		undef CTL_TypenameSet
#	endif
#endif

#undef CTL_MethodDefined
#undef CTL_MethodThrowDefined
#undef CTL_StaticMethodDefined
#undef CTL_StaticMethodThrowDefined
#undef CTL_ConstructorDefined
#undef CTL_ConstructorThrowDefined
#undef CTL_FunctionDefined
#undef CTL_FunctionThrowDefined
#undef CTL_FunctionTmplDefined
#undef CTL_FunctionTmplThrowDefined
#undef CTL_Count
#undef CTL_ArgX
#undef CTL_Pretty





