/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL_FORTRAN_MCR_
#define CTL_FORTRAN_MCR_

#define CTL_FortranTypeH(BraExpr,n,macro) macro BraExpr,n

#define CTL_FortranQualconst CTL_FortranTypeH (CTL_Bra
#define CTL_FortranQualchar CTL_FortranTypeH  (CTL_Bra char
#define CTL_FortranQualint2 CTL_FortranTypeH  (CTL_Bra int2
#define CTL_FortranQualuint2 CTL_FortranTypeH  (CTL_Bra uint2
#define CTL_FortranQualint4 CTL_FortranTypeH  (CTL_Bra int4
#define CTL_FortranQualint CTL_FortranTypeH  (CTL_Bra int4
#define CTL_FortranQualuint4 CTL_FortranTypeH  (CTL_Bra uint4
#define CTL_FortranQualint8 CTL_FortranTypeH  (CTL_Bra int8
#define CTL_FortranQualuint8 CTL_FortranTypeH  (CTL_Bra uint8
#define CTL_FortranQualreal4 CTL_FortranTypeH (CTL_Bra real4
#define CTL_FortranQualreal8 CTL_FortranTypeH (CTL_Bra real8
#define CTL_FortranQualscalar1 CTL_FortranTypeH (CTL_Bra scalar1
#define CTL_FortranQualscalar2 CTL_FortranTypeH (CTL_Bra scalar2
#define CTL_FortranQualscalar3 CTL_FortranTypeH (CTL_Bra scalar3
#define CTL_FortranQualscalar4 CTL_FortranTypeH (CTL_Bra scalar4
#define CTL_FortranQualscalar5 CTL_FortranTypeH (CTL_Bra scalar5
#define CTL_FortranQualscalar6 CTL_FortranTypeH (CTL_Bra scalar6
#define CTL_FortranQualscalar7 CTL_FortranTypeH (CTL_Bra scalar7
#define CTL_FortranQualscalar8 CTL_FortranTypeH (CTL_Bra scalar8
#define CTL_FortranQualarray CTL_FortranTypeH (CTL_Bra array
#define CTL_FortranQualstring CTL_FortranTypeH (CTL_Bra string
#define CTL_FortranQualvoid CTL_FortranTypeH (CTL_Bra void

#define CTL_Fortran_IVec(_,n) int8 *s##n,
#define CTL_Fortran_IStd(_,n)
#define CTL_Fortran_Ichar CTL_Fortran_IStd(_
#define CTL_Fortran_Iint2 CTL_Fortran_IStd(_
#define CTL_Fortran_Iuint2 CTL_Fortran_IStd(_
#define CTL_Fortran_Iint4 CTL_Fortran_IStd(_
#define CTL_Fortran_Iint CTL_Fortran_IStd(_
#define CTL_Fortran_Iuint4 CTL_Fortran_IStd(_
#define CTL_Fortran_Iint8 CTL_Fortran_IStd(_
#define CTL_Fortran_Iuint8 CTL_Fortran_IStd(_
#define CTL_Fortran_Ireal4 CTL_Fortran_IStd(_
#define CTL_Fortran_Ireal8 CTL_Fortran_IStd(_
#define CTL_Fortran_Iscalar1 CTL_Fortran_IStd(_
#define CTL_Fortran_Iscalar2 CTL_Fortran_IStd(_
#define CTL_Fortran_Iscalar3 CTL_Fortran_IStd(_
#define CTL_Fortran_Iscalar4 CTL_Fortran_IStd(_
#define CTL_Fortran_Iscalar5 CTL_Fortran_IStd(_
#define CTL_Fortran_Iscalar6 CTL_Fortran_IStd(_
#define CTL_Fortran_Iscalar7 CTL_Fortran_IStd(_
#define CTL_Fortran_Iscalar8 CTL_Fortran_IStd(_
#define CTL_Fortran_Iarray CTL_Fortran_IVec(_
#define CTL_Fortran_Istring CTL_Fortran_IVec(_
#define CTL_Fortran_Ivoid


#define CTL_Fortran_GG(T,n) CTL_Cat2(CTL_Fortran_G,T) ,n)

#define CTL_Fortran_Gconst  CTL_Fortran_GG(
#define CTL_Fortran_GVec(_,n) s##n, y##n
#define CTL_Fortran_GStd(_,n) y##n
#define CTL_Fortran_Gchar CTL_Fortran_GStd(_
#define CTL_Fortran_Gint2 CTL_Fortran_GStd(_
#define CTL_Fortran_Guint2 CTL_Fortran_GStd(_
#define CTL_Fortran_Gint4 CTL_Fortran_GStd(_
#define CTL_Fortran_Guint4 CTL_Fortran_GStd(_
#define CTL_Fortran_Gint8 CTL_Fortran_GStd(_
#define CTL_Fortran_Guint8 CTL_Fortran_GStd(_
#define CTL_Fortran_Greal4 CTL_Fortran_GStd(_
#define CTL_Fortran_Greal8 CTL_Fortran_GStd(_
#define CTL_Fortran_Gscalar1 CTL_Fortran_GStd(_
#define CTL_Fortran_Gscalar2 CTL_Fortran_GStd(_
#define CTL_Fortran_Gscalar3 CTL_Fortran_GStd(_
#define CTL_Fortran_Gscalar4 CTL_Fortran_GStd(_
#define CTL_Fortran_Gscalar5 CTL_Fortran_GStd(_
#define CTL_Fortran_Gscalar6 CTL_Fortran_GStd(_
#define CTL_Fortran_Gscalar7 CTL_Fortran_GStd(_
#define CTL_Fortran_Gscalar8 CTL_Fortran_GStd(_
#define CTL_Fortran_Garray CTL_Fortran_GVec(_
#define CTL_Fortran_Gstring CTL_Fortran_GVec(_
#define CTL_Fortran_Gvoid

#define CTL_Fortran_HVec(_,n) x##n.sM, x##n.tM
#define CTL_Fortran_HStd(_,n) &x##n
#define CTL_Fortran_Hchar (char*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hint2 (int2*) CTL_Fortran_HStd(_
#define CTL_Fortran_Huint2 (uint2*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hint (int4*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hint4 (int4*) CTL_Fortran_HStd(_
#define CTL_Fortran_Huint4 (uint4*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hint8 (int8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Huint8 (uint8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hreal4 (real4*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hreal8 (real8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hscalar1 (real8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hscalar2 (real8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hscalar3 (real8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hscalar4 (real8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hscalar5 (real8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hscalar6 (real8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hscalar7 (real8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Hscalar8 (real8*) CTL_Fortran_HStd(_
#define CTL_Fortran_Harray CTL_Fortran_HVec(_
#define CTL_Fortran_Hstring CTL_Fortran_HVec(_
#define CTL_Fortran_Hvoid

#define CTL_Fortran_PVec(_,n) "       "<<"integer*8 s"<<n<<"\n"<<
#define CTL_Fortran_PStd(_,n)
#define CTL_Fortran_Pchar CTL_Fortran_PStd(_
#define CTL_Fortran_Pint2 CTL_Fortran_PStd(_
#define CTL_Fortran_Pint4 CTL_Fortran_PStd(_
#define CTL_Fortran_Pint CTL_Fortran_PStd(_
#define CTL_Fortran_Pint8 CTL_Fortran_PStd(_
#define CTL_Fortran_Preal4 CTL_Fortran_PStd(_
#define CTL_Fortran_Preal8 CTL_Fortran_PStd(_
#define CTL_Fortran_Pscalar1 CTL_Fortran_PStd(_
#define CTL_Fortran_Pscalar2 CTL_Fortran_PStd(_
#define CTL_Fortran_Pscalar3 CTL_Fortran_PStd(_
#define CTL_Fortran_Pscalar4 CTL_Fortran_PStd(_
#define CTL_Fortran_Pscalar5 CTL_Fortran_PStd(_
#define CTL_Fortran_Pscalar6 CTL_Fortran_PStd(_
#define CTL_Fortran_Pscalar7 CTL_Fortran_PStd(_
#define CTL_Fortran_Pscalar8 CTL_Fortran_PStd(_
#define CTL_Fortran_Parray CTL_Fortran_PVec(_
#define CTL_Fortran_Pstring CTL_Fortran_PVec(_
#define CTL_Fortran_Pvoid

#define CTL_Fortran_QVec(_,n) "s"<<n << ", x"<<n
#define CTL_Fortran_QStd(_,n) "x"<<n
#define CTL_Fortran_Qchar CTL_Fortran_QStd(_
#define CTL_Fortran_Qint2 CTL_Fortran_QStd(_
#define CTL_Fortran_Qint4 CTL_Fortran_QStd(_
#define CTL_Fortran_Qint CTL_Fortran_QStd(_
#define CTL_Fortran_Qint8 CTL_Fortran_QStd(_
#define CTL_Fortran_Qreal4 CTL_Fortran_QStd(_
#define CTL_Fortran_Qreal8 CTL_Fortran_QStd(_
#define CTL_Fortran_Qscalar1 CTL_Fortran_QStd(_
#define CTL_Fortran_Qscalar2 CTL_Fortran_QStd(_
#define CTL_Fortran_Qscalar3 CTL_Fortran_QStd(_
#define CTL_Fortran_Qscalar4 CTL_Fortran_QStd(_
#define CTL_Fortran_Qscalar5 CTL_Fortran_QStd(_
#define CTL_Fortran_Qscalar6 CTL_Fortran_QStd(_
#define CTL_Fortran_Qscalar7 CTL_Fortran_QStd(_
#define CTL_Fortran_Qscalar8 CTL_Fortran_QStd(_
#define CTL_Fortran_Qarray CTL_Fortran_QVec(_
#define CTL_Fortran_Qstring CTL_Fortran_QVec(_
#define CTL_Fortran_Qvoid

#define CTL_Fortran_RVec(_,n) ctl::typeName<CTL_List(x,*>()<<","<<
#define CTL_Fortran_RStd(_,n)
#define CTL_Fortran_Rchar CTL_Fortran_RStd(_
#define CTL_Fortran_Rint2 CTL_Fortran_RStd(_
#define CTL_Fortran_Rint4 CTL_Fortran_RStd(_
#define CTL_Fortran_Rint CTL_Fortran_RStd(_
#define CTL_Fortran_Rint8 CTL_Fortran_RStd(_
#define CTL_Fortran_Rreal4 CTL_Fortran_RStd(_
#define CTL_Fortran_Rreal8 CTL_Fortran_RStd(_
#define CTL_Fortran_Rscalar1 CTL_Fortran_RStd(_
#define CTL_Fortran_Rscalar2 CTL_Fortran_RStd(_
#define CTL_Fortran_Rscalar3 CTL_Fortran_RStd(_
#define CTL_Fortran_Rscalar4 CTL_Fortran_RStd(_
#define CTL_Fortran_Rscalar5 CTL_Fortran_RStd(_
#define CTL_Fortran_Rscalar6 CTL_Fortran_RStd(_
#define CTL_Fortran_Rscalar7 CTL_Fortran_RStd(_
#define CTL_Fortran_Rscalar8 CTL_Fortran_RStd(_
#define CTL_Fortran_Rarray CTL_Fortran_RVec(_
#define CTL_Fortran_Rstring CTL_Fortran_RVec(_
#define CTL_Fortran_Rvoid

#define CTL_Fortran_YVec(_,n)
#define CTL_Fortran_YStd(_,n)
#define CTL_Fortran_Ychar 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yint2 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yint4  0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yint  0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yint8  0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yreal4 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yreal8 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yscalar1 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yscalar2 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yscalar3 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yscalar4 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yscalar5 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yscalar6 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yscalar7 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yscalar8 0 CTL_Fortran_YStd(_
#define CTL_Fortran_Yarray  0 CTL_Fortran_YVec(_
#define CTL_Fortran_Ystring 0 CTL_Fortran_YVec(_
#define CTL_Fortran_Yvoid  1 CTL_Fortran_YStd(_

#define CTL_Fortran_MacroA(T,n) CTL_Cat2(CTL_Fortran_I,T _), n) type<T >::resultT *y##n
#define CTL_Fortran_MacroB(T,n) type<T >::value x##n( CTL_Cat2(CTL_Fortran_G,T _) ,n) )
#define CTL_Fortran_MacroC(T,n) CTL_Cat2(CTL_Fortran_H,T _) ,n)
#define CTL_Fortran_MacroD(T,n) CTL_Cat2(CTL_Fortran_P,T _), n) "       "<<   print(type<T >::resultT())<<" x"<<n
#define CTL_Fortran_MacroE(T,n) CTL_Cat2(CTL_Fortran_Q,T _), n)
#define CTL_Fortran_MacroF(T,n) CTL_Cat2(CTL_Fortran_R,T _), n) ctl::typeName<type<T >::pointer>()
#define CTL_Fortran_MacroY(T,n) CTL_Cat2(CTL_Fortran_Y,T _), n)

#define CTL_Fortran_I(n,T)  CTL_Cat2(CTL_FortranQual,T )) ,n, CTL_Fortran_MacroA)
#define CTL_Fortran_G(n,T)  CTL_Cat2(CTL_FortranQual,T )) ,n, CTL_Fortran_MacroB)
#define CTL_Fortran_H(n,T)  CTL_Cat2(CTL_FortranQual,T )) ,n, CTL_Fortran_MacroC)
#define CTL_Fortran_P(n,T)  CTL_Cat2(CTL_FortranQual,T )) ,n, CTL_Fortran_MacroD)
#define CTL_Fortran_Q(n,T)  CTL_Cat2(CTL_FortranQual,T )) ,n, CTL_Fortran_MacroE)
#define CTL_Fortran_R(n,T)  CTL_Cat2(CTL_FortranQual,T )) ,n, CTL_Fortran_MacroF)
#define CTL_Fortran_Y(n,T)  CTL_FortranTypeH (CTL_Bra T ) ,n, CTL_Fortran_MacroY)

#define CTL_Fortran_IY(macro, y,list,n, sep) CTL_Exp5(CTL_Fortran_IY, macro, y, list, n, sep, CTL_Fortran_isVoid(y) )
#define CTL_Fortran_IYvoid(macro, list, n, sep) CTL_MacroApplyCut(macro, sep,list,n)

#define CTL_Fortran_isVoid(y) CTL_MacroApplyCut(CTL_Fortran_Y, Space, (y), 1)

#define CTL_Fortran_IY0(macro, y, list, n, sep) CTL_Fortran_IY1H( (macro, CTL_AppendedList(y,list,n), sep) )
#define CTL_Fortran_IY1(macro, y, list, n, sep) CTL_MacroApplyCut(macro, sep,list,n)
#define CTL_Fortran_IY1H(list) CTL_Fortran_IYvoid list 

#define CTL_Fortran_IYY0(n) , x##n
#define CTL_Fortran_IYY1(n)

#define CTL_FortranDefClass(sign) CTL_FortranDefClass5 sign
#define CTL_FortranDefClass5(mid,y,f,list,n) \
	void CTL_FortranName2(CTL_ClassPrefix_  ,f##_impl)(CTL_Fortran_IY(CTL_Fortran_I,y,list,n, Comma));\
	void CTL_FortranName2(CTL_ClassPrefix_  ,f)(ctl::int8 *handle, CTL_Fortran_IY(CTL_Fortran_I, y,list,n, Comma), ctl::int8 *res)\
{\
	CTL_Fortran_IY(CTL_Fortran_G,y,list,n, Semicolon);\
	CTL_ClassName &ci=ctl::Extern::objMapper<CTL_ClassName>(*handle);\
	if(!!ci)\
		setResult(res, ci.f(CTL_ExprList(CTL_Conv,x,Comma,n)) CTL_Exp1(CTL_Fortran_IYY,(n),CTL_Fortran_isVoid(y) ) );\
}

#define CTL_FortranDefConstr(sign) CTL_FortranDefConstr3 sign
#define CTL_FortranDefConstr3(mid,list,n) \
	void CTL_FortranName2(CTL_ClassPrefix_  ,new##mid##_impl)(CTL_MacroApplyCut(CTL_Fortran_I, Comma,list,n));\
	void CTL_FortranName2(CTL_ClassPrefix_ ,new##mid) (char* location, CTL_MacroApplyCut(CTL_Fortran_I, Comma,list, n),ctl::int8 *handle)\
	{\
	CTL_MacroApplyCut(CTL_Fortran_G, Semicolon ,list, n);\
	ctl::log("#d ++ by fortran: %s\n", location);\
	*handle = 0; ctl::link p;\
	if(location && *location)\
	{ p = ctl::link(location); }\
	else\
	{ p = ctl::getLink(CTL_Str(CTL_Class)); }\
	if(!p)\
		ctl::log("#l !! by fortran: connecting %s failed\n", location);\
	else\
	{\
		CTL_ClassName ci(p, CTL_ExprList(CTL_Conv,x,Comma,n));\
		if(!!ci)\
		{\
			ctl::Extern::objMapper<CTL_ClassName >(*handle, ci);\
			return;\
		}\
		else\
			ctl::log("#c !! by fortran: creation of %s failed\n", CTL_Str(CTL_Class));\
	}\
 }

#define CTL_FortranImplClass(sign) CTL_FortranImplClass5 sign
#define CTL_FortranImplClass5(mid,y,f,list,n)\
CTL_FortranImpl(y, CTL_FortranName2(CTL_ClassPrefix_  ,f##_impl), f, list, n)

#define CTL_FortranImplConstr(sign) CTL_FortranImplConstr3 sign
#define CTL_FortranImplConstr3(mid,list,n)\
	CTL_Class CTL_ArgList(list,n)\
	{ CTL_FortranName2(CTL_ClassPrefix_  ,new##mid##_impl)(CTL_MacroApplyCut(CTL_Fortran_H, Comma,list,n)); }


#define CTL_Conv(x,n) Fortran_conv(x##n)
#define CTL_FortranDefFunction(sign) CTL_FortranDefFunction5 sign
#define CTL_FortranDefFunction5(mid,y,f,list,n) \
void CTL_FortranName2(CTL_Library ,f##_impl)(CTL_MacroApplyCut(CTL_Fortran_I, Comma,list,n));\
void CTL_FortranName2(CTL_Library ,f)(CTL_MacroApplyCut(CTL_Fortran_I, Comma,list, n),  *res)\
{\
	CTL_Fortran_IY(CTL_Fortran_G,y,list,n, Semicolon);\
	setResult(res, f(CTL_ExprList(CTL_Conv,x,Comma,n)) CTL_Exp1(CTL_Fortran_IYY,(n),CTL_Fortran_isVoid(y) ) );\
}

#define CTL_FortranImplFunction(sign) CTL_FortranImplFunction5 sign
#define CTL_FortranImplFunction5(mid,y,f,list,n)\
CTL_FortranImpl(y, CTL_FortranName2(CTL_Library ,f##_impl), f, list, n)

#define CTL_FortranConstrDetail(sign)  CTL_FortranConstrDetail3 sign
#define CTL_FortranConstrDetail3(mid,list,n)\
	typedef CTL_Field_Type (CTL_ArgDclr(list,n), n) CTL_constrType##mid;\
	operator  ctl::hasConstrType<ctl::int2type<mid> >() const;

#	define CTL_sizeChanged(x,n)  recall=ctl::sizeChanged(x##n) || recall

#define CTL_FortranImpl(y, f_,f,list,n)\
ctl::noVoid<y>::resultT f CTL_ArgList(list,n)\
{\
	ctl::noVoid<y>::resultT x##n;\
	f_(CTL_Fortran_IY(CTL_Fortran_H,y,list,n, Comma));\
	bool recall=false;\
	CTL_ExprList(CTL_sizeChanged, x, Semicolon, CTL_Succ(n));\
	if(recall) f_ (CTL_Fortran_IY(CTL_Fortran_H,y,list,n, Comma));\
	return x##n;\
}

#endif

