/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#include "ctl.h"

#ifdef CTL_inClass
#	error Libraries inside classes not supported
#endif
#undef  CTL_LibName
#ifdef CTL_SubSubSubLibrary
#	ifndef  CTL_inSubSubLib
#		error SubSubSubLibrary defined outside SubSubLibrary
#	endif
#	define CTL_openSubSubSubLib
#	include "lib_end.h"
#  define CTL_inSubSubSubLib
#	define CTL_LibName  CTL_SubSubSubLibrary
namespace CTL_SubSubSubLibrary
{ 	
	inline ctl::typeId CTL_typeNameS()
	{ return  ctl::string( CTL_Str(CTL_Library) ) + "::"+CTL_Str(CTL_SubLibrary)+ "::" + CTL_Str(CTL_SubSubLibrary)+ "::" + CTL_Str(CTL_SubSubSubLibrary);  }
#elif defined CTL_SubSubLibrary
#	ifndef  CTL_inSubLib
#		error SubSubLibrary defined outside SubLibrary
#	endif
#	define CTL_openSubSubLib
#	include "lib_end.h"
#  define CTL_inSubSubLib
#	define CTL_LibName  CTL_SubSubLibrary
namespace CTL_SubSubLibrary
{ 	
	inline ctl::typeId CTL_typeNameS()
	{ return  ctl::string( CTL_Str(CTL_Library) ) + "::"+CTL_Str(CTL_SubLibrary)+"::" + CTL_Str(CTL_SubSubLibrary);  }
#elif defined CTL_SubLibrary
#	ifndef  CTL_inLib
#		error SubLibrary defined outside Library
#	endif
#	define CTL_openSubLib
#	include "lib_end.h"
#  define CTL_inSubLib
#	define CTL_LibName  CTL_SubLibrary
namespace CTL_SubLibrary
{ 	
	inline ctl::typeId CTL_typeNameS()
	{ return  ctl::string( CTL_Str(CTL_Library) ) + "::"+CTL_Str(CTL_SubLibrary);  }
#else
#	ifndef CTL_Library
#		error no Library name specified
#	endif
#	define CTL_inLib
#	define CTL_LibName  CTL_Library
namespace CTL_Library
{ 	
	typedef ctl::cstring<char> string;	
	typedef ctl::cstring<ctl::wchar> wstring;	
	using ctl::int1;
	using ctl::uint1;
	using ctl::int2;
	using ctl::uint2;
	using ctl::int4;
	using ctl::uint4;
	using ctl::int8;
	using ctl::uint8;
	using ctl::real4;
	using ctl::real8;
	using ctl::wchar;
	using ctl::cstring;
	using ctl::tupel;
	using ctl::array;
	using ctl::reference;
	using ctl::any;
	enum { _ = -1 };
#ifndef size_t
#	define size_t CTL_Error_size_t_is_Arch_Dependend
#endif

	inline ctl::typeId CTL_typeNameS()
	{ return  CTL_Str(CTL_Library);  }

#endif

	template<class X0, class X1, class X2, class X3, class X4, class X5, class X6, class X7, class X8>
		inline bool connectFunctionF(X0, X1, X2, X3, X4, X5, X6, X7,X8);

	inline void use(const ctl::link &p=ctl::link())
	{
		if(p.getType()==ctl::invalid )
			ctl::throwStr(" *** invalid link in %s::use ***", CTL_typeNameS().c_str() );
		ctl::log("#f -> %s::use\n", CTL_typeNameS().c_str() );
		if(p.getType()==ctl::modifier)
		{ 
			ctl::setLocationModifier(CTL_typeNameS().c_str(), p.getModifier());
			return; 
		}
		ctl::setLink(CTL_typeNameS(), p);
	}
	inline void use(const char* s)
	{ use(ctl::link(s) ); }
	inline void use(const ctl::string& s)
	{ use(s.c_str() ); }

#ifdef CTL_Extern

inline void setResult(int *res, const ctl::resultType<void>::resultT &rRes)
{ ctl::Fortran::setResult(res, rRes, ctl::empty() ); }

template<class T> inline void setResult(int *res, const typename ctl::resultType<T>::resultT &rRes,const T &t)
{ ctl::Fortran::setResult(res, rRes, t); }

extern "C" {
void CTL_FortranName2(CTL_Library ,recv)(int *res)
{ ctl::Fortran::recv(res); }
}

#endif

