/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL_inLib
# error not in library scope,  probably missing #include CTL_LibBegin
#endif

#undef CTL_Scope

#ifdef CTL_inSubSubSubLib
#	define  CTL_Scope CTL_Library::CTL_SubLibrary::CTL_SubSubLibrary::CTL_SubSubSubLib
#elif defined CTL_inSubSubLib
#	define  CTL_Scope CTL_Library::CTL_SubLibrary::CTL_SubSubLibrary
#elif defined CTL_inSubLib
#	define  CTL_Scope CTL_Library::CTL_SubLibrary
#else
#	define  CTL_Scope CTL_Library
#endif

#define CTL_ExpandFunction CTL_DefFunctionObject
#define CTL_ExpandFunctionTmpl  CTL_DefFunctionTmplObject
#include CTL_ExpandAll

#define CTL_ExpandFunction  CTL_DefFunction
#define CTL_ExpandFunctionTmpl CTL_DefFunctionTmpl
#include CTL_ExpandAll

#ifdef  CTL_Extern
extern "C"
	{
#	define CTL_ExpandFunction  CTL_FortranDefFunction
#	include CTL_ExpandAll
	}
	namespace Extern
	{
#	define CTL_ExpandFunction CTL_FortranImplFunction
#	include CTL_ExpandAll
	}

#endif

#if  !defined CTL_openSubLib  && !defined CTL_openSubSubLib && !defined CTL_openSubSubSubLib

#define CTL_connectFncTmpl(n) template<int fid, CTL_GetClassList((CTL_List(X,n)),n), typename F>\
	 inline bool connect(F fi, ctl::type2type<CTL_List(X,n)>* =0)\
		{ return connectFunctionF<CTL_List(X,n)>(ctl::int2type<fid>(),0, fi, (ctl::type2type<CTL_List(X,n)>*)0); }

CTL_connectFncTmpl(1)
CTL_connectFncTmpl(2)
CTL_connectFncTmpl(3)
CTL_connectFncTmpl(4)
CTL_connectFncTmpl(5)
CTL_connectFncTmpl(6)
CTL_connectFncTmpl(7)
CTL_connectFncTmpl(8)

#undef CTL_connectFncTmpl
 	template<int fid, typename FI> inline bool connect(FI fi, ctl::int2type<fid>* =0)
	{ return connectFunctionF(ctl::int2type<fid>(),0, fi); }

	template<int fid, typename FI> inline bool connect(ctl::link &p, FI fi, ctl::int2type<fid>* =0)
	{
		ctl::setLink(ctl::typeId(), p);
		bool ok=connectFunctionF(ctl::int2type<fid>(),0, fi);
		ctl::setLink(ctl::typeId(), ctl::link() );
		return ok;
	}


	inline ctl::Remote* connectFunctionF(...)
	{ return 0; }
	
	template<typename F, typename FI> struct connectFunctionH
	{
		F friM; FI fiM;
		connectFunctionH(F fri, FI fi): friM(fri), fiM(fi) {}
		template<class Int> bool operator()(Int i)
		{ return !connectFunctionF(i,friM,fiM); }
	};

	template<typename F, typename FI> inline bool connect(F f, FI fi)
	{
		connectFunctionH<F,FI> connecter(f,fi);
		return !ctl::forLoop<1,33>(connecter);
	}

	template<typename F, typename FI> inline bool connect(ctl::link &p, F f, FI fi)
	{
		ctl::setLink(ctl::typeId(), p);
		bool ok=connectf(f, fi);
		ctl::setLink(ctl::typeId(), ctl::link() );
		return ok;
	}

} // CTL_Library
#	undef CTL_LibName
#	ifdef CTL_inSubSubSubLib
#		undef CTL_inSubSubSubLib
#		undef  CTL_SubSubSubLibrary
#		define CTL_LibName  CTL_SubSubLibrary
#	elif defined CTL_inSubSubLib
#		undef CTL_inSubSubLib
#		undef  CTL_SubSubLibrary
#		define CTL_LibName  CTL_SubLibrary
#	elif defined CTL_inSubLib
#		undef CTL_inSubLib
#		undef  CTL_SubLibrary
#		define CTL_LibName  CTL_Library
#	else
#		undef CTL_inLib
#		undef  CTL_Library		
#	endif
#endif

#define CTL_UndefFunctions
#include CTL_ExpandAll

#ifdef size_t
#	undef size_t
#endif

#undef CTL_openSubLib
#undef CTL_openSubSubLib
#undef CTL_openSubSubSubLib
#undef CTL_UndefFunctions
#undef CTL_Scope

