/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL_RI_MCR_
#define CTL_RI_MCR_

#include "ctl.mcr"


#define CTL_DclrPureMeth(x) CTL_DclrPureMeth5 x
#define CTL_DclrPureMeth5(mid,y,f,list,n)\
	virtual CTL_resType##mid f CTL_MethArgList(list,n) =0;

#define CTL_DefMethSend(x) CTL_DefMethSend5 x
#define CTL_DefMethSend5(mid,y,f,list,n)\
	virtual CTL_resType##mid f CTL_MethArgList(list,n)\
	{ return CTL_RMICall##mid::send(*this, ctl::MID(mid, ciT::CTL_printM##mid()), CTL_args##mid(CTL_List(x,n)), ctl::RMI );	}


#define CTL_DefCallSwitch(x) CTL_DefCallSwitch5 x
#define CTL_DefCallSwitch5(mid, y, f, list, n)\
case mid: {\
						const char* pretty=ciT::CTL_printM##mid();\
						if(strcmp(pretty, midStr.strM.c_str())==0) \
						{ return CTL_remoteCall##mid(is, ctl::int2type<CTL_RMICall##mid::hasBinRep>(), pretty);	}\
						return baseT::receiveMID(is, midStr);\
				 }
	
#define CTL_DefCallDerivedSwitch(x) CTL_DefCallDerivedSwitch5 x
#define CTL_DefCallDerivedSwitch5(mid, y, f, list, n)\
case mid: {\
						if(strcmp(ciT::CTL_printM##mid(), midStr.strM.c_str())==0) \
						{\
							CTL_resType##mid (thisT::*meth)CTL_MethArgDclr(list,n) = &thisT::f;\
							return CTL_RMICall##mid::call(ctl::falseT(), ctl::functor(*(thisT*)this,meth) ,is);\
						}\
						return baseT::receiveMID(is, midStr);\
				 }

#define CTL_DefRMITypes(x) CTL_DefRMITypes5 x
#define CTL_DefRMITypes5(mid,y,f,list,n)\
	CTL_ArgTypedef(list,n)\
	typedef ctl::field##n<CTL_List(CTL_Cat3(CTL_T,mid,_), n)> CTL_FieldT##mid;\
 	static const char *CTL_printM##mid(ctl::type2type<>* =0)\
	{ CTL_Static const char *pretty=ctl::prettyNameS (CTL_Str ((CTL_Get((y),1)) ), CTL_typeNameS().c_str(), CTL_Str(f), 0, CTL_Str((CTL_Get(list,n)) ), CTL_Str(list) );  return pretty; };\
	typedef CTL_Tmpl_Name2S(ctl::tryCallCatch, CTL_Throws)  CTL_Cat3(CTL_Catch,M,mid);\
	typedef CTL_Typename ctl::alias<CTL_Trans1(y) >::resultT CTL_YY##mid;\
	typedef ctl::RMICall<CTL_YY##mid, CTL_FieldT##mid, CTL_Cat3(CTL_Catch,M,mid)> CTL_RMICall##mid;\
	typedef CTL_Typename CTL_RMICall##mid::optArgs CTL_args##mid;\
	typedef CTL_Typename CTL_RMICall##mid::resY CTL_resType##mid;\
	typedef CTL_Typename ctl::returnType<CTL_YY##mid>::binType CTL_binY##mid;\
	typedef CTL_Typename ctl::returnType<CTL_YY##mid>::resultT CTL_Y##mid;\
	typedef ctl::noVoid<CTL_binY##mid> CTL_aVoidM##mid;\
	typedef CTL_Typename CTL_aVoidM##mid::cast CTL_cast##mid;
	
#define CTL_MethCallImpl(x) CTL_MethCallImpl5 x
#define CTL_MethCallImpl5(mid,y,f,list,n)\
	CTL_resType##mid f CTL_MethArgList(list,n)\
	{\
		CTL_Cat3(CTL_Catch,M,mid)::connect();\
		const char *pretty=CTL_printM##mid();\
		(void)pretty;\
		if(CTL_Pretty) { CTL_Log1(CTL_getEnv(),"#f <- %s\n", CTL_Pretty) }\
		CTL_getCIRef();\
		const ctl::link &p=CTL_getLink();\
		ctl::channelT typ=p.getType();\
		ctl::link::envSet tmp(&p, typ);\
		CTL_resType##mid (CTL_Interface::*meth) CTL_MethArgList(list,n) = &CTL_Interface::f;\
		CTL_resType##mid res= typ==ctl::thread ?\
	 			CTL_RMICall##mid::threadCall(ctl::functor(*CTL_getCIPThrows(),meth),CTL_args##mid(CTL_List(x,n) ), p, 0) :\
				CTL_getCIRef().f(CTL_List(x,n) );\
		res.setPretty(CTL_Pretty);\
		return res;\
	}

#define CTL_DefConstr(x) CTL_DefConstr3 x
#define CTL_DefConstr3H(mid, list, n)\
	typedef CTL_ArgField_Type(list,n) CTL_constrType##mid;\
 	static const char *CTL_printC##mid(ctl::type2type<>* =0)\
	{ CTL_Static const char *pretty=ctl::prettyNameS (0, CTL_typeNameS().c_str(), 0, 0, CTL_Str((CTL_Get(list,n)) ), 0 );  return pretty; };\
 	typedef CTL_Tmpl_Name2S(ctl::tryCallCatch, CTL_Throws)  CTL_Cat3(CTL_Catch,C,mid);\
	CTL_DefFunction8(mid, CTL_RP, CTL_new, list, n, static, "C", (<>), 1,C)\
	CTL_Class CTL_ArgList(list,n)\
	{ CTL_init(ctl::link()); CTL_attrM.rpM = CTL_new(CTL_getLink(),CTL_List(x,n) ); }\
	CTL_CopyConstrExist(list, n)

#define CTL_DefStaticMeth(x) CTL_DefStaticMeth5 x
#define CTL_DefStaticMeth5(mid, y, f, list, n)\
	static const char *CTL_printS##mid(ctl::type2type<>* =0)\
	{ CTL_Static const char *pretty=ctl::prettyNameS (CTL_Str(y), CTL_typeNameS().c_str(), CTL_Str(f), 0, CTL_Str((CTL_Get(list,n)) ), 0 ); return pretty; };\
 	typedef CTL_Tmpl_Name2S(ctl::tryCallCatch, CTL_Throws)  CTL_Cat3(CTL_Catch,S,mid);\
	typedef CTL_Typename ctl::alias<CTL_Trans1(y) >::resultT CTL_YS##mid;\
	typedef CTL_Typename ctl::resultType<CTL_YS##mid>::resultT CTL_funcResType##mid;\
	CTL_DefFunction8(mid, y, f, list, n, static,"S", (<>), 1, S)\
	template<class Impl, class detail> static void CTL_connectStatic##mid(ctl::falseT, CTL_funcResType##mid (*ff) CTL_ArgDclr(list,n), Impl *, detail*)\
	{\
		 typename ctl::returnType<CTL_YS##mid>::resultT (*fI) CTL_ArgDclr(list,n) = &CTL_ImplHandle<Impl,detail>::f;\
		connectFunctionS(ctl::int2type<mid>(), ff, fI);\
	}\
	template<class Impl, class detail> static void CTL_connectStatic##mid(ctl::trueT, CTL_funcResType##mid (*ff) CTL_ArgDclr(list,n), Impl*, detail*)\
	{ connectFunctionS(ctl::int2type<mid>(), ff, &Impl::f);	}\
	template<class Impl, class detail> static void CTL_connectStatic##mid(ctl::int2type<2>, CTL_funcResType##mid (*ff) CTL_ArgDclr(list,n), Impl*, detail*)\
	{ connectFunctionS(ctl::int2type<mid>(), ff, detail::getFunc(ctl::int2type<mid>()));	}

#define CTL_DefConnect(x) CTL_DefConnect3 x
#define CTL_DefConnect3(mid,list,n)\
	{\
		typedef ctl::RMICall<void, CTL_Field_TypeRP(list,n) ,CTL_Cat3(CTL_Catch,C,mid)> CTL_RCICall;\
		enum { hasConstr=ctl::conversion<ctl::hasConstrType<ctl::int2type<mid> >, detail >::exist};\
		typedef typename ctl::select<hasConstr,\
						  detail, thisT>::resultT::CTL_constrType##mid   constrType;\
 		CTL_resRP (*ff) CTL_ArgDclr(list,n)= &CTL_new;\
		enum { detailNeeded  = !CTL_RCICall::hasBinRep || hasConstr };\
		ctl::Assert<detailNeeded> CTL_ERROR__Constructor##mid##_connectDetail_needed;\
		(void)CTL_ERROR__Constructor##mid##_connectDetail_needed;\
		connectFunctionC(ctl::int2type<mid>(), ff, ctl::internal::createRP<thisT,Impl,detail,constrType>());\
	}

#define CTL_DefConnectStatic(x) CTL_DefConnectStatic5 x
#define CTL_DefConnectStatic5(mid, y, f, list, n)\
	{\
		typedef ctl::RMICall<CTL_YS##mid, CTL_Field_TypeRP(list,n), CTL_Cat3(CTL_Catch,S,mid)> CTL_RFICall##mid;\
		typedef  CTL_Typename CTL_RFICall##mid::resY  CTL_funcResType##mid;\
		CTL_funcResType##mid (*ff) CTL_ArgDclr(list,n)= &thisT::f;\
		enum { sw= 	ctl::conversion<ctl::hasStaticType<ctl::int2type<mid> >, detail >::exist ? 2 : CTL_RFICall##mid::hasBinRep };\
		CTL_connectStatic##mid(ctl::int2type<sw>(),ff, (Impl*)0, (detail*)0);  }
		
#define CTL_DefTrampoline(x) CTL_DefTrampoline5 x
#define CTL_DefTrampoline5(mid,y,f,list,n)\
	enum {CTL_hasDetail##mid = ctl::conversion<ctl::hasMethodType<ctl::int2type<mid> >, detail>::exist,  hasBin##mid =CTL_RMICall##mid::hasBinRep };\
	ctl::status CTL_remoteCallH##mid(ctl::iStream &is, ctl::falseT, const char* pretty) const\
	{ return  CTL_RMICall##mid::call(ctl::trueT(),ctl::callerRes<CTL_RMICall##mid>(ctl::functor((Impl&)*pimplM, &Impl::f),0, pretty ), is); }\
	ctl::status CTL_remoteCallH##mid(ctl::iStream &is, ctl::trueT, const char* pretty) const\
	{ return  CTL_RMICall##mid::call(ctl::trueT(),ctl::callerRes<CTL_RMICall##mid>(ctl::functor((Impl&)*pimplM, detail::getMeth((Impl*)0,ctl::int2type<mid>()) ),0,pretty), is); }\
	ctl::status CTL_remoteCall##mid(ctl::iStream &is, ctl::trueT, const char* pretty) const\
	{	return CTL_remoteCallH##mid(is, ctl::int2type<CTL_hasDetail##mid>(), pretty);	}\
	ctl::status CTL_remoteCall##mid(ctl::iStream &is, ctl::falseT, const char*) const\
	{\
		CTL_resType##mid (thisT::*meth)CTL_MethArgDclr(list,n) = &thisT::f;\
		return CTL_RMICall##mid::call(ctl::falseT(), ctl::functor(*(thisT*)this,meth) ,is);\
	}\
	template<class Imp> static CTL_Y##mid CTL_LocalCall##mid(Imp &impl, CTL_ExprList(CTL_MethArgItemComma, x, Space, n) ctl::falseT, ctl::falseT)\
	{ return CTL_cast##mid(CTL_binY##mid(impl.f(CTL_List(x, n) ) ) ),ctl::empty(); }\
	template<class Imp> static CTL_Y##mid CTL_LocalCall##mid(Imp &impl, CTL_ExprList(CTL_MethArgItemComma, x, Space, n) ctl::trueT, ctl::falseT)\
	{ return CTL_RMICall##mid::call(ctl::trueT(), ctl::functor((Impl&)impl,  &Impl::f),  CTL_args##mid(CTL_List(x,n) ) ); }\
	template<class Imp> static CTL_Y##mid CTL_LocalCall##mid(Imp &impl, CTL_ExprList(CTL_MethArgItemComma, x, Space, n) ctl::falseT,ctl::trueT)\
	{ return CTL_cast##mid(CTL_binY##mid((impl.*detail::getMeth((Impl*)0,ctl::int2type<mid>()))(CTL_List(x,n) ))),ctl::empty(); }\
	template<class Imp> static CTL_Y##mid CTL_LocalCall##mid(Imp &impl, CTL_ExprList(CTL_MethArgItemComma, x, Space, n) ctl::trueT,ctl::trueT)\
	{ return CTL_RMICall##mid::call(ctl::trueT(), ctl::functor((Impl&)impl,detail::getMeth((Impl*)0,ctl::int2type<mid>())), CTL_args##mid(CTL_List(x,n) ) ); }\
	CTL_resType##mid f CTL_MethArgList(list,n)\
 	{\
		const char *pretty=CTL_printM##mid();\
		if(CTL_Pretty) { CTL_Log1(0,"#f -> %s \n", CTL_Pretty) }\
		ctl::logger lg(CTL_Pretty ? 'f':'\0', "<= ");		lg << CTL_Pretty;\
		ctl::cPointer<ctl::excptHandle> excpt;\
		CTL_Try { return CTL_LocalCall##mid(*pimplM CTL_HeadList(x, n) , ctl::int2type<hasBin##mid>(), ctl::int2type<CTL_hasDetail##mid>()); }\
		CTL_CatchList1( CTL_Throws)\
		CTL_Catch(const ctl::exception &e)\
		{ excpt = new ctl::excptHandle; ctl::rethrowStr2bin(e, excpt->binM, " *** in:  %s ***\n", pretty); } \
		CTL_CatchAll\
		{ excpt = new ctl::excptHandle; ctl::throwStr2bin(excpt->binM, " *** in:  %s ***\n", pretty); } \
		lg<<" throws "<< excpt->binM.type.c_str()<<"\n";\
		return CTL_resType##mid(CTL_Y##mid(), excpt, CTL_Pretty);\
	}

#define CTL_DefStaticTrampoline(x)  CTL_DefStaticTrampoline5 x

#define CTL_DefStaticTrampoline5(mid,y,f,list,n)\
	static typename ctl::returnType<CTL_YS##mid>::resultT f CTL_ArgList(list,n)\
	{\
		typedef  typename ctl::returnType<CTL_YS##mid>::binType resT;\
		typedef ctl::noVoid<resT> aVoid;\
		return CTL_Typename aVoid::cast(resT(Impl::f(CTL_List(x,n) ) ) ), ctl::empty() ;\
	 }

#define CTL_DefImplConstr(x)
//#define CTL_DefImplConstr(x) CTL_DefImpl3 x
#define CTL_DefImpl3(mid,list,n)\
	CTL_ImplHandle CTL_ArgList(list,n):  baseT(implM), implM(CTL_List(x,n) ) {}

#define CTL_DefFunction(sign) CTL_DefFunction5 sign
#define CTL_DefFunction5(mid, y, f, list, n)\
 CTL_DefFunction8 (mid, y, f, list, n ,inline , "F",(<>) ,1,F)

#define CTL_DefFunctionTmpl(sign) CTL_DefFunctionTmpl7 sign
#define CTL_DefFunctionTmpl7(mid, y, f, list, n, TList, nT)\
	CTL_DefFunctionTmpl8(mid, y, f, list, n, TList, nT, inline)

#define CTL_DefFunctionPBody(y,f,list,n,mid, FKey, TList, nT, K)\
	CTL_Typename ctl::resAlias<CTL_Trans1(y) >::resultT   f (ctl::link &p CTL_UnbracedArgList(list,n) )\
	{\
		const char *pretty=CTL_print##K##mid((ctl::type2type CTL_Get(TList, nT) *)0);\
		if(CTL_Pretty) { CTL_Log1(0, "#f <- %s\n", CTL_Pretty) }\
		typedef CTL_Tmpl_Name2S(ctl::tryCallCatch, CTL_Throws)  caller;\
		caller::connect();\
		typedef ctl::RMICall<CTL_Typename ctl::alias<CTL_Trans1(y) >::resultT, CTL_Field_TypeRP(list,n),caller> RFICall;\
		return RFICall::functionCall(CTL_ArgField_Type(list,n)(CTL_List(x,n) ), pretty,(ctl::int2type<mid>*)0, CTL_Scope::CTL_typeNameS(), p);\
	}

#	define CTL_DefConstr3(mid, list, n)\
		CTL_DefConstr3H(mid, list, n)\
		CTL_Class (const ctl::link &p CTL_UnbracedArgList(list,n) )\
		{ CTL_init(p); CTL_attrM.rpM = CTL_new(p,CTL_List(x,n) ); }
	
#	define CTL_DefFunction8(mid, y, f, list, n, prefix, FKey, TList, nT,K)\
		prefix 	CTL_DefFunctionPBody(y,f,list,n,mid,FKey, TList, nT, K)\
		prefix CTL_Typename ctl::resAlias<CTL_Trans1(y) >::resultT f (const ctl::link &pc CTL_UnbracedArgList(list,n) )\
		{ ctl::link p(pc); return f (p CTL_HeadList(x, n) ); }\
		prefix CTL_Typename ctl::resAlias<CTL_Trans1(y) >::resultT f CTL_ArgList(list,n)\
		{ return  f  ( ctl::link() CTL_HeadList(x, n) ); }\
		template<typename F> prefix CTL_DefFConnect(y, f, list, n, mid, FKey,TList, nT, K)

#	define CTL_DefFunctionTmpl8(mid, y, f, list, n, TList, nT, prefix)\
		CTL_Tmpl_Dclr2(TList,nT) prefix CTL_DefFunctionPBody(y,f,list,n,mid,CTL_TypeNameList(TList,nT), (<CTL_Get(TList,nT)>), nT,  F)\
		CTL_Tmpl_Dclr2(TList,nT) prefix CTL_Typename ctl::resAlias<CTL_Trans1(y) >::resultT f (const ctl::link &pc CTL_UnbracedArgList(list,n) )\
		{ ctl::link p(pc); return f<CTL_Get(TList,nT)> (p CTL_HeadList(x, n) ); }\
		CTL_Tmpl_Dclr2(TList,nT) prefix CTL_Typename ctl::resAlias<CTL_Trans1(y) >::resultT f CTL_ArgList(list,n)\
		{ return  f<CTL_Get(TList,nT)>  ( ctl::link() CTL_HeadList(x, n) ); }\
		template<CTL_GetClassList(TList,nT), typename F> \
			prefix CTL_DefFConnect(y, f, list, n, mid, CTL_TypeNameList(TList,nT), (<CTL_Get(TList,nT)>), nT, F)

#define CTL_DefFunctionDeclare(x)  CTL_FunctionDeclare5 x
#define CTL_FunctionDeclare5(mid, y, f, list, n)\

#define CTL_DefFunctionTmplDeclare(sign) CTL_FunctionTmplDeclare7 sign
#define CTL_FunctionTmplDeclare7(mid, y, f, list, n, TList, nT)\
	CTL_Tmpl_Dclr2(TList,nT) CTL_Typename ctl::resAlias<CTL_Trans1(y) >::resultT  f  CTL_ArgList(list,n);


#define CTL_DefFunctionObject(x)  CTL_FunctionObject5 x
#define CTL_FunctionObject5(mid, y, f, list, n)\
	inline const char *CTL_printF##mid(ctl::type2type<>* =0)\
	{ CTL_Static const char *pretty=ctl::prettyNameS (CTL_Str(y), CTL_typeNameS().c_str(), CTL_Str(f), 0, CTL_Str((CTL_Get(list,n)) ), 0 ); return pretty; };

#define CTL_DefFunctionTmplObject(sign) CTL_FunctionTmplObject7 sign
#define CTL_FunctionTmplObject7(mid, y, f, list, n, TList, nT)\
		CTL_Tmpl_Dclr2(TList,nT) inline const char *CTL_printF##mid(ctl::type2type <CTL_Get(TList, nT)>* =0)\
		{  CTL_Static const char *pretty=ctl::prettyNameS (CTL_Str(y), CTL_typeNameS().c_str(), CTL_Str(f), (CTL_TypeNameList(TList,nT)).c_str(), CTL_Str((CTL_Get(list,n)) ),0 ); return pretty; };

#define CTL_DefFConnect(y, f, list, n, mid, FKey, TList, nT,K) \
	 bool connectFunction##K(ctl::int2type<mid>, CTL_Typename ctl::resAlias<CTL_Trans1(y) >::resultT   (*) CTL_ArgDclr(list,n), F fI, ctl::type2type CTL_Get(TList, nT) *__ =0 )\
	{\
		typedef CTL_Tmpl_Name2S(ctl::tryCallCatch, CTL_Throws)  caller;\
		const char *pretty= CTL_print##K##mid(__);\
		return ctl::connectFunction<ctl::RMICall<CTL_Typename ctl::alias<CTL_Trans1(y) >::resultT, CTL_Field_TypeRP(list,n),caller >, ctl::int2type<mid> >\
				(fI, (CTL_ArgField_Type(list,n)*)0, pretty) != 0;\
	}


#endif
