/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

//#include CTL_IPath(ctl/config.h)

#ifndef CTL_TEMPLARG_MCR_
#define CTL_TEMPLARG_MCR_

#define CTL_TrnsA1(x1) CTL_Trans2(x1)
#define CTL_TrnsA2(x1,x2) CTL_Trans2(x1), CTL_Trans2(x2)
#define CTL_TrnsA3(x1,x2,x3)  CTL_TrnsA2(x1,x2), CTL_Trans2(x3)
#define CTL_TrnsA4(x1,x2,x3,x4)  CTL_TrnsA2(x1,x2), CTL_TrnsA2(x3,x4)
#define CTL_TrnsA5(x1,x2,x3,x4,x5)  CTL_TrnsA2(x1,x2), CTL_TrnsA3(x3,x4,x5)
#define CTL_TrnsA6(x1,x2,x3,x4,x5,x6)  CTL_TrnsA3(x1,x2,x3), CTL_TrnsA3(x4,x5,x6)
#define CTL_TrnsA7(x1,x2,x3,x4,x5,x6,x7)  CTL_TrnsA3(x1,x2,x3), CTL_TrnsA4(x4,x5,x6,x7)
#define CTL_TrnsA8(x1,x2,x3,x4,x5,x6,x7,x8)  CTL_TrnsA4(x1,x2,x3,x4), CTL_TrnsA4(x5,x6,x7,x8)
#define CTL_CatTH1(a,b) a##b
#define CTL_CatT1(a,b) CTL_CatTH1(a,b)
#define CTL_TrnsD1(n,x) CTL_##x
#define CTL_Tmpl_NameC1(C,TList,n) C < CTL_TrnsA##n TList >
#define CTL_CTL_Tmpl1
#define CTL_Tmpl1(T,list,n) Tmpl_NameC1 (T,list,n)
#define CTL_Trans1(x) CTL_CatT1(CTL_,CTL_Tmpl1 x)

#define CTL_TrnsB1(x1) CTL_Trans3(x1)
#define CTL_TrnsB2(x1,x2) CTL_Trans3(x1), CTL_Trans3(x2)
#define CTL_TrnsB3(x1,x2,x3) CTL_TrnsB2(x1,x2), CTL_Trans3(x3)
#define CTL_TrnsB4(x1,x2,x3,x4)  CTL_TrnsB2(x1,x2), CTL_TrnsB2(x3,x4)
#define CTL_TrnsB5(x1,x2,x3,x4,x5)  CTL_TrnsB2(x1,x2), CTL_TrnsB3(x3,x4,x5)
#define CTL_TrnsB6(x1,x2,x3,x4,x5,x6)  CTL_TrnsB3(x1,x2,x3), CTL_TrnsB3(x4,x5,x6)
#define CTL_TrnsB7(x1,x2,x3,x4,x5,x6,x7)  CTL_TrnsB3(x1,x2,x3), CTL_TrnsB4(x4,x5,x6,x7)
#define CTL_TrnsB8(x1,x2,x3,x4,x5,x6,x7,x8)  CTL_TrnsB4(x1,x2,x3,x4), CTL_TrnsB4(x5,x6,x7,x8)
#define CTL_CatTH2(a,b) a##b
#define CTL_CatT2(a,b) CTL_CatTH2(a,b)
#define CTL_Tmpl_NameC2(C,TList,n) C < CTL_TrnsB##n TList >
#define CTL_CTL_Tmpl2
#define CTL_Tmpl2(T,list,n) Tmpl_NameC2 (T,list,n)
#define CTL_Trans2(x) CTL_CatT2(CTL_,CTL_Tmpl2 x)

#define CTL_TrnsC1(x1) CTL_Trans4(x1)
#define CTL_TrnsC2(x1,x2) CTL_Trans4(x1), CTL_Trans4(x2)
#define CTL_TrnsC3(x1,x2,x3) CTL_TrnsC2(x1,x2), CTL_Trans4(x3)
#define CTL_TrnsC4(x1,x2,x3,x4)  CTL_TrnsC2(x1,x2), CTL_TrnsC2(x3,x4)
#define CTL_TrnsC5(x1,x2,x3,x4,x5)  CTL_TrnsC2(x1,x2), CTL_TrnsC3(x3,x4,x5)
#define CTL_TrnsC6(x1,x2,x3,x4,x5,x6)  CTL_TrnsC3(x1,x2,x3), CTL_TrnsC3(x4,x5,x6)
#define CTL_TrnsC7(x1,x2,x3,x4,x5,x6,x7)  CTL_TrnsC3(x1,x2,x3), CTL_TrnsC4(x4,x5,x6,x7)
#define CTL_TrnsC8(x1,x2,x3,x4,x5,x6,x7,x8)  CTL_TrnsC4(x1,x2,x3,x4), CTL_TrnsC4(x5,x6,x7,x8)
#define CTL_CatTH3(a,b) a##b
#define CTL_CatT3(a,b) CTL_CatTH3(a,b)
#define CTL_Tmpl_NameC3(C,TList,n) C < CTL_TrnsC##n TList >
#define CTL_CTL_Tmpl3
#define CTL_Tmpl3(T,list,n) Tmpl_NameC3 (T,list,n)
#define CTL_Trans3(x) CTL_CatT3(CTL_,CTL_Tmpl3 x)
#define CTL_Trans4(x) x

#endif

