/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL2_MCR_
#define CTL2_MCR_

#include "templarg.mcr"

#define CTL_Bra (
#define CTL_Ket )
#define CTL_Space
#define CTL_Comma ,
#define CTL_CommaStr +","+
#define CTL_Semicolon ;
#define CTL_Or ||
#define CTL_Plus +
#define CTL_And &&
#define CTL_LShift <<
#define CTL_RShift >>
#define CTL_StringList +","+
#define CTL_SecondTrans(n,x) CTL_Trans1(x)
#define CTL_SecondTransRPH(x) CTL_Typename ctl::alias<x >::resultT
#define CTL_SecondTransRP(n,x) CTL_SecondTransRPH(CTL_Trans1(x) ) 
#define CTL_Second(n,x) x

#define CTL_Ignore( X )
#define CTL_ExpandHH( X ) X
#define CTL_ExpandH( X ) CTL_ExpandHH(X)
#define CTL_Expand( X ) CTL_ExpandH (X)
#define CTL_UnBraceH(x) x
#define CTL_UnBrace(x) CTL_UnBraceH x
#define CTL_Succ0 1
#define CTL_Succ1 2
#define CTL_Succ2 3
#define CTL_Succ3 4
#define CTL_Succ4 5
#define CTL_Succ5 6
#define CTL_Succ6 7
#define CTL_Succ7 8
#define CTL_Succ8 9
#define CTL_Succ9 10
#define CTL_Succ10 11
#define CTL_Succ11 12
#define CTL_Succ12 13
#define CTL_Succ13 14
#define CTL_Succ14 15
#define CTL_Succ15 16
#define CTL_Succ16 17
#define CTL_Succ17 18
#define CTL_Succ18 19
#define CTL_Succ19 20

#define CTL_Succ(n) CTL_Succ##n

#define CTL_Cdr0(x0) x0
#define CTL_Cdr1(x0,x1) x1
#define CTL_Cdr2(x0,x1,x2) x2
#define CTL_Cdr3(x0,x1,x2,x3) x3
#define CTL_Cdr4(x0,x1,x2,x3,x4) x4
#define CTL_Cdr5(x0,x1,x2,x3,x4,x5) x5
#define CTL_Cdr6(x0,x1,x2,x3,x4,x5,x6) x6
#define CTL_Cdr7(x0,x1,x2,x3,x4,x5,x6,x7) x7
#define CTL_Cdr8(x0,x1,x2,x3,x4,x5,x6,x7,x8) x8
#define CTL_Cdr9(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9) x9
#define CTL_Cdr10(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) x10
#define CTL_Cdr11(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11) x11
#define CTL_Cdr12(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12) x12
#define CTL_Cdr13(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13) x13
#define CTL_Cdr14(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14) x14
#define CTL_Cdr15(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15) x15
#define CTL_Cdr16(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16) x16
#define CTL_Cdr17(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16,x17) x17

#define CTL_CdrCut0(x0) x0 CTL_Ignore CTL_Bra x
#define CTL_CdrCut1(x0,x1) x1 CTL_Ignore CTL_Bra x
#define CTL_CdrCut2(x0,x1,x2) x2 CTL_Ignore CTL_Bra x
#define CTL_CdrCut3(x0,x1,x2,x3) x3 CTL_Ignore CTL_Bra x
#define CTL_CdrCut4(x0,x1,x2,x3,x4) x4 CTL_Ignore CTL_Bra x
#define CTL_CdrCut5(x0,x1,x2,x3,x4,x5) x5 CTL_Ignore CTL_Bra x
#define CTL_CdrCut6(x0,x1,x2,x3,x4,x5,x6) x6 CTL_Ignore CTL_Bra x
#define CTL_CdrCut7(x0,x1,x2,x3,x4,x5,x6,x7) x7 CTL_Ignore CTL_Bra x
#define CTL_CdrCut8(x0,x1,x2,x3,x4,x5,x6,x7,x8) x8 CTL_Ignore CTL_Bra x
#define CTL_CdrCut9(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9) x9 CTL_Ignore CTL_Bra x
#define CTL_CdrCut10(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) x10 CTL_Ignore CTL_Bra x
#define CTL_CdrCut11(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11) x11 CTL_Ignore CTL_Bra x
#define CTL_CdrCut12(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12) x12 CTL_Ignore CTL_Bra x
#define CTL_CdrCut13(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13) x13 CTL_Ignore CTL_Bra x
#define CTL_CdrCut14(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14) x14 CTL_Ignore CTL_Bra x
#define CTL_CdrCut15(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15) x15 CTL_Ignore CTL_Bra x
#define CTL_CdrCut16(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16) x16 CTL_Ignore CTL_Bra x
#define CTL_CdrCut17(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16,x17) x17 CTL_Ignore CTL_Bra x

#ifdef CTL_VC
#	define CTL_CdrCutH(string ) string )
#	define CTL_CdrCut(macro, list, n)  macro (n, CTL_CdrCutH(CTL_CdrCut##n list) )
#else
#	define CTL_CdrCut(macro, list, n)  macro (n, CTL_CdrCut##n list ) )
#endif

#define CTL_Cdr(macro, list, n)  macro (n, CTL_Cdr##n list )

#define CTL_Car1(x0)
#define CTL_Car2(x0,x1) (x0)
#define CTL_Car3(x0,x1,x2) (x0,x1)
#define CTL_Car4(x0,x1,x2,x3) (x0,x1,x2)
#define CTL_Car5(x0,x1,x2,x3,x4) (x0,x1,x2,x3)
#define CTL_Car6(x0,x1,x2,x3,x4,x5) (x0,x1,x2,x3,x4)
#define CTL_Car7(x0,x1,x2,x3,x4,x5,x6) (x0,x1,x2,x3,x4,x5)
#define CTL_Car8(x0,x1,x2,x3,x4,x5,x6,x7) (x0,x1,x2,x3,x4,x5,x6)
#define CTL_Car9(x0,x1,x2,x3,x4,x5,x6,x7,x8) (x0,x1,x2,x3,x4,x5,x6,x7)
#define CTL_Car10(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9) (x0,x1,x2,x3,x4,x5,x6,x7,x8)
#define CTL_Car11(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) (x0,x1,x2,x3,x4,x5,x6,x7,x8,x9)
#define CTL_Car12(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11) (x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10)
#define CTL_Car13(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12) (x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11)
#define CTL_Car14(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13) (x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12)
#define CTL_Car15(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14) (x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13)
#define CTL_Car16(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15) (x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14)
#define CTL_Car17(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16) (x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15)

#define CTL_Tail1(x0)
#define CTL_Tail2(x0,x1) x1
#define CTL_Tail3(x0,x1,x2) x1,x2
#define CTL_Tail4(x0,x1,x2,x3) x1,x2, x3
#define CTL_Tail5(x0,x1,x2,x3,x4) x1,x2,x3,x4
#define CTL_Tail6(x0,x1,x2,x3,x4,x5) x1,x2,x3,x4,x5
#define CTL_Tail7(x0,x1,x2,x3,x4,x5,x6) x1,x2,x3,x4,x5,x6
#define CTL_Tail8(x0,x1,x2,x3,x4,x5,x6,x7) x1,x2,x3,x4,x5,x6,x7
#define CTL_Tail9(x0,x1,x2,x3,x4,x5,x6,x7,x8) x1,x2,x3,x4,x5,x6,x7,x8
#define CTL_Tail10(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9) x1,x2,x3,x4,x5,x6,x7,x8,x9
#define CTL_Tail11(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) x1,x2,x3,x4,x5,x6,x7,x8,x9,x10
#define CTL_Tail12(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11) x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11
#define CTL_Tail13(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12) x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12
#define CTL_Tail14(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13) x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13
#define CTL_Tail15(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14) x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14
#define CTL_Tail16(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15) x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15
#define CTL_Tail17(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16) x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16
#define CTL_Tail(list, n)  CTL_Tail##n list

#define CTL_First1(x0) x0
#define CTL_First2(x0,x1) x0
#define CTL_First3(x0,x1,x2) x0
#define CTL_First4(x0,x1,x2,x3) x0
#define CTL_First5(x0,x1,x2,x3,x4) x0
#define CTL_First6(x0,x1,x2,x3,x4,x5) x0
#define CTL_First7(x0,x1,x2,x3,x4,x5,x6) x0
#define CTL_First8(x0,x1,x2,x3,x4,x5,x6,x7) x0
#define CTL_First9(x0,x1,x2,x3,x4,x5,x6,x7,x8) x0
#define CTL_First10(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9) x0
#define CTL_First11(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10) x0
#define CTL_First12(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11) x0
#define CTL_First13(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12) x0
#define CTL_First14(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13) x0
#define CTL_First15(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14) x0
#define CTL_First16(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15) x0
#define CTL_First17(x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16) x0
#define CTL_First(list, n)  CTL_First##n list 

#define CTL_MacroApplyCdrCut(macro, sep, list, cdr)
#define CTL_MacroApplyCdr(macro, sep, list, cdr)
#define CTL_MacroApply0(macro, sep, list, cdr) CTL_Cat2(CTL_MacroApply,cdr) (macro, sep, list, cdr)
#define CTL_MacroApply1(macro, sep, list, cdr) CTL_Cat2(CTL_,cdr) (macro, list, 0)
#define CTL_MacroApply2(macro, sep, list, cdr) CTL_MacroApply1(macro, sep, CTL_Car2 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 1)
#define CTL_MacroApply3(macro, sep, list, cdr) CTL_MacroApply2(macro, sep, CTL_Car3 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 2)
#define CTL_MacroApply4(macro, sep, list, cdr) CTL_MacroApply3(macro, sep, CTL_Car4 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 3)
#define CTL_MacroApply5(macro, sep, list, cdr) CTL_MacroApply4(macro, sep, CTL_Car5 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 4)
#define CTL_MacroApply6(macro, sep, list, cdr) CTL_MacroApply5(macro, sep, CTL_Car6 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 5)
#define CTL_MacroApply7(macro, sep, list, cdr) CTL_MacroApply6(macro, sep, CTL_Car7 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 6)
#define CTL_MacroApply8(macro, sep, list, cdr) CTL_MacroApply7(macro, sep, CTL_Car8 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 7)
#define CTL_MacroApply9(macro, sep, list, cdr) CTL_MacroApply8(macro, sep, CTL_Car9 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 8)
#define CTL_MacroApply10(macro, sep, list, cdr) CTL_MacroApply9(macro, sep, CTL_Car10 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 9)
#define CTL_MacroApply11(macro, sep, list, cdr) CTL_MacroApply10(macro, sep, CTL_Car11 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 10)
#define CTL_MacroApply12(macro, sep, list, cdr) CTL_MacroApply11(macro, sep, CTL_Car12 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 11)
#define CTL_MacroApply13(macro, sep, list, cdr) CTL_MacroApply12(macro, sep, CTL_Car13 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 12)
#define CTL_MacroApply14(macro, sep, list, cdr) CTL_MacroApply13(macro, sep, CTL_Car14 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 13)
#define CTL_MacroApply15(macro, sep, list, cdr) CTL_MacroApply14(macro, sep, CTL_Car15 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 14)
#define CTL_MacroApply16(macro, sep, list, cdr) CTL_MacroApply15(macro, sep, CTL_Car16 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 15)
#define CTL_MacroApply17(macro, sep, list, cdr) CTL_MacroApply16(macro, sep, CTL_Car17 list, cdr) CTL_Cat2(CTL_, sep) CTL_Cat2(CTL_,cdr)(macro, list, 16)

#define CTL_MacroApply(macro, sep, list, n) CTL_MacroApply##n(macro, sep, list, Cdr)
#define CTL_MacroApplyCut(macro, sep, list, n) CTL_MacroApply##n(macro, sep, list, CdrCut)

#define CTL_ExprList0(expr, x, sep)
#define CTL_ExprList1(expr, x, sep) expr(x,0)
#define CTL_ExprList2(expr, x, sep) CTL_ExprList1(expr, x, sep) CTL_##sep expr(x,1)
#define CTL_ExprList3(expr, x, sep) CTL_ExprList2(expr, x, sep) CTL_##sep expr(x,2)
#define CTL_ExprList4(expr, x, sep) CTL_ExprList3(expr, x, sep) CTL_##sep expr(x,3)
#define CTL_ExprList5(expr, x, sep) CTL_ExprList4(expr, x, sep) CTL_##sep expr(x,4)
#define CTL_ExprList6(expr, x, sep) CTL_ExprList5(expr, x, sep) CTL_##sep expr(x,5)
#define CTL_ExprList7(expr, x, sep) CTL_ExprList6(expr, x, sep) CTL_##sep expr(x,6)
#define CTL_ExprList8(expr, x, sep) CTL_ExprList7(expr, x, sep) CTL_##sep expr(x,7)
#define CTL_ExprList9(expr, x, sep) CTL_ExprList8(expr, x, sep) CTL_##sep expr(x,8)
#define CTL_ExprList10(expr, x, sep) CTL_ExprList9(expr, x, sep) CTL_##sep expr(x,9)
#define CTL_ExprList11(expr, x, sep) CTL_ExprList10(expr, x, sep) CTL_##sep expr(x,10)
#define CTL_ExprList12(expr, x, sep) CTL_ExprList11(expr, x, sep) CTL_##sep expr(x,11)
#define CTL_ExprList13(expr, x, sep) CTL_ExprList12(expr, x, sep) CTL_##sep expr(x,12)
#define CTL_ExprList14(expr, x, sep) CTL_ExprList13(expr, x, sep) CTL_##sep expr(x,13)
#define CTL_ExprList15(expr, x, sep) CTL_ExprList14(expr, x, sep) CTL_##sep expr(x,14)
#define CTL_ExprList16(expr, x, sep) CTL_ExprList15(expr, x, sep) CTL_##sep expr(x,15)
#define CTL_ExprList17(expr, x, sep) CTL_ExprList16(expr, x, sep) CTL_##sep expr(x,16)

#define CTL_ExprList(expr, x, sep, n) CTL_Cat2(CTL_ExprList,n) (expr, x, sep)
#define CTL_PairListItem(X,n) X##n& x##n
#define CTL_ListSep(x, sep, n) CTL_Cat2(CTL_ExprList,n) (CTL_Cat2, x, sep)
#define CTL_Cat2Comma(a,b) ,CTL_Cat2(a,b) 
#define CTL_HeadListSep(x, sep, n) CTL_Cat2(CTL_ExprList,n) (CTL_Cat2Comma, x, sep)
#define CTL_List(x, n) CTL_ListSep(x, Comma, n)
#define CTL_HeadList(x, n) CTL_HeadListSep(x, Space, n)
#define CTL_PairList(x, n) CTL_Cat2(CTL_ExprList,n) (CTL_PairListItem, x, Comma)

#define CTL_DList0
#define CTL_DList1(t0) (CTL_MacroApply(CTL_ArgItem, Comma, (t0), 1))
#define CTL_DList2(t0,t1) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1), 2))
#define CTL_DList3(t0,t1,t2) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2), 3))
#define CTL_DList4(t0,t1,t2,t3) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3), 4))
#define CTL_DList5(t0,t1,t2,t3,t4) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4), 5))
#define CTL_DList6(t0,t1,t2,t3,t4,t5) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5), 6))
#define CTL_DList7(t0,t1,t2,t3,t4,t5,t6) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6), 7))
#define CTL_DList8(t0,t1,t2,t3,t4,t5,t6,t7) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7), 8))
#define CTL_DList9(t0,t1,t2,t3,t4,t5,t6,t7,t8) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8), 9))
#define CTL_DList10(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9), 10))
#define CTL_DList11(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10), 11))
#define CTL_DList12(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11), 12))
#define CTL_DList13(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12), 13))
#define CTL_DList14(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13), 14))
#define CTL_DList15(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14), 15))
#define CTL_DList16(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15), 16))
#define CTL_DList17(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16) (CTL_MacroApply(CTL_ArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16), 17))

#define CTL_EList0
#define CTL_EList1(t0) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0), 1))
#define CTL_EList2(t0,t1) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1), 2))
#define CTL_EList3(t0,t1,t2) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2), 3))
#define CTL_EList4(t0,t1,t2,t3) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3), 4))
#define CTL_EList5(t0,t1,t2,t3,t4) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4), 5))
#define CTL_EList6(t0,t1,t2,t3,t4,t5) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5), 6))
#define CTL_EList7(t0,t1,t2,t3,t4,t5,t6) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6), 7))
#define CTL_EList8(t0,t1,t2,t3,t4,t5,t6,t7) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7), 8))
#define CTL_EList9(t0,t1,t2,t3,t4,t5,t6,t7,t8) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8), 9))
#define CTL_EList10(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9), 10))
#define CTL_EList11(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10), 11))
#define CTL_EList12(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11), 12))
#define CTL_EList13(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12), 13))
#define CTL_EList14(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13), 14))
#define CTL_EList15(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14), 15))
#define CTL_EList16(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15), 16))
#define CTL_EList17(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16) (CTL_MacroApply(CTL_ArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16), 17))

#define CTL_FList0
#define CTL_FList1(t0) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0), 1))
#define CTL_FList2(t0,t1) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1), 2))
#define CTL_FList3(t0,t1,t2) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2), 3))
#define CTL_FList4(t0,t1,t2,t3) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3), 4))
#define CTL_FList5(t0,t1,t2,t3,t4) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4), 5))
#define CTL_FList6(t0,t1,t2,t3,t4,t5) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5), 6))
#define CTL_FList7(t0,t1,t2,t3,t4,t5,t6) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6), 7))
#define CTL_FList8(t0,t1,t2,t3,t4,t5,t6,t7) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7), 8))
#define CTL_FList9(t0,t1,t2,t3,t4,t5,t6,t7,t8) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8), 9))
#define CTL_FList10(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9), 10))
#define CTL_FList11(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10), 11))
#define CTL_FList12(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11), 12))
#define CTL_FList13(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12), 13))
#define CTL_FList14(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13), 14))
#define CTL_FList15(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14), 15))
#define CTL_FList16(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15), 16))
#define CTL_FList17(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16) (CTL_MacroApply(CTL_MethArgDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16), 17))

#define CTL_GList0
#define CTL_GList1(t0) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0), 1))
#define CTL_GList2(t0,t1) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1), 2))
#define CTL_GList3(t0,t1,t2) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2), 3))
#define CTL_GList4(t0,t1,t2,t3) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3), 4))
#define CTL_GList5(t0,t1,t2,t3,t4) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4), 5))
#define CTL_GList6(t0,t1,t2,t3,t4,t5) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5), 6))
#define CTL_GList7(t0,t1,t2,t3,t4,t5,t6) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6), 7))
#define CTL_GList8(t0,t1,t2,t3,t4,t5,t6,t7) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7), 8))
#define CTL_GList9(t0,t1,t2,t3,t4,t5,t6,t7,t8) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8), 9))
#define CTL_GList10(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9), 10))
#define CTL_GList11(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10), 11))
#define CTL_GList12(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11), 12))
#define CTL_GList13(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12), 13))
#define CTL_GList14(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13), 14))
#define CTL_GList15(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14), 15))
#define CTL_GList16(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15), 16))
#define CTL_GList17(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16) (CTL_MacroApply(CTL_MethArgItem, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16), 17))

#define CTL_HList0
#define CTL_HList1(t0) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0), 1))
#define CTL_HList2(t0,t1) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1), 2))
#define CTL_HList3(t0,t1,t2) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2), 3))
#define CTL_HList4(t0,t1,t2,t3) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3), 4))
#define CTL_HList5(t0,t1,t2,t3,t4) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4), 5))
#define CTL_HList6(t0,t1,t2,t3,t4,t5) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5), 6))
#define CTL_HList7(t0,t1,t2,t3,t4,t5,t6) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6), 7))
#define CTL_HList8(t0,t1,t2,t3,t4,t5,t6,t7) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7), 8))
#define CTL_H_List9(t0,t1,t2,t3,t4,t5,t6,t7,t8) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8), 9))
#define CTL_HList10(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9), 10))
#define CTL_HList11(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10), 11))
#define CTL_HList12(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11), 12))
#define CTL_HList13(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12), 13))
#define CTL_HList14(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13), 14))
#define CTL_HList15(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14), 15))
#define CTL_HList16(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15), 16))
#define CTL_HList17(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16) (CTL_MacroApply(CTL_ArgSimplDecl, Comma, (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16), 17))

#define CTL_MethArgDecl(n, T) CTL_ArgX(X,n)
#define CTL_MethArgItem(n, T) CTL_MethArgDecl(n, T) x##n
#define CTL_MethArgItemComma(T, n) CTL_MethArgDecl(n, T) x##n,

#define CTL_ArgSimplDecl(n, T) CTL_Trans1(T)
#define CTL_ArgDecl(n, T) CTL_Typename ctl::argAlias<CTL_Trans1(T) >::resultT
#define CTL_ArgItem(n, T) CTL_ArgDecl(n, T) x##n

#define CTL_ArgTypedefItemH(n,type)\
	 typedef CTL_Typename ctl::alias<CTL_Trans1(type) >::resultT CTL_ArgX(T,n);\
	 typedef CTL_Typename ctl::binArg<CTL_ArgX(T,n) >::resultT CTL_ArgX(X,n);
#define CTL_ArgTypedefItem(n, T) CTL_ArgTypedefItemH(n, T) 

#define CTL_ArgList(list,n) \
  CTL_Exp1(CTL_DList, list,n)

#define CTL_ArgDclr(list,n) \
  CTL_Exp1(CTL_EList, list,n)

#define CTL_MethArgDclr(list,n) \
  CTL_Exp1(CTL_FList, list,n)

#define CTL_MethArgList(list,n) \
  CTL_Exp1(CTL_GList, list,n)

#define CTL_MethSimplArgList(list,n) \
  CTL_Exp1(CTL_HList, list,n)

#define CTL_CommaArgItem(n, T) , CTL_ArgItem(n, T)
#define CTL_ArgItemComma(n, T) CTL_ArgItem(n, T),

#define CTL_IdentComma(n, T) T,

#define CTL_ArgTypedef(list,n) \
	CTL_MacroApplyCut(CTL_ArgTypedefItem, Space, list, n) 

#define CTL_UnbracedArgList(list,n) \
	CTL_MacroApply(CTL_CommaArgItem, Space, list, n) 

#define CTL_AppendedList(tail,list,n) \
	(CTL_MacroApply(CTL_IdentComma, Space, list, n) tail ), CTL_Succ(n)

#define CTL_TailedArgList(list,n, TList, nT) \
	(CTL_MacroApply(CTL_ArgItemComma, Space, list, n) CTL_FieldTypeF(TList, nT) = CTL_FieldTypeF(TList, nT)())

#define CTL_FieldTypeF(TList, nT) \
	ctl::field##H##nT CTL_Get(TList,nT)

#define CTL_Get(list, n) CTL_MacroApplyCut(CTL_SecondTrans, Comma, list, n)
#define CTL_GetWC(list, n) CTL_MacroApply(CTL_SecondTrans, Comma, list, n)

#define CTL_Get2_1H(a,b) a
#define CTL_Get2_2H(a,b) b
#define CTL_Get2_1(list) CTL_Get2_1H list
#define CTL_Get2_2(list) CTL_Get2_2H list
#define CTL_Get_2_2(list) CTL_Get2_2 (list)

#define CTL_Get3_1H(a,b,c) a
#define CTL_Get3_2H(a,b,c) b
#define CTL_Get3_3H(a,b,c) c
#define CTL_Get3_1(list) CTL_Get3_1H list
#define CTL_Get3_2(list) CTL_Get3_2H list
#define CTL_Get3_3(list) CTL_Get3_3H list

#define CTL_Get4_4H(a,b,c,d) d
#define CTL_Get4_4(list) CTL_Get4_4H list
#define CTL_Get_4_4(list) CTL_Get4_4(list)

#define CTL_Get4_2H(a,b,c,d) b
#define CTL_Get4_2(list) CTL_Get4_2H list
#define CTL_Get_4_2(list) CTL_Get4_2(list)

#define CTL_Get5_5H(a,b,c,d,e) e
#define CTL_Get5_5(list) CTL_Get5_5H list
#define CTL_Get_5_5(list) CTL_Get5_5(list)


#define CTL_Get7_7H(a,b,c,d,e,f,h) h
#define CTL_Get7_7(list) CTL_Get7_7H list
#define CTL_Get_7_7(list) CTL_Get7_7(list)


#define CTL_StrH5(x) #x
#define CTL_StrH4(x) CTL_StrH5(x)
#define CTL_StrH3(x) CTL_StrH4(x)
#define CTL_StrH2(x) CTL_StrH3(x)
#define CTL_StrH1(x) CTL_StrH2(x)
#define CTL_Str(x) CTL_StrH1(x)


#define CTL_Cat2H(a,b) a ## b
#define CTL_Cat2(a,b) CTL_Cat2H(a,b)
#define CTL_Cat_2(a,b) CTL_Cat2(a,b)
#define CTL_CatH3(a,b,c) a ## b ## c
#define CTL_Cat3(a,b,c) CTL_CatH3(a, b, c)
#define CTL_CatH4(a,b,c,d) a ## b ## c ## d
#define CTL_Cat4(a,b,c,d) CTL_CatH4(a, b, c, d)
#define CTL_CatH5(a,b,c,d,e) a ## b ## c ## d  ## e
#define CTL_Cat5(a,b,c,d,e) CTL_CatH5(a, b, c, d, e)

#define CTL_Sig_f(mid,y,f,list,n) f

#define CTL_Exp1(macro,list,n) CTL_Cat2(macro,n) list

#define CTL_Exp5(macro,macro2, y, list, n, sep, flag) CTL_Exp5H(CTL_Cat2(macro, flag),macro2, y, list, n, sep)
#define CTL_Exp5H(macro,macro2, y, list, n, sep) macro (macro2, y, list, n, sep)


#define CTL_TypeNameList3(C, TList, n)\
	CTL_TypeNameList(TList,nT)	

#define CTL_TypeNameExpr(n,T) ctl::getTypeId<T >()
#define CTL_TypeNameList(TList,nT)  ctl::typeId("<") + CTL_MacroApply(CTL_TypeNameExpr, StringList, TList, nT)  +  ">"

#define CTL_TmplNameStr1(TList) CTL_TmplNameStrH ((TList))
#define CTL_TmplNameStrH(TList) CTL_TmplNameStr3 TList
#define CTL_TmplNameStr3(T,TList, nT)\
	ctl::typeId(CTL_Str(T))+CTL_TypeNameList(TList,nT)

// class TList[0], class TList[1], ...
#define CTL_ClassType(n, X) typename X
#define CTL_GetClassList(TList,nT)\
	CTL_MacroApply(CTL_ClassType, Comma, TList, nT)

#define CTL_Tmpl_EmptyDclr(list) CTL_Tmpl_EmptyDclrH ((list))
#define CTL_Tmpl_EmptyDclrH(list) CTL_Tmpl_EmptyDclr3 list
#define CTL_Tmpl_EmptyDclr3(C,TList,nT)\
	CTL_Tmpl_Dclr2(TList,nT)

#define CTL_Tmpl_Dclr(list) CTL_Tmpl_DclrH ((list))
#define CTL_Tmpl_DclrH(list) CTL_Tmpl_Dclr3 list
#define CTL_Tmpl_Dclr2(TList,nT)\
	template< CTL_GetClassList(TList,nT) >
#define CTL_Tmpl_Dclr3(C,TList,nT)\
	CTL_Tmpl_Dclr2(TList,nT)  struct C

#define CTL_ClassList(T, n) typename T##n

#define CTL_StrList0
#define CTL_StrList1(T0) #T0
#define CTL_StrList2(T0,T1)  #T0, #T1
#define CTL_StrList3(T0,T1,T2) #T0, #T1, #T2

#define CTL_StrList(list,n) CTL_Exp1(CTL_StrList,list,n)

#define CTL_Tmpl_Name1(TList) CTL_Tmpl_NameH((TList))
#define CTL_Tmpl_NameH(x) CTL_Tmpl_Name x
#define CTL_Tmpl_NameRP(C,TList,n)\
	C < CTL_MacroApplyCut(CTL_SecondTransRP, Comma, TList, n)> 	

#define CTL_Tmpl_Name2(C,List) CTL_Tmpl_Name3H(C, CTL_Get2_1H  List, CTL_Get2_2H  List)
#define CTL_Tmpl_Name3H(C, list, n) CTL_Tmpl_Name3(C, list, n)
#define CTL_Tmpl_Name3(C, list, n) CTL_Tmpl_Name(C##n, list, n)
#define CTL_Tmpl_Name(C,TList,n)\
	C < CTL_MacroApplyCut(CTL_SecondTrans, Comma, TList, n) > 	

#define CTL_Tmpl_Name2S(C,List) CTL_Tmpl_Name3HS(C, CTL_Get2_1H  List, CTL_Get2_2H  List)
#define CTL_Tmpl_Name3HS(C, list, n) CTL_Tmpl_Name(C, list, n)

#define CTL_ArgTmpl_Name(C,TList,n)\
	C < CTL_MacroApply(CTL_ArgDecl, Comma, TList, n) >	

#define CTL_Field_Type(list, n) \
	CTL_Tmpl_Name(ctl::field##n, list, n)	

#define CTL_Field_TypeRP(list, n) \
	CTL_Tmpl_NameRP(ctl::field##n, list, n)	

#define CTL_ArgField_Type(list, n) \
	CTL_ArgTmpl_Name(ctl::field##n, list, n)	

#define CTL_ConnectHelp(n, type)\
	ctl::connectType((type*)0);
#define CTL_ConnList(list) CTL_ConnList2 list
#define CTL_ConnList2(list,n)\
	CTL_MacroApply(CTL_ConnectHelp, Space , list, n)

#define CTL_CatchBlock(n, type)\
	CTL_Catch(const type &excption)\
	{\
		excpt = new ctl::excptHandle(excption);\
		ctl::log("#x !! user exception %s caught\n", ctl::typeName<type>().string().c_str());\
 	}

#define CTL_CatchList(list) CTL_CatchList2 list
#define CTL_CatchList1(x) CTL_CatchList2 x
#define CTL_CatchList2(list,n)\
	CTL_MacroApply(CTL_CatchBlock, Space , list, n)

#ifdef CTL_Debug
#	define CTL_Assert(expr)\
	if(!(expr))\
	{\
		ctl::log("#x !! %s: %d: assertion %s failed\n", __FILE__,__LINE__, #expr);\
		assert(expr);\
	}
#else
#	define CTL_Assert(expr) {}
#endif

#define CTL_CopyConstrExist(list, n) CTL_CopyConstrExist##n (list)
#define CTL_CopyConstrExistH(x) static int CTL_constrExist(int,CTL_Typename ctl::isBinaryRep< CTL_SecondTrans(0, x) >::ws);
#define CTL_CopyConstrExist1(x) CTL_CopyConstrExistH x
#define CTL_CopyConstrExist2(x)
#define CTL_CopyConstrExist3(x)
#define CTL_CopyConstrExist4(x)
#define CTL_CopyConstrExist5(x)
#define CTL_CopyConstrExist6(x)
#define CTL_CopyConstrExist7(x)
#define CTL_CopyConstrExist8(x)
#define CTL_CopyConstrExist9(x)
#define CTL_CopyConstrExist10(x)
#define CTL_CopyConstrExist11(x)
#define CTL_CopyConstrExist12(x)
#define CTL_CopyConstrExist13(x)
#define CTL_CopyConstrExist14(x)
#define CTL_CopyConstrExist15(x)
#define CTL_CopyConstrExist16(x)
#define CTL_CopyConstrExist17(x)



// Base List Definitions
#define CTL_CI_BaseDclrH(n,T ) public CTL_Trans1(T)
#define CTL_CI_BaseDclr(x)   CTL_CI_BaseDclr2 x
#define CTL_CI_BaseDclr2(list, n)    CTL_MacroApply(CTL_CI_BaseDclrH, Comma ,list, n)

#define CTL_IF_BaseDclrH(n,T ) public CTL_Trans1(T)::CTL_Interface
#define CTL_IF_BaseDclr(x)   CTL_IF_BaseDclr2 x
#define CTL_IF_BaseDclr2(list, n)    CTL_MacroApply(CTL_IF_BaseDclrH, Comma ,list, n)

#define CTL_RB_BaseDclrH(n,T ) typedef typename CTL_Trans1(T):: CTL_TemplateDclr CTL_RemoteInstanceBaseExt<CTL_RBaseT##n>::CTL_RBaseT CTL_Cat2(CTL_RBaseT, CTL_Succ(n));
#define CTL_RB_BaseDclr(x)   CTL_RB_BaseDclr2 x
#define CTL_RB_BaseDclr2(list, n)    CTL_MacroApply(CTL_RB_BaseDclrH, Space ,list, n)

#define CTL_IB_BaseDclrH(n,T ) typedef typename CTL_Trans1(T):: CTL_TemplateDclr CTL_ImplDef<Impl, detail, CTL_IBaseT##n>::CTL_IBaseT CTL_Cat2(CTL_IBaseT, CTL_Succ(n));
#define CTL_IB_BaseDclr(x)   CTL_IB_BaseDclr2 x
#define CTL_IB_BaseDclr2(list, n)    CTL_MacroApply(CTL_IB_BaseDclrH, Space ,list, n)

#define CTL_IR_BaseDclrH(n,T ) typedef typename CTL_Trans1(T):: CTL_TemplateDclr CTL_RecvDef<CTL_IBaseT##n>::CTL_IBaseT CTL_Cat2(CTL_IBaseT, CTL_Succ(n));
#define CTL_IR_BaseDclr(x)   CTL_IR_BaseDclr2 x
#define CTL_IR_BaseDclr2(list, n)    CTL_MacroApply(CTL_IR_BaseDclrH, Space ,list, n)

#define CTL_setCICallH(n,T )	CTL_Trans1(T)::CTL_setCIP(ci);
#define CTL_setCICall(x)   CTL_setCICall2 x
#define CTL_setCICall2(list, n)    CTL_MacroApply(CTL_setCICallH, Space ,list, n)

#define CTL_ConnectStaticH(n,T )	CTL_Trans1(T)::CTL_connectStatic(rec, (Impl*)0, (detail*)0);
#define CTL_ConnectStatic(x)   CTL_ConnectStatic2 x
#define CTL_ConnectStatic2(list, n)    CTL_MacroApply(CTL_ConnectStaticH, Space ,list, n)

#define CTL_base_initH(n,T )	CTL_Trans1(T)()
#define CTL_base_init(x)   CTL_base_init2 x
#define CTL_base_init2(list, n)    CTL_MacroApply(CTL_base_initH, Comma ,list, n)

#define CTL_base_useH(n,T )	CTL_Trans1(T)::use(p);
#define CTL_base_use(x)   CTL_base_use2 x
#define CTL_base_use2(list, n)    CTL_MacroApply(CTL_base_useH, Space ,list, n)

#define CTL_base_nameH(n,T )	CTL_Trans1(T)::CTL_fullTypeNameS()
#define CTL_base_name(x)   CTL_base_name2 x
#define CTL_base_name2(list, n)    CTL_MacroApply(CTL_base_nameH, CommaStr ,list, n)

#endif

