/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL_SYSTYPES_H_
#define CTL_SYSTYPES_H_

#ifndef CTL_MSC_HEADER
#include <dlfcn.h>
#include <unistd.h>
#include <sys/socket.h>    
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <pthread.h>
#include <sys/uio.h>
#include <sys/stat.h>
#include <signal.h>
#ifdef CTL_OSX
	#include <sys/wait.h>
#else
	#include <wait.h>
#endif

#include <sys/resource.h>
#ifdef _POSIX_PRIORITY_SCHEDULING
#	define CTL_SchedYield
#endif
#else

#	include <Winsock2.h>
#	include <direct.h>
#	include <process.h>
#	include <io.h>

#endif

#include <errno.h>
#include <fcntl.h>


namespace ctl
{
	namespace sys
	{
#ifdef CTL_Win32
#	define CTL_runDclr		sys::threadResult __stdcall
	typedef int sockl_t;
	typedef _WSABUF iovec;
	typedef char sockBool;
	typedef HMODULE LibHandle; 
	typedef unsigned int threadIdType;
	typedef unsigned int threadResult;
	enum { f_setfl, o_nonblock };
	enum { shut_rdwr };

#elif	defined(CTL_SGI) || defined (CTL_Alpha)
	typedef int sockl_t;
	typedef int sockBool;
#else
	typedef socklen_t sockl_t;
	typedef int sockBool;
#endif
#if defined(CTL_HPUX)  || defined(CTL_Alpha)
	typedef int addr_t;
#else
	typedef sockl_t addr_t;
#endif

#ifndef CTL_Win32
	enum { f_setfl=F_SETFL, o_nonblock = O_NONBLOCK };
	enum {shut_rd= SHUT_RD, shut_rdwr= SHUT_RDWR };
	typedef ::iovec iovec;
	typedef void* LibHandle; 
	typedef pthread_t threadIdType;
	typedef void* threadResult;
#endif
	} // system
} //ctl

#endif

