/******************************************************************************

This file is part of the Component Template Library (CTL) 

Copyright (C) 2006  Rainer Niekamp
email:              r.niekamp@tu-bs.de

The CTL is free software; you can redistribute it and/or modify it under the 
terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2.1 of the License, or (at your option) any later 
version. We only ask that proper credit be given to the author.

This library is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License 
for more details.

You should have received a copy of the GNU Lesser General Public License along 
with this library; if not, write to the Free Software Foundation, 
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

******************************************************************************/

#ifndef CTL_UTL_INL_
#define CTL_UTL_INL_

#include "ctl/utl/factory.h"

namespace ctl
{
	CTL_Inline void factory::throwIt(const typeId &type, iStream &is) const
	{	
		void *p=0;
		const polymorphIOBase * const * io=factoryS().ioM.find(type.c_str());
		ctl::log("#x !! throwing  %s(%p)\n",  type.c_str(), this);
    if(!!io)
			(*io)->CTL_read(p, is, true);
		else
			CTL_Throw(ctl::exception(ctl::string(" *** unknown type") + type +" ***"));
	}

	CTL_Inline void binaryObject::throwIt()
	{     	
		if(!buffer)
			return;
// istream doesn't hold the buffer
		vector<char> b= buffer;
		iStream is(b);
		typeId t = type;
		clear();
		factoryS().throwIt(t, is);
	}

}

#endif

