####################################################################
#General Configuration
####################################################################
CTLDIR            =../
CTLINCLUDE        =-I$(CTLDIR)include/
MPI               ?=TRUE
PVM               =FALSE
# default gateway
SSH_GATEWAY	  ?=valkyrie.sc.cs.tu-bs.de
#SSH_GATEWAY				=<your gateway>
CTLLOCATOR        =TRUE
MACHINECLOCKRATE  =3e9
CCSUFFIX          =cpp
OBJDIR            =./
SO_LOADER					=-DCTL_Loader=\"/lib/ld-linux.so.2\"
ifneq "$(SSH_GATEWAY)" ""
COMMONFLAGS	  +=-DCTL_SSH_GATEWAY=$(SSH_GATEWAY) 
endif

RELEASEFLAGS      =$(COMMONFLAGS) -fPIC -DNDEBUG -DCTL_CatchSignals -O2#  -pg
DEBUGFLAGS        =$(COMMONFLAGS) -fPIC -DDEBUG -O0 -g3

### COMPILER CONFIGURATION
ifdef CPL
				CXX               :=$(CPL)
else
				CXX               :=g++#DEFAULT 
endif

ifeq "$(CXX)" "g++"
RELEASEFLAGS      +=
DEBUGFLAGS        +=
endif

ifeq "$(CXX)" "icpc"
COMMONFLAGS				+= -gcc-name=/usr/bin/gcc-4.2 -gcc-version=420
RELEASEFLAGS      += -fast
DEBUGFLAGS        += 
endif

### OPTIONAL ONLY USED IF PVM=TRUE ####
PVMINCLUDE = -I/usr/share/pvm3/include
PVMFLAGS   = -DCTL_LAM -DCTL_PVM
PVMLIBS    = -L/usr/share/pvm3/lib/LINUX/ -lpvm3
### OPTIONAL ONLY USED IF MPI=TRUE ####
MPIINCLUDE = -I/usr/include/lam
MPILIBS    = -L/usr/lib/lam/lib/ -lmpi -llam -llammpi++
MPIFLAGS   = -DCTL_LAM


### TARGET CONFIGURATION
HOSTTYPE:=$(shell uname -m)
OSTYPE  :=$(shell uname -s)
TARGET  :=$(CXX)$(OSTYPE)$(HOSTTYPE)
OUTDIR  ?=libctl_$(TARGET)/

ifeq "$(OSTYPE)" "Darwin"
  SHAREDFLAG = -dynamiclib
else
  SHAREDFLAG = -shared
endif

