#CHECKING SOME ASSUMPTIONS
ifdef $(call localised,CONNECTSOURCEPREFIX) 
ifdef $(call localised,CCSUFFIX) 

#######################################################
### FINDING SOURCES GIVEN BY STRUCT ###################
#######################################################
define SOURCEFIND
### FILTERS
$(call localised,LOCALCXXSOURCE):=$$(filter-out $($(call localised,CONNECTSOURCEPREFIX))%.$($(call localised,CCSUFFIX)),$$(wildcard $(1)*.$($(call localised,CCSUFFIX))))
$(call localised,LOCALCXXOBJECT):=$$(subst $(1),$(OBJDIR),$$($(call localised,LOCALCXXSOURCE):.$($(call localised,CCSUFFIX))=.o))
$(call localised,LOCALCSOURCE):=$$(wildcard $(1)*.$($(call localised,CSUFFIX)))
$(call localised,LOCALCOBJECT):=$$(subst $(1),$(OBJDIR),$$($(call localised,LOCALCSOURCE):.$($(call localised,CSUFFIX))=.o))
$(call localised,LOCALFSOURCE):=$$(wildcard $(1)*.$($(call localised,FSUFFIX)))
$(call localised,LOCALFOBJECT):=$$(subst $(1),$(OBJDIR),$$($(call localised,LOCALFSOURCE):.$($(call localised,FSUFFIX))=.o))
$(call localised,LOCALPSOURCE):=$$(wildcard $(1)*.$($(call localised,PSUFFIX)))
$(call localised,LOCALPOBJECT):=$$(subst $(1),$(OBJDIR),$$($(call localised,LOCALPSOURCE):.$($(call localised,PSUFFIX))=.o))
$(call localised,LOCALCONNECT):=$$(wildcard $(1)$($(call localised,CONNECTSOURCEPREFIX))*.$($(call localised,CCSUFFIX)))
### COLLECTORS
$(call localised,LOCALSOURCE):=$$($(call localised,LOCALSOURCE)) $$($(call localised,LOCALCSOURCE)) \
		       $$($(call localised,LOCALCXXSOURCE)) $$($(call localised,LOCALFSOURCE)) $$($(call localised,LOCALPSOURCE))
$(call localised,LOCALOBJECT):=$$($(call localised,LOCALOBJECT)) $$($(call localised,LOCALCOBJECT)) \
		       $$($(call localised,LOCALCXXOBJECT)) $$($(call localised,LOCALFOBJECT)) $$($(call localised,LOCALPOBJECT))
$(call localised,LOCALSERVICETARGET):=$$($(call localised,LOCALSERVICETARGET)) $$(subst $($(call localised,CONNECTSOURCEPREFIX)),,$$(subst $(1),$(BIN),$$(subst .$($(call localised,CCSUFFIX)),.ctl.so ,$$($(call localised,LOCALCONNECT))))) $$(subst $($(call localised,CONNECTSOURCEPREFIX)),,$$(subst $(1),$(BIN),$$(subst .$($(call localised,CCSUFFIX)),.ctl.exe,$$($(call localised,LOCALCONNECT))))) 
endef
### -> CALL :
$(eval $(call SOURCEFIND,$(SRC)))
$(foreach SRCDIR,$($(call localised,SOURCEDIR)),$(eval $(call SOURCEFIND,$(SRCDIR))))

######################################################
################ TEST VARIABLES ######################
######################################################
$(call localised,LOCALCXXTEST):=$(strip $(wildcard $(TEST)*Test.$($(call localised,CCSUFFIX)))) 
$(call localised,LOCALFTEST):=$(strip $(wildcard $(TEST)*Test.$($(call localised,FSUFFIX)))) 
$(call localised,LOCALCTEST):=$(strip $(wildcard $(TEST)*Test.$($(call localised,CSUFFIX)))) 
$(call localised,LOCALPTEST):=$(strip $(wildcard $(TEST)*Test.$($(call localised,PSUFFIX))))
$(call localised,LOCALTEST):=$($(call localised,LOCALCXXTEST)) $($(call localised,LOCALFTEST)) $($(call localised,LOCALCTEST)) $($(call localised,LOCALPTEST))

$(call localised,LOCALCXXTESTTARGET):=$(strip $(subst test,bin,$($(call localised,LOCALCXXTEST):Test.$($(call localised,CCSUFFIX))=TEST)))
$(call localised,LOCALFTESTTARGET):=$(strip $(subst test,bin,$($(call localised,LOCALFTEST):Test.$($(call localised,FSUFFIX))=TEST)))
$(call localised,LOCALCTESTTARGET):=$(strip $(subst test,bin,$($(call localised,LOCALCTEST):Test.$($(call localised,CSUFFIX))=TEST)))
$(call localised,LOCALPTESTTARGET):=$(strip $(subst test,bin,$($(call localised,LOCALPTEST):Test.$($(call localised,PSUFFIX))=TEST)))
$(call localised,LOCALTESTTARGET):= $($(call localised,LOCALCXXTESTTARGET)) $($(call localised,LOCALFTESTTARGET)) $($(call localised,LOCALCTESTTARGET)) $($(call localised,LOCALPTESTTARGET)) 

$(call localised,LOCALCXXTESTOUTPUT):=$(strip $(subst TEST,TEST.output,$($(call localised,LOCALCXXTESTTARGET)) $(wildcard $(BIN)*TEST)))
$(call localised,LOCALFTESTOUTPUT):=$(strip $(subst TEST,TEST.output,$($(call localised,LOCALFTESTTARGET)) $(wildcard $(BIN)*TEST)))
$(call localised,LOCALCTESTOUTPUT):=$(strip $(subst TEST,TEST.output,$($(call localised,LOCALCTESTTARGET)) $(wildcard $(BIN)*TEST)))
$(call localised,LOCALPTESTOUTPUT):=$(strip $(subst TEST,TEST.output,$($(call localised,LOCALPTESTTARGET)) $(wildcard $(BIN)*TEST)))
$(call localised,LOCALTESTOUTPUT):=$($(call localised,LOCALCXXTESTOUTPUT)) $($(call localised,LOCALFTESTOUTPUT)) $($(call localised,LOCALCTESTOUTPUT)) $($(call localised,LOCALPTESTOUTPUT))


$(call localised,LOCALCXXTESTRERUN):=$(strip $(subst TEST,TEST.rerun,$($(call localised,LOCALCXXTESTTARGET)) $(wildcard $(BIN)*TEST)))
$(call localised,LOCALFTESTRERUN):=$(strip $(subst TEST,TEST.rerun,$($(call localised,LOCALFTESTTARGET)) $(wildcard $(BIN)*TEST)))
$(call localised,LOCALCTESTRERUN):=$(strip $(subst TEST,TEST.rerun,$($(call localised,LOCALCTESTTARGET)) $(wildcard $(BIN)*TEST)))
$(call localised,LOCALPTESTRERUN):=$(strip $(subst TEST,TEST.rerun,$($(call localised,LOCALPTESTTARGET)) $(wildcard $(BIN)*TEST)))
$(call localised,LOCALTESTRERUN):= $($(call localised,LOCALCXXTESTRERUN)) $($(call localised,LOCALFTESTRERUN)) $($(call localised,LOCALCTESTRERUN)) $($(call localised,LOCALPTESTRERUN))


######################################################
### COLLECTORS #######################################
######################################################
define COLLECTORS
ALLTEST:=$(strip $(ALLTEST) $($(call localised,LOCALTEST)))
TESTTARGET:=$(strip $(TESTTARGET) $($(call localised,LOCALTESTTARGET)))
TESTOUTPUT:=$(strip $(TESTOUTPUT) $($(call localised,LOCALTESTOUTPUT)))
TESTRERUN:=$(strip $(TESTRERUN) $($(call localised,LOCALTESTRERUN)))
SOURCEFILES+=$(strip $($(call localised,LOCALSOURCE)) $($(call localised,LOCALTEST)) $($(call localised,LOCALCONNECT)))
SERVICETARGET:=$(strip $(SERVICETARGET) $($(call localised,LOCALSERVICETARGET)))
TARGETS:=$(strip $(SERVICETARGET) $(CLIENTTARGET))
endef
ifeq "$($(COMPDIR)ISINCLUDED)" "TRUE"
  ifneq "$(MAKECMDGOALS)" "clean"
    ifneq "$(MAKECMDGOALS)" "DEPCLEAN"
      ifneq "$(INCLUDETARGETS)" "false"
        $(eval $(call COLLECTORS))
      endif
    endif
  endif
else
    $(eval $(call COLLECTORS))
endif

######################################################
### IDL DEPEND #######################################
######################################################
$($(call localised,LOCALOBJECT)):$(subst .idl,.ci,$(wildcard $(COMPDIR)include/ci/*.idl))

################ DEP VARIABLES #######################
$(COMPDIR)DEPFILES:=$(wildcard $(DEP)*.d)
ALLDEPFILES:=$(strip $(ALLDEPFILES) $($(call localised,DEPFILES)))


#NOT DELETE TESTS
.PRECIOUS:$(TESTTARGET)

#GIVING WARNINGS IF ASSUMPTIONS FAIL... Nothing will be automatically found
else
$(warning Variable $(call localised,CCSUFFIX) is not defined... please adopt your config.mk; otherwise targets will not be automatically discovered )
endif
else
$(warning Variable $(call localised,CONNECTSOURCEPREFIX)  is not defined... please adopt your config.mk; otherwise targets will not be automatically discovered)
endif

DIRECTORYSTRUCT:=$(COMPDIR)component\
		 $(COMPDIR)bin\
		 $(COMPDIR)src\
		 $(COMPDIR)dep\
		 $(COMPDIR)include\
		 $(COMPDIR)include/ci\
		 $(COMPDIR)obj\
		 $(COMPDIR)test\
		 $(COMPDIR)library
