####################################
# SET COMPONENT AVALABLE          ##
####################################
AVAILABLE:=$(AVAILABLE) $(call ID,$(COMPONENTNAME))

$(COMPDIR)COMPONENTNAME:=$(COMPONENTNAME)
ifneq "$(COMPDIR)" ""
COMPONENTNAME=$($(COMPDIR)COMPONENTNAME)
endif

ifneq "$(strip $(CTL_DIR))" ""
CTLCONFIGURED=FALSE
endif
ifneq "$(CTLCONFIGURED)" "TRUE"
CTLCONFIGURED=TRUE
ifneq "$(NOCTL)" "TRUE"
  ifneq "$(strip $(CTL_DIR))" ""
    CTL_INCLUDE_PATH  =$(CTL_DIR)include
    CTL_LIBRARY_PATH  =$(CTL_DIR)lib/$(CTL_RELATIVE_LIBDIR)
    $(CTL_LIBRARY_PATH)%:
	@cd $(CTL_DIR)lib&&$(MAKE) $(CTL_RELATIVE_LIBDIR)$*

    CTL_INCFLAGS:=-I$(CTL_INCLUDE_PATH) -I$(CTL_INCLUDE_PATH)/ctl/ci
    ifdef GDB 
      CTLLIB:=$(CTL_LIBRARY_PATH)libctlD.so
    else
      CTLLIB:=$(CTL_LIBRARY_PATH)libctl.so
    endif #GDB1
    CTL_LDLIBS:=$(CTLLIB)
    $(TARGETS):$(CTLLIB)
    ALLDEP+=$(CTLLIB)
  else  #CTL_DIR
    ifdef GDB
      CTL_LDLIBS:=-lctlD
    else
      CTL_LDLIBS:=-lctl
    endif #GDB2
  endif #CTL_DIR	
endif #NOCTL
endif #CTLCONFIGURED

ifdef GDB
    CPPFLAGS      +=-Wall -g3 -O0 -DDEBUG
endif #GDB2

CTLLOCATOR        ?=TRUE
LOCATORNAME	  ?=CTL_Locate

###########################################################
## SETTING DEFAULTS FOR COMPILE FLAGS #####################
###########################################################
ifneq "$(strip $(NOAUTOINCLUDE))" "TRUE"
AUTOINCLUDE  :=$(shell for dir in $(wildcard $(COMPDIR)component/*); do echo -I$${dir}/include -I$${dir}/include/ci; done)
AUTOINCLUDE  :=$(AUTOINCLUDE) $(shell for dir in $(wildcard $(COMPDIR)library/*); do echo -I$${dir}/include -I$${dir}/include/ci; done)
AUTOINCLUDE  :=$(AUTOINCLUDE) -I$(COMPDIR)include -I$(COMPDIR)include/ci
AUTOLIBS     :=-L$(BIN) -L$(OBJDIR) 

ifeq "$(call IS_DIR,$(ABS_COMPDIR)lib)" "TRUE"
AUTOLIBS     +=-L$(COMPDIR)lib
endif
endif
NOAUTOINCLUDE:=#UNDEFINE

INCFLAGS     :=$(INCFLAGS) $(AUTOINCLUDE) $(CTL_INCFLAGS)
LDLIBS       :=$(AUTOLIBS) $(CTL_LDLIBS) $(LDLOCALLIBS) $(LDLIBS) 

##########################################################
### INFO DISPLAY #########################################
##########################################################
ifndef SILENT
  ifeq "$($(COMPDIR)ISINCLUDED)" "TRUE"
    $(info INCLUDED COMPONENT $(COMPONENTNAME))
    $(info **Build Configuration: $(COMPONENTNAME))
  else
    $(info BUILDING $(COMPONENTNAME))
    $(info **Build Configuration: $(COMPONENTNAME))
  endif
 
  ###########################################################
  ####### PRINT CONFIG ######################################
  ###########################################################
  define printifdef
    ifneq "$$(word 1,$$($(1)))" ""
      ifneq "$$(origin $(1))" "default"
        ifneq "$$(origin $(1))" "undefined"
          $$(info **$(1)($$(origin $(1)))="$(strip $($(1)))")
        endif
      endif
    endif
  endef
  PRINTIFNOTDEFAULT:=LDLIBS CPPFLAGS FFLAGS INCFLAGS CXX FC CC CTL_DIR PC

  $(foreach VAR,$(PRINTIFNOTDEFAULT),$(eval $(call printifdef,$(VAR))))
  $(info --------------------------------------------------------------------------------)
endif # SILENT

###########################################################
####### LOCALISE BUILD VARIABLE ###########################
###########################################################

MOVELOCALISEDVARIABLES:=LDLIBS LDCOMPONENTLIBS INCFLAGS CCFLAGS CPPFLAGS CXXFLAGS CFLAGS FFLAGS PFLAGS COMPONENTNAME VERSION LOCALLIBS LOCALOBJECT
$(foreach VAR,$(MOVELOCALISEDVARIABLES),$(eval $(call append_move_local,$(VAR))))
COPYLOCALISEDVARIABLES:=CXX CC FC PC DEP BIN SRC TEST OBJDIR INCDIR AUTOINCLUDE AUTOLIBS COMPDIR ABS_COMPDIR
$(foreach VAR,$(COPYLOCALISEDVARIABLES),$(eval $(call append_copy_local,$(VAR))))

#$(eval $(call check_set,MOVELOCALISEDVARIABLES))
#$(foreach VAR,$(MOVELOCALISEDVARIABLES),$(eval $(call check_unset,$(VAR))))

#define inner_loop_57612576
#  $(foreach VAR,$(MOVELOCALISEDVARIABLES) $(COPYLOCALISEDVARIABLES), $(eval $(call link_substruct,$(1),$(VAR))))
#endef
#$(foreach DIR,$($(call localised,SOURCEDIR)), $(eval $(call inner_loop_57612576,$(DIR))))



